      PROGRAM TOOL_MAIN
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **           TOOL            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     PROGRAM :
C*          TOOL
C*
C*     AUTHOR :
C*          Arthur E. Ragosta
C*                 &
C*          Laura E. Jurgeleit
C*          RAGOSTA@MERLIN.ARC.NASA.GOV
C*          MS 219-1
C*          NASA Ames Research Center
C*          Moffett Field, Ca.  94035
C*          (415) 604-5578
C*
C*     PURPOSE :
C*
C*     QUALIFIERS :
C*
C*     PARAMETERS :
C*
C*     SUBPROGRAM REFERENCES :
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     CHANGE HISTORY :
C*
C***********************************************************************
C*
      CHARACTER *80 P(10), Q(10), FNAME
      CHARACTER *127 FILES, OUTFILES, ONEFILE, DEFILE, EXFILE, OUTFILE
C
      LOGICAL MATCHD, AMBIG, LIST, OUTWILD, DID_SOME
C
C --- THE QUALIFIER LIST MUST BE ALPHABETICAL !!!!
C
      PARAMETER (NQUALS=2)
      CHARACTER *20 QUALS(NQUALS)
      DATA QUALS/ 'EXCLUDE',  'OUTPUT' /
      DATA DID_SOME /.FALSE./
C
C --- GET USER PARAMETERS AND QUALIFIERS
C
      CALL GETFOR (NQ, Q, NP, P)
C
C --- IF THE USER DIDN'T ENTER A FILE LIST ON THE COMMAND LINE, ASK
C ---  FOR IT
C
      IF (NP .EQ. 0) THEN
         WRITE(6,900)
         READ(5,910) P(1)
      ENDIF
C
C --- MAYBE HE CHANGED HIS MIND?
C
      IF (P(1) .EQ. ' ') THEN
         WRITE(6,920)
         CALL EXIT
      ENDIF
C
      CALL LEFT(P(1))
      FILES = P(1)
      EXFILE = ' '
      DEFILE = ' '
C
C --- GET OUTPUT FILE LIST, IF ANY
C
      IF (NP .GT. 1) THEN
         OUTFILES = P(2)
         IF ((INDEX(OUTFILES,',') .NE. 0) .AND.
     $       (INDEX(OUTFILES,'*') .NE. 0)) THEN
            WRITE(6,970) OUTFILES
            CALL EXIT
         ENDIF
C
C ------ IF THE INPUT LIST HAS MORE THAN ONE FILE, SO MUST THE
C ------  OUTPUT FILE LIST
C
         IF ((INDEX(FILES,',') .NE. 0) .OR. (INDEX(FILES,'*') .NE. 0)) 
     $      THEN
            LIST = .TRUE.
            IF (INDEX(FILES,'*') .NE. 0) THEN
               IF (INDEX(OUTFILES,'*') .EQ. 0) THEN
                  WRITE(6,960) FILES(1:LENGTH(FILES))
                  CALL EXIT
               ENDIF
            ELSE
               IF ((INDEX(OUTFILES,'*') .EQ. 0) .AND.
     $             (INDEX(OUTFILES,',') .EQ. 0)) THEN
                  WRITE(6,960) FILES(1:LENGTH(FILES))
                  CALL EXIT
               ENDIF
            ENDIF
         ELSE
            LIST = .FALSE.
         ENDIF
      ELSE
         OUTFILES = ' '
         LIST = .FALSE.
      ENDIF
C
      I = INDEX(OUTFILES,'*')
      IF (I .NE. 0) THEN
         OUTFILES(I:I) = ' '
         CALL BLANKS (OUTFILES)
         OUTWILD = .TRUE.
      ELSE
         OUTWILD = .FALSE.
      ENDIF
      IPTR = 1
C
C --- OK, WE HAVE THE FILE LISTS NOW
C
C --- LET'S CHECK OUT THE QUALIFIERS
C
      DO 10 I = 1, NQ
         L = INDEX(Q(I),'=') - 1
         IF (L .LE. 0) L = LENGTH(Q(I))
         CALL SEARCH (QUALS, NQUALS, Q(I)(1:L), K,
     $            MATCHD, AMBIG)
C
         IF (AMBIG) THEN
            WRITE(6,930) Q(I)
            CALL EXIT
         ENDIF
C
         IF (MATCHD) THEN
            IF (QUALS(K) .EQ. 'OUTPUT') THEN
               FNAME = Q(I)(L+2:)
               IF (FNAME .NE. ' ') THEN
                  CLOSE (UNIT=6)
                  OPEN (UNIT=6, FILE=FNAME, STATUS='NEW', ERR=1000)
               ENDIF
            ELSE IF (QUALS(K) .EQ. 'EXCLUDE') THEN
               EXFILE = Q(I)(L+2:)
            ENDIF
         ELSE
            WRITE (6,950) Q(I)
         ENDIF
10    CONTINUE
C
C$$
C$$  TOOL INITIALIZATION CODE HERE
C$$
C
C
C --- OK, NOW LET THE TOOL DO ITS STUFF
C
C
C --- EXTRACT FILE NAMES ONE AT A TIME
C
100   CALL GETFILEX ( FILES, ONEFILE, DEFILE, EXFILE )
C
C --- GENERATE NAME OF OUTPUT FILE FOR THIS INPUT FILE
C
      IF (ONEFILE .NE. ' ') THEN
         DID_SOME = .TRUE.
C
C ------ IF NO OUTLIST SPECIFIED, CREATE NEW VERSION OF INPUT FILE
C
         IF (OUTFILES .EQ. ' ') THEN
            I = INDEX(ONEFILE,';')
            OUTFILE = ONEFILE(1:I)
C
C ------ IF THE INPUT(OUTPUT) FILE SPEC IS A LIST, FIGURE OUT NEXT 
C ------  FILE NAME FROM THE OUTLIST
C
         ELSE IF (LIST) THEN
            IF (OUTWILD) THEN
               CALL PARSE ( OUTFILES, ONEFILE, 'FULL', OUTFILE )
            ELSE
               I = INDEX (OUTFILES(IPTR:),',')
               IF (I .EQ. 0) THEN
                  WRITE(6,980)
                  CALL EXIT
               ENDIF
               I = I + IPTR
               OUTFILE = OUTFILES(IPTR:I-1)
               IPTR = I + 1
            ENDIF
C
C --- SINGLE OUTPUT FILE SPECIFIED
C
         ELSE
            OUTFILE = OUTFILES
         ENDIF
C
         CALL TOOL ( ONEFILE, OUTFILE )
         GO TO 100
      ENDIF
C$$
C$$  TOOL FINALIZATION CODE HERE
C$$
      IF (.NOT. DID_SOME) WRITE (6,925)
      CALL EXIT
C
1000  WRITE(6,940) Q(I)
      CALL EXIT
C
900   FORMAT(' File ? ',$)
910   FORMAT(A20)
920   FORMAT(' No file specified.')
925   FORMAT(' No files processed.')
930   FORMAT(' Ambiguous qualifier ',A)
940   FORMAT(' Unable to open output file ',A)
950   FORMAT(' Unknown qualifier ignored, 'A)
960   FORMAT(
     $ ' ERROR - incompatible input and output file specifications :'/,
     $ X,A,5X,A,/
     $ ' When the input parameter is specified as a list, ',/,
     $ ' The output spec must contain a wildcard (e.g., *.TXT).')
970   FORMAT(
     $ ' ERROR - Illegal parameter ',A,/,
     $ ' A list with wildcards makes no sense on output.')
980   FORMAT(
     $ ' ERROR - There are more files in the input list than in ',
     $ 'the output list.')
      END
