      SUBROUTINE READC
C*
C*  READC IS THE ENTRY POINT FOR READING DATA INTO COMMON.
C*   INPUT IS READ FROM UNIT 'NIN'.
C*
      PARAMETER (MAXBUF=133,MAXTOK=132)
**  -  NMCOM0/1 
      COMMON / READC0 / CH, BUFF, TOKEN
      COMMON / READC1 / IBPTR, LBUFF, EOF, NOQUO
      CHARACTER *(MAXBUF) BUFF
      CHARACTER *(MAXTOK) TOKEN
      CHARACTER *1 CH
      LOGICAL EOF, NOQUO
C
C --- INITIALIZE POINTERS AND STUFF FOR GETC0... FORCE A READ FIRST TIME
C
      EOF   = .FALSE.
      IBPTR = 1
      LBUFF = 0
      NOQUO = .TRUE.
C     
      CALL GETC0
C
C --- GET THE VARIABLE NAME OR COMMAND
C
30    NAMERR = .FALSE.
      CALL GETOK0
      IF (.NOT. NAMERR) THEN
         CALL CAPS (TOKEN)
C
C --- IF NAME GOTTEN OK, ITS EITHER A COMMAND OR AN ASSIGNMENT
C
         IF (TOKEN(1:1) .EQ. SIGNAL) THEN
C
C ------- CHECK FOR 'END' COMMAND
C
            IF (TOKEN(2:2) .EQ. 'E') THEN
               RETURN
C
C ------- AND 'INCLUDE' COMMAND
C
            ELSE IF (TOKEN(2:2) .EQ. 'I') THEN
10             CALL GETC0
               IF (CH .EQ. ' ') GO TO 10
               I = 1
20             TOKEN(I:I) = CH      ! Get file name
               I = I + 1
               CALL GETC0
               IF ((CH .NE. ' ') .AND. (CH .NE. ',')) GO TO 20
               NIN = NIN + 2
               OPEN (UNIT=NIN,NAME=TOKEN(1:I-1),READONLY,STATUS='OLD')
               IBPTR = LBUFF+1                 ! Force a read in GETC0
C
C ------- GOOF BALL... TREAT IT LIKE AN END COMMAND
C
            ELSE
               CALL ERROR0('Illegal command: '//TOKEN )
               RETURN
            ENDIF
         ELSE
            CALL DOTOK0
         ENDIF
      ENDIF
C
C --- IF ERROR IN GETOK0 OR DOTOK0, SKIP TO NEXT ASSIGNMENT OR COMMAND
C
      IF (NAMERR) THEN
40       IF ((CH .NE. ',') .AND. (CH .NE. SIGNAL)) THEN
            CALL GETC0
            GO TO 40
         ENDIF         
      ENDIF 
C
      IF (CH .EQ. ',') CALL GETC0
      GO TO 30
      END
C
C---END READC
C
      SUBROUTINE GETOK0
C
C *** GET THE NEXT TOKEN (VARIABLE NAME OR COMMAND) FROM THE INPUT FILE
C ***  A TOKEN IS THE ENTIRE FIELD UP TO THE '='.
C
      PARAMETER (MAXBUF=133,MAXTOK=132)
**  -  NMCOM0/1
      COMMON / READC0 / CH, BUFF, TOKEN
      COMMON / READC1 / IBPTR, LBUFF, EOF, NOQUO
      CHARACTER *(MAXBUF) BUFF
      CHARACTER *(MAXTOK) TOKEN
      CHARACTER *1 CH
      LOGICAL EOF, NOQUO
C
C --- INIT, SKIP LEADING SPACES
C
      TOKEN = ' '
      ITOKE = 1
10    IF (CH .EQ. ' ') THEN
         CALL GETC0
         GO TO 10
      ENDIF
C
C --- CHECK TO SEE IF IT IS A SIGNAL CHARACTER
C ---  IF SO, TOKEN ENDS AT NEXT SPACE
C
      IF (CH .EQ. SIGNAL) THEN
30       IF (CH .NE. ' ') THEN
            TOKEN(ITOKE:ITOKE) = CH
            ITOKE = ITOKE + 1
            CALL GETC0
            GO TO 30
         ENDIF
      ELSE
C
C --- ASSIGNMENT TOKEN, TOKEN ENDS WITH EQUAL SIGN
C
40       TOKEN(ITOKE:ITOKE) = CH
         ITOKE = ITOKE + 1
45       CALL GETC0
         IF (CH .EQ. ' ') GO TO 45
         IF (CH .NE. '=') GO TO 40
         CALL GETC0
      ENDIF
      RETURN
      END
C
C---END GETOK0
C
      SUBROUTINE DOTOK0
C
C *** THE TOKEN IS THE NAME (AND INDICES) OF A VARIABLE.
C ***  THE VALUE(S) HAVEN'T BEEN GOTTEN YET.
C
      PARAMETER (MAXBUF=133,MAXTOK=132)
**  -  NMCOM0/1
      COMMON / READC0 / CH, BUFF, TOKEN
      COMMON / READC1 / IBPTR, LBUFF, EOF, NOQUO
      CHARACTER *(MAXBUF) BUFF
      CHARACTER *(MAXTOK) TOKEN, NAME
      CHARACTER *10 WORK
      CHARACTER *1 CH
      LOGICAL EOF, NOQUO, IN_ARR
C
C --- OK, TIME FOR FUN.  FIRST LET'S PARSE THE TOKEN FOR THE NAME AND 
C ---  INDICES (IF ANY).
C
      K = INDEX(TOKEN,'(')
      IF (K .EQ. 0) THEN
         NAME = TOKEN
         ISUB = 1
         IN_ARR = .FALSE.
      ELSE
         NAME = TOKEN(1:K-1)
         L = INDEX(TOKEN,')')
         WORK = TOKEN(K+1:L-1)
         CALL RIGHT (WORK)
         READ(WORK, 900) ISUB
         IN_ARR = .TRUE.
      ENDIF
C
C --- NAME NOW CONTAINS THE VARIABLE NAME.  ISUB = INDEX (1 FOR SCALAR).
C
C --- BINARY SEARCH FOR VARIABLE NAME
C
      K = 1
      L = NUMALL
30    M = ( L + K ) / 2
      IF (NAME .LE. VNAMES(M)) L = M - 1
      IF (NAME .GE. VNAMES(M)) K = M + 1
      IF (K .LE. L) GO TO 30
      IF (K-1 .LE. L) THEN
         CALL ERROR0('Variable '//NAME(1:LENGTH(NAME))//
     $      ' not in common.')
         RETURN
      ENDIF
C
C --- "M" IS NOW THE INDEX IN THE BIG ARRAYS FOR THIS VARIABLE
C
C --- PUT THE VALUE IN THE VARIABLE
C
50    IF (CH .EQ. ' ') THEN
         CALL GETC0
         GO TO 50
      ENDIF
C
      IF (VTYPES(M) .EQ. 'C') THEN
         CALL ASGNC0 ( M, ISUB )
      ELSE
         IF (VSIZES(M) .GT. 1)  THEN
            IN_ARR = .TRUE.
         ELSE
            IF (IN_ARR) THEN
               CALL ERROR0('Variable ' // NAME(1:LENGTH(NAME)) //
     $                     ' is not an array.')
               RETURN
            ENDIF
         ENDIF
         CALL ASIGN0 ( M, ISUB, IN_ARR )
      ENDIF
      RETURN
900   FORMAT(I10)
      END
C
C---END DOTOK0
C
      SUBROUTINE GETC0
C
C *** GET THE NEXT CHARACTER FROM THE COMMON FILE, IGNORING LINE BREAKS
C ***  AND CHECKING FOR BLANK LINES AND COMMENTS
C
      PARAMETER (MAXBUF=133,MAXTOK=132)
**  -  NMCOM0/1
      COMMON / READC0 / CH, BUFF, TOKEN
      COMMON / READC1 / IBPTR, LBUFF, EOF, NOQUO
      CHARACTER *(MAXBUF) BUFF
      CHARACTER *(MAXTOK) TOKEN
      CHARACTER *1 CH
      LOGICAL EOF, NOQUO
C
5     IF (IBPTR .GT. LBUFF) THEN
10       READ(NIN,900,END=1000) BUFF
         ICARD = ICARD + 1
         LBUFF = LENGTH(BUFF)+1
         IF (ECHO) WRITE (NOUT,910) BUFF(1:LBUFF)
         IF (LBUFF .EQ. 1) GO TO 10
         IBPTR = 1
      ENDIF
      CH    = BUFF(IBPTR:IBPTR)
C
C --- SKIP COMMENTS
C
      IF ((CH .EQ. '!') .AND. (NOQUO)) THEN
         IBPTR = LBUFF+1
         GO TO 5
      ENDIF
      IBPTR = IBPTR + 1
      RETURN
C
C --- ATTEMPT TO GET A CHARACTER AFTER THE END-OF-FILE WAS REACHED
C
*7  -  Nameio checks for end-of-file on initial file here
         IF ( EOF ) THEN
*6  -  Nameio puts call to EXIT handler here
C
C --- ONE END-OF-FILE IS OK IN CASE '&END' IS THE LAST ENTRY IN THE FILE
C
         ELSE
            CH  = ' '
            EOF = .TRUE.
         ENDIF
      ELSE
         CLOSE(NIN)
         NIN = NIN - 2
         CH = ' '
      ENDIF
      RETURN
900   FORMAT(A)
910   FORMAT(' ',A)
      END
C
C---END GETC0
C
      SUBROUTINE ERROR0 ( TEXT )
C
C *** PRINT ERROR MESSAGE
C
**  -  NMCOM0/1
      CHARACTER *(*) TEXT
C
      WRITE (NOUT,900) ICARD, TEXT
      NAMERR = .TRUE.
      RETURN
900   FORMAT(' *** NAMEIO Error at line number ',I5,'.'/
     $       ' *** ',A)
      END
C
C---END ERROR0
C
      SUBROUTINE ASIGN0 ( J, ISUB, IN_ARR )
C
C *** ASSIGN A VALUE OR VALUES TO THE 'J'TH VARIABLE
C ***  ISUB = INDEX IN ARRAY (ALWAYS 1 FOR SCALAR)
C ***  IN_ARR = .TRUE. IF THIS IS AN ARRAY
C
      PARAMETER (MAXBUF=133,MAXTOK=132)
**  -  NMCOM0/1
      COMMON / READC0 / CH, BUFF, TOKEN
      COMMON / READC1 / IBPTR, LBUFF, EOF, NOQUO
*1 --- THE USER'S COMMON BLOCKS ARE PLACED HERE BY THE NAMEIO PROGRAM
      CHARACTER *(MAXBUF) BUFF
      CHARACTER *(MAXTOK) TOKEN
      CHARACTER *20 VAL
      CHARACTER *20 CREP
      CHARACTER *1 CH
      LOGICAL EOF, NOQUO, LV, IN_ARR
      EQUIVALENCE (RV,IV,LV)
C
      IF (IN_ARR) THEN
         IF (CH .EQ. '(') THEN         ! LIST OF VALUES
            CALL GETC0
         ELSE                          ! SINGLE VALUE
            IN_ARR = .FALSE.
         ENDIF
      ENDIF
C
410   IF (CH .EQ. ' ') THEN
         CALL GETC0
         GO TO 410
      ENDIF
C
C --- EXTRACT THE VALUE
C
      VAL = ' '
      IVAL = 1
430   IF ((CH .NE. ',') .AND. (CH .NE. ')') .AND.
     $    (CH .NE. SIGNAL)) THEN
         VAL(IVAL:IVAL) = CH
         IVAL = IVAL + 1
         CALL GETC0
         GO TO 430
      ENDIF
      CALL BLANKS (VAL)
C
C --- STRING IS IN "VAL", CHECK FOR REPETITION COUNT
C
      IREP = 1
      I = INDEX(VAL,'*')
      IF (I .NE. 0) THEN
         IF (IN_ARR) THEN
            CREP = VAL(1:I-1)
            CALL RIGHT (CREP)
            READ (CREP, 910) IREP
         ENDIF
         VAL = VAL(I+1:)
      ENDIF
C
      IF ((ISUB+IREP-1) .GT. VSIZES(J)) THEN
         IREP=MAX(0,(VSIZES(J)-ISUB+1))
         CALL ERROR0 ('Assignment beyond dimensioned limits for ' //
     $                  VNAMES(J))
         NAMERR = .FALSE.       ! To prevent READC from skipping
      ENDIF
C
C --- OK, FINALLY WE ASSIGN A SINGLE VALUE
C
C --- CONVERT TO PROPER TYPE
C
      CALL RIGHT(VAL)
      IF (VTYPES(J) .EQ. 'R') THEN
         READ(VAL,900,ERR=2000) RV
      ELSE IF (VTYPES(J) .EQ. 'I') THEN
         READ(VAL,910,ERR=2000) IV
      ELSE
         READ(VAL,920,ERR=2000) LV
      ENDIF
C
C --- NOW STICK ONE OR MORE COPIES INTO STORAGE
C
      DO 1500 I = 1,IREP
*2 --- THE ASSIGNMENT CODE IS PLACED HERE BY THE NAMEIO PROGRAM
1000     ISUB = ISUB + 1
1500  CONTINUE
C
      IF (IN_ARR) THEN
         IF (CH .EQ. ',') THEN
            CALL GETC0
            GO TO 410
         ELSE IF (CH .EQ. ')') THEN
            CALL GETC0
         ENDIF
      ENDIF
C
      RETURN
C
2000  CALL ERROR0 ('Illegal value for variable '//VNAMES(J))
      RETURN
900   FORMAT(G20.0)
910   FORMAT(I20)
920   FORMAT(L20)
      END
C
C---END ASIGN0
C
      SUBROUTINE ASGNC0 ( J, ISUB )
C
C *** ASSIGN THE VALUE 'VALUE' TO THE 'J'TH VARIABLE (CHARACTER)
C
      PARAMETER (MAXBUF=133,MAXTOK=132)
**  -  NMCOM0/1
      COMMON / READC0 / CH, BUFF, TOKEN
      COMMON / READC1 / IBPTR, LBUFF, EOF, NOQUO
*1 --- THE USER'S COMMON BLOCKS ARE PLACED HERE BY THE NAMEIO PROGRAM
      CHARACTER *(MAXBUF) BUFF
      CHARACTER *(MAXTOK) TOKEN 
      CHARACTER *255 SV
      CHARACTER *1 CH, QUOTE
      LOGICAL EOF, NOQUO
C
      IF ((CH .EQ. '''') .OR. (CH .EQ. '"')) THEN
         QUOTE = CH
         CALL GETC0
         NOQUO = .FALSE.
      ELSE
         QUOTE = ' '
      ENDIF
C
C --- OK... WE'RE IN THE STRING.  SPACES AND SUCH COUNT.
C
      SV  = ' '
      ISV = 1
C
420   SV(ISV:ISV) = CH
C
      IF (QUOTE .EQ. ' ') THEN
         IF ((CH .EQ. ',') .OR. (CH .EQ. SIGNAL)) GO TO 500
      ELSE
         IF (CH .EQ. QUOTE) THEN
            CALL GETC0
            IF (CH .NE. QUOTE) THEN          ! MAY BE EMBEDDED QUOTE
               NOQUO = .TRUE.
               GO TO 500
            ENDIF
         ENDIF
      ENDIF
C
      CALL GETC0
      ISV = ISV + 1 
      GO TO 420
C
500   SV(ISV:ISV) = ' '
*5 --- THE ASSIGNMENT CODE IS PLACED HERE BY THE NAMEIO PROGRAM
1000  RETURN
      END
C
C---END ASGNC0
C
      SUBROUTINE WRITEV(NAME)
C*
C*  ENTRY POINT FOR WRITING A VARIABLE...
C*  THE VARIABLE NAME IS IN 'NAME'.
C*
      PARAMETER (MAXTOK=132)
**  -  NMCOM0/1
*1  - Nameio puts user's COMMONs here
      CHARACTER *(*) NAME
      CHARACTER *(MAXTOK) CV
      CHARACTER *132 TEMP
      CHARACTER *5 WORK
      CHARACTER *10 LABEL
      CHARACTER *1 COMMA
      LOGICAL LV
      EQUIVALENCE (RV,IV,LV)
C
      NAMERR = .FALSE.
C
C --- CHECK TO SEE IF AN ARRAY ELEMENT WAS REQUESTED
C
      IN = INDEX(NAME,'(')
      WORK = ' '
      IF (IN .NE. 0) THEN
         IM = INDEX(NAME,')')
         IF (IM .LE. IN+1) THEN
            CALL ERROR0('Illegal subscript.')
            RETURN
         ENDIF
         WORK = NAME(IN+1:IM-1)
         NAME = NAME(1:IN-1)
      ENDIF
C
C --- BINARY SEARCH FOR VARIABLE NAME
C
      K = 1
      L = NUMALL
100   M = ( L + K ) / 2
      IF (NAME .LE. VNAMES(M)) L = M - 1
      IF (NAME .GE. VNAMES(M)) K = M + 1
      IF (K .LE. L) GO TO 100
      IF (K-1 .LE. L) THEN
         CALL ERROR0('Variable '//NAME(1:LENGTH(NAME))//
     $      ' not in common.')
         RETURN
      ENDIF
C
C --- FOUND THE NAME
C
      IF (WORK .NE. ' ') THEN
C
C --- SUBSCRIPT
C
         IF (VSIZES(M) .EQ. 1) THEN
            CALL ERROR0('Variable '//NAME(1:LENGTH(NAME))//
     $                  ' is not an array.')
            RETURN
         ENDIF
         CALL RIGHT(WORK)
         READ(WORK,900) K
         IF ( (K .LT. 1 ) .OR. (K .GT. VSIZES(M)) ) THEN
            CALL ERROR0('Subscript for variable ' //
     $          NAME(1:LENGTH(NAME)) // ' out of bounds.')
            RETURN
         ENDIF
         NUM = 1
         COMMA = ' '
      ELSE IF (VSIZES(M) .EQ. 1) THEN
C
C --- NON-ARRAY VARIABLE
C
         K = 1
         NUM = 1
         COMMA = ' '
      ELSE
C
C --- PRINT ENTIRE ARRAY OR CHARACTER VARIABLE
C
         IF (VTYPES(M) .EQ. 'C') THEN
            NUM = 1
         ELSE
            NUM = VSIZES(M)
            COMMA = ','
         ENDIF
         K = 1
      ENDIF
      IF (DOINGC) COMMA = ','
C
      IF ((VTYPES(M) .NE. 'C') .AND. (VSIZES(M) .GT. 1)) THEN
         LABEL = NAME(1:LENGTH(NAME)) // ' = ('
      ELSE
         LABEL = NAME(1:LENGTH(NAME)) // ' = '
      ENDIF
C
      IF (.NOT. DOINGC) IBUFF = 1
      DO 500 KK = 1,NUM
         IF ((KK .EQ. NUM) .AND. (NUM .NE. 1)) COMMA = ')'
*3 - Computed GOTO for each COMMON placed here
400      IF (VTYPES(M) .EQ. 'R') THEN
            WRITE(TEMP,910) LABEL, RV, COMMA
         ELSE IF (VTYPES(M) .EQ. 'I') THEN
            WRITE(TEMP,920) LABEL, IV, COMMA
         ELSE IF (VTYPES(M) .EQ. 'L') THEN
            WRITE(TEMP,930) LABEL, LV, COMMA
         ELSE
            ICV = LENX(CV)
            IF (ICV .EQ. 0) THEN                ! Get rid of NUL
               ICV = 1
               CV(1:1) = ' '
            ENDIF
            I = 1                               ! Replace " with ""
450         IF (CV(I:I) .EQ. '"') THEN
               I = I + 1
               CV(I+1:) = CV(I:)
               CV(I:I) = '"'
               IF (ICV .LT. LEN(CV)) ICV = ICV + 1
            ENDIF
            I = I + 1
            IF (I .LE. ICV) GO TO 450
            WRITE(TEMP,940) LABEL, CV(1:ICV), COMMA
         ENDIF
         CALL COMPRESS (TEMP)
         CALL BUFF0 ( TEMP )
         K = K + 1
         IF (KK .EQ. 1) LABEL = ' '
500   CONTINUE
      IF (NUM .NE. 1) CALL BUFF0 (',')
      IF ((.NOT. DOINGC) .AND. (IBUFF .GT. 1))
     $     WRITE(NOUT,950) BUFFER(1:IBUFF-1)
      RETURN
900   FORMAT(I5)
910   FORMAT(' ',A,E12.5,A1)
920   FORMAT(' ',A,I11,A1)
930   FORMAT(' ',A,L3,A1)
940   FORMAT(' ',A,'"',A,'"',A1)
950   FORMAT(' ',A)
      END
C
C---END WRITEV
C
      SUBROUTINE WRITEC (CNAME)
      CHARACTER *(*) CNAME
      CHARACTER *8 TNAME
**  -  NMCOM0/1
*4 - COMMON block names
      LOGICAL ALL
C
      NAMERR = .FALSE.
      IF (CNAME .EQ. ' ') THEN
         ALL = .TRUE.
         GO TO 20
      ELSE
         ALL = .FALSE.
      ENDIF
      TNAME = CNAME
      CALL CAPS ( TNAME )
      DO 10 I = 1, NUMCOM
         IF (TNAME .EQ. CNAMES(I)) GO TO 20 
10    CONTINUE
      RETURN
C
20    DOINGC = .TRUE.
      IBUFF = 1
      DO 30 J = 1, NUMALL
         IF ((VCOM(J) .EQ. I) .OR. ALL) CALL WRITEV(VNAMES(J))
30    CONTINUE
      IF (IBUFF .GT. 1) WRITE(NOUT,910) BUFFER(1:IBUFF-1)
      DOINGC = .FALSE.
      RETURN
910   FORMAT(' ',A)
      END     
C
C---END WRITEC
C
      SUBROUTINE BUFF0 ( T )
      CHARACTER *(*) T
**  -  NMCOM0/1
C
      LT = LENGTH(T) + 3                ! Three spaces
      IF ((IBUFF+LT) .GT. 80) THEN
         WRITE(NOUT,900) BUFFER(1:IBUFF)
         IBUFF = 1
      ENDIF
C
      BUFFER(IBUFF:) = T
      IBUFF = IBUFF + LT
      RETURN
900   FORMAT(' ',A)
      END
C
C---END BUFF0
C
