      PROGRAM SMALL_MAIN
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          SMALL            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     AUTHOR :
C*          Arthur E. Ragosta
C*          RAGOSTA@MERLIN.ARC.NASA.GOV
C*          MS 219-1
C*          NASA Ames Research Center
C*          Moffett Field, Ca.  94035
C*          (415) 604-5578
C*
C*     PURPOSE :
C*          TO MAKE MULTIPLE SMALL FILES OUT OF ONE BIG ONE
C*
C*     QUALIFIERS :
C*          /MAXIMUM - REQUIRED!  MAXIMUM SIZE OF OUTPUT FILES IN 
C*                      KBYTES.  (E.G. /MAX=20)
C*          /EXCLUDE - LIST OF FILES TO EXCLUDE FROM PROCESSING
C*
C*     PARAMETERS :
C*          FILELIST - LIST OF FILESPECS TO PROCESS
C*
C*     SUBPROGRAM REFERENCES :
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     CHANGE HISTORY :
C*
C***********************************************************************
C*
      CHARACTER *80 P(4), Q(4)
      CHARACTER *127 FILES, ONEFILE, DEFILE, EXFILE, FNAME
      CHARACTER *8 TEMP
C
      LOGICAL MATCHD, AMBIG, MAXOK
C
C --- THE QUALIFIER LIST MUST BE ALPHABETICAL !!!!
C
      PARAMETER (NQUALS=3)
      CHARACTER *20 QUALS(NQUALS)
      DATA QUALS/ 'EXCLUDE',  'MAXIMUM',  'OUTPUT' /
C
C --- GET USER PARAMETERS AND QUALIFIERS
C
      MAXOK = .FALSE.
      CALL GETFOR (NQ, Q, NP, P)
C
C --- IF THE USER DIDN'T ENTER A FILE LIST ON THE COMMAND LINE, ASK
C ---  FOR IT
C
      IF (NP .EQ. 0) THEN
         WRITE(6,900)
         READ(5,910) P(1)
      ENDIF
C
C --- MAYBE HE CHANGED HIS MIND?
C
      IF (P(1) .EQ. ' ') THEN
         WRITE(6,920)
         CALL EXIT
      ENDIF
C
      CALL LEFT(P(1))
      FILES = P(1)
      EXFILE = ' '
      DEFILE = ' '
C
C --- OK, WE HAVE THE FILE LISTS NOW
C
C --- LET'S CHECK OUT THE QUALIFIERS
C
      DO 10 I = 1, NQ
         L = INDEX(Q(I),'=') - 1
         IF (L .LE. 0) L = LENGTH(Q(I))
         CALL SEARCH (QUALS, NQUALS, Q(I)(1:L), K,
     $            MATCHD, AMBIG)
C
         IF (AMBIG) THEN
            WRITE(6,930) Q(I)
            CALL EXIT
         ENDIF
C
         IF (MATCHD) THEN
            IF (QUALS(K) .EQ. 'OUTPUT') THEN
               FNAME = Q(I)(L+2:)
               IF (FNAME .NE. ' ') THEN
                  CLOSE (UNIT=6)
                  OPEN (UNIT=6, FILE=FNAME, STATUS='NEW', ERR=1000)
               ENDIF
            ELSE IF (QUALS(K) .EQ. 'EXCLUDE') THEN
               EXFILE = Q(I)(L+2:)
            ELSE IF (QUALS(K) .EQ. 'MAXIMUM') THEN
               IE = INDEX(Q(I),'=')
               IF (IE .EQ. 0) GO TO 15
               TEMP = Q(I)(IE+1:)
               CALL RIGHT(TEMP)
               READ(TEMP,990,ERR=15) MAX
               MAX = 1000 * MAX
               MAXOK = .TRUE.
            ENDIF
         ELSE
            WRITE (6,950) Q(I)
         ENDIF
10    CONTINUE
C
15    IF ((NQ .LT. 1) .OR. (.NOT. MAXOK)) THEN
         WRITE(6,*) '/MAXIMUM must be specified.'
         CALL EXIT
      ENDIF
C
C
C --- OK, NOW LET THE TOOL DO ITS STUFF
C
C
C --- EXTRACT FILE NAMES ONE AT A TIME
C
100   CALL GETFILEX ( FILES, ONEFILE, DEFILE, EXFILE )
C
      IF (ONEFILE .NE. ' ') THEN
         WRITE(6,960) ONEFILE(1:LENGTH(ONEFILE))
         CALL SMALL ( ONEFILE, MAX )
         GO TO 100
      ENDIF
      CALL EXIT
C
1000  WRITE(6,940) Q(I)
      CALL EXIT
C
900   FORMAT(' File ? ',$)
910   FORMAT(A20)
920   FORMAT(' No file specified.')
930   FORMAT(' Ambiguous qualifier ',A)
940   FORMAT(' Unable to open output file ',A)
950   FORMAT(' Unknown qualifier ignored, 'A)
960   FORMAT(//,' Breaking up file ',A)
990   FORMAT(I8)
      END
C
C---END SMALL_MAIN
C
      SUBROUTINE SMALL (INFILE, MAX)
      CHARACTER *(*) INFILE
      CHARACTER *132 LINE
      CHARACTER *80 ONAME
      CHARACTER *8 TEMP
C
C
C --- INPUT FILE NAME
C
      OPEN (UNIT=1, FILE=INFILE, STATUS='OLD', ERR=1000)
C
C --- OUTPUT FILE NAME
C
      NFILE = 1
10    IF (NFILE .LE. 9) THEN
         WRITE(TEMP,910) NFILE
      ELSE
         WRITE(TEMP,920) NFILE
      ENDIF
      CALL PARSE ( TEMP, INFILE, 'FULL', ONAME )
      OPEN (UNIT=2, FILE=ONAME, STATUS='NEW', ERR=2000,
     $    CARRIAGECONTROL='LIST' )
      NFILE = NFILE + 1
C
C --- COPY FILE
C
      ISIZE = 0
20    READ(1,930,END=30) LL, LINE
      IF (LL .EQ. 0) THEN
         WRITE(2,950)
      ELSE
         WRITE(2,940) LINE(1:LL)
      ENDIF
      ISIZE = ISIZE + LL + 2
      IF (ISIZE .GE. MAX) THEN
         CLOSE(UNIT=2)
         WRITE(6,970) ONAME(1:LENGTH(ONAME))
         GO TO 10
      ENDIF
      GO TO 20
C
C --- IF THE FILE IS SMALLER THAN LIMIT, DON'T CREATE A NEW COPY
C
30    IF (NFILE .EQ. 2) THEN
         CLOSE(UNIT=2,STATUS='DELETE')
         WRITE(6,960)
      ELSE
         CLOSE(UNIT=2)
         WRITE(6,970) ONAME(1:LENGTH(ONAME))
      ENDIF
      RETURN
C
1000  WRITE(6,*) 'Can''t open input file ' // INFILE(1:LENGTH(INFILE))
      CALL EXIT
2000  WRITE(6,*) 'Can''t open output file ' // ONAME(1:LENGTH(ONAME))
      CALL EXIT
910   FORMAT('.PT',I1,';')
920   FORMAT('.PT',I2,';')
930   FORMAT(Q,A)
940   FORMAT(A)
950   FORMAT()
960   FORMAT(' Small enough.')
970   FORMAT(' Creating file ',A)
      END
C
C---END SMALL
C
