      PROGRAM CLEANUP
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          CLEANUP          **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          FORTRAN PROGRAM CLEANER-UPPER           
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          THIS PROGRAM READS FORTRAN 77 SOURCE CODE, AND, DEPENDING   
C*          ON OPTIONS CHOSEN, CREATES A NEW FILE OF FORTRAN CODE WHICH 
C*          HAS BEEN CLEANED UP AND STRUCTURED.                         
C*
C*     SUBPROGRAM REFERENCES :
C*          INITL, GETSTM, PROSUB, CHKLAB, WRITSUB, RESET
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     10-NOV-86 
C*
C*     CHANGE HISTORY :
C*          18-JUL-88    ADDED 'D_LINES' OPTION
C*          30-NOV-87    ADDED OPTION TO MOVE '!' COMMENTS
C*          10-NOV-86    INITIAL VERSION
C*
C***********************************************************************
C*
      CALL INITL
C
C --- LOOP UNTIL EOF
C --- PROGRAM ENDS IN GETCRD
C
10    CALL GETSTM       
C
C --- DO INITIAL PROCESSING
C
      CALL PROSUB
C
C --- CHECK THE LABELS
C
      CALL CHKLAB
C
C --- WRITE THE SUBPROGRAM
C
      CALL WRITSUB
C
C --- RESET ALL PARAMETERS
C
      CALL RESET
      GO TO 10
      END
C
C---END CLEANUP
C
      SUBROUTINE INITL 
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          INITL            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          INITIALIZE                              
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS219-1                                 
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          INITIALIZE PROGRAM WIDE DATA                                
C*
C*     COMMON BLOCKS :
C*          FILES, STATMT, STUB, OPTIONS
C*
C*     FILE REFERENCES :
C*          NAUTH - AUTHOR INFORMATION FILE, SET TO 90
C*          NOPT  - OPTIONS FILE, SET TO 91
C*          NWARN - WARNINGS AND ERRORS, SET TO 6
C*          NOUT  - CLEANED FILE, SET TO 92
C*          NTEMP - TEMPORARY FILE, SET TO 93
C*          NFORM - FILE FOR FORMAT STATEMENTS, SET TO 94
C*          NIN   - SOURCE FILE, SET TO 95
C*
C*     SUBPROGRAM REFERENCES :
C*          CAPS, GETOPT, GETCRD, ENDUP
C*
C*     TRANSPORTABILITY LIMITATIONS :
C*          CARRIAGECONTROL = 'LIST' IS NON-STANDARD IN OPEN STATEMENT
C*
C*     ERROR PROCESSING :
C*          TERMINATES JOB IF ERRORS ARE ENCOUNTERED OPENING FILES;
C*          FORMATS WILL NOT BE MOVED IF ERROR ENCOUNTERED OPENING
C*          TEMPORARY FORMAT FILE.
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     10-NOV-86 
C*
C*     CHANGE HISTORY :
C*          02-MAR-89    CHANGED LUN'S TO CORRESPOND TO LUN'S FOR 
C*                         SYSTEM PROGRAMS
C*          10-NOV-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXCALLS=400,MXCOMS=100,MXFIL=10,MXARG=50,MXNAME=20,
     $          MXSTLN=1520,MXINC=10,MXAUTH=10)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      CHARACTER *(MXSTLN) STMT
      CHARACTER *132 OPSTRG
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *40 AUTHOR
      CHARACTER *5 CLABEL
      CHARACTER *1 CONCHR, CMTCHR
      LOGICAL ADD, ALIGN, ARG, COMM, INDENT, MOVE, PROLOG, RENUM, 
     $        STRUC, WARN, EOF, CONT, LOGIF, TOMANY, STAT, EXEM,
     $        POINT
C                                           
      NAUTH  = 90
      NOPT   = 91
      NWARN  = 6
      NOUT   = 92
      NTEMP  = 93
      NFORM  = 94
      NIN    = 95
      EOF    = .FALSE.
      SUBNAM = '$MAIN'
C
      OPEN (UNIT=NIN,STATUS='OLD',ERR=1000)
      OPEN (UNIT=NOUT,STATUS='NEW',CARRIAGECONTROL='LIST',ERR=1100)
      OPEN (UNIT=NTEMP,STATUS='SCRATCH',FORM='UNFORMATTED',ERR=1200)
      OPEN (UNIT=NFORM,STATUS='SCRATCH',FORM='UNFORMATTED',ERR=1300)
C
C --- SET DEFAULT OPTIONS 
C 
      ADD    = .FALSE.
      ALIGN  = .FALSE.
      ARG    = .FALSE.
      COMM   = .FALSE.
      EXEM   = .FALSE.
      INDENT = .FALSE.
      MOVE   = .FALSE.
      POINT  = .TRUE.
      PROLOG = .FALSE.
      RENUM  = .FALSE.
      STRUC  = .TRUE.
      WARN   = .TRUE.
      CONCHR = ' '
      CMTCHR = 'C'
      LDLINES = 0
C
C --- CHECK FOR OPTIONS FILE
C
      OPEN (NOPT,STATUS='OLD',ERR=100)
C
C --- IN THIS CASE, WE HAVE AN OPTIONS FILE; GET OPTIONS
C
5     READ (NOPT,950,END=100) OPSTRG
      CALL CAPS (OPSTRG)
      CALL GETOPT (OPSTRG)
      GO TO 5
C
C --- GET FIRST CARD
C
100   CALL GETCRD
      RETURN
C
C --- ERROR MESSAGES
C
1000  WRITE (NWARN,900) 
      GO TO 1500
1100  WRITE (NWARN,910) 
      GO TO 1500
1200  WRITE (NWARN,920) 
      GO TO 1500
1300  WRITE (NWARN,930) 
      MOVE = .FALSE.
      RETURN
1500  WRITE (NWARN,940)
      CALL ENDUP (STAT)
C
900   FORMAT (/' *********** ERROR OPENING SOURCE FILE - ')
910   FORMAT (/' *********** ERROR OPENING OUTPUT FILE - ')
920   FORMAT (/' *********** ERROR OPENING SCRATCH FILE - ')
930   FORMAT (/' *********** ERROR OPENING FORMAT FILE - ',
     $                       'FORMATS WILL NOT BE MOVED')
940   FORMAT (15X,'JOB TERMINATED.')
950   FORMAT (A132)
      END        
C
C---END INITL 
C
      SUBROUTINE GETCRD
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          GETCRD           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          GET CARD                                
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS219-1                                 
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          GET CARD FROM SOURCE FILE, CHECK FOR COMMENTS,
C*          CONTROL CARDS, BLANK CARDS, CONTINUATION AND EOF   
C*
C*     INTERNAL WORK AREAS :
C*          CARD   - HOLDS THE LAST CARD READ
C*          CCARDS - HOLDS COMMENT CARDS
C*
C*     COMMON BLOCKS :
C*          FILES, STATMT, OPTIONS, COMMS, STUB
C*
C*     FILE REFERENCES :
C*          NIN, NTEMP, NWARN
C*
C*     SUBPROGRAM REFERENCES :
C*          UNTAB, ENDUP, GETOPT, LENGTH, INDEX, CAPITAL
C*
C*     TRANSPORTABILITY LIMITATIONS :
C*          REQUIRES 'MERLIB'
C*
C*     ASSUMPTIONS AND RESTRICTIONS :
C*          ANY MORE THAN 200 CONSECUTIVE COMMENTS WILL BE DELETED
C*          DOESN'T "SEE" "!" IN HOLLERITH FIELDS - "SEES" A COMMENT
C*            
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     13-NOV-86 
C*
C*     CHANGE HISTORY :
C*          20-AUG-90    BUG FIXED IN CONTROL CARD CHECKING
C*          18-JUL-88    ADDED CHECKING AND CONVERSION FOR DEC TAB
C*                        FORMAT; ADDED D_LINES OPTION
C*          13-NOV-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXCM=200,MXSTLN=1520,MXINC=10,MXCALLS=400,MXCOMS=100,
     $          MXFIL=10,MXARG=50,MXNAME=20,MXAUTH=10)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      COMMON / COMMS / CCARDS, NCMTS
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      CHARACTER *(MXSTLN) STMT
      CHARACTER *80 CARD, CCARDS(MXCM), TCARD(MXINC), OPS
      CHARACTER *40 AUTHOR
      CHARACTER *7 CC
      CHARACTER *5 CLABEL, DUMLAB
      CHARACTER *1 CONCHR, CMTCHR
      LOGICAL ADD, ALIGN, ARG, COMM, INDENT, MOVE, PROLOG, RENUM, 
     $        STRUC, WARN, EOF, CONT, LOGIF, INSTRG, DUMLOG, EX, 
     $        STAT, TOMANY, EXEM, POINT
C                                    
C --- WRITE ANY STORED COMMENTS
C        
      IF (NCMTS .GT. 0) THEN
         DUMLOG = .FALSE.
         LTYPE  = 51
         DUMLAB = ' '
         NLAB   = 0
         DO 5 I = 1,NCMTS
            L = LENGTH (CCARDS(I))
            WRITE(NTEMP) LTYPE,L,DUMLAB,CCARDS(I)(1:L),NLAB,DUMLOG
5        CONTINUE
         NCMTS = 0
         EX = .FALSE.
      ENDIF     
C
C --- CHECK FOR END OF FILE
C
      IF (EOF) THEN
         STAT = .TRUE.
         CALL ENDUP (STAT)
      ENDIF
      CONT = .FALSE. 
C
C --- READ THE CARD
C
10    READ ( NIN, 900, END=100 ) CARD
      IF (CARD(73:80) .NE. ' ') CARD(73:80) = ' '
C
C --- CHECK FOR CONTROL CARD
C
      CC = CARD(1:7)
      CALL CAPS (CC)
      IF (CC .EQ. 'CLEANUP') THEN
         OPS = CARD(8:)
         CALL CAPS (OPS)
         CALL GETOPT (OPS)
         GO TO 10
      ENDIF
C
C --- CHECK FOR BLANK CARD
C
      IF (CARD(1:72) .EQ. ' ') CARD(1:1) = CMTCHR
C
C --- CHECK FOR COMMENTS; IF FOUND, STORE THEM TO BE WRITTEN
C --- ON NEXT CALL TO GETCRD
C
      IF ((CARD(1:1) .EQ. 'C') .OR. (CARD(1:1) .EQ. '*') .OR.
     $    (CARD(1:1) .EQ. '!') .OR. (CARD(1:1) .EQ. 'c')) THEN
          IF (.NOT. EX) THEN
              NCMTS = NCMTS + 1
              IF (NCMTS .GT. MXCM) THEN
                 EX = .TRUE.
                 IF (WARN) WRITE(NWARN,910) SUBNAM
                 NCMTS = NCMTS - 1
              ELSE
                 IF (COMM) CARD(1:1) = CMTCHR
                 CCARDS(NCMTS) = CARD
              ENDIF
          ENDIF
          GO TO 10
      ENDIF
C
C --- CHECK FOR VAX "D_LINES" EXTENSION
C
      IF ((CARD(1:1) .EQ. 'D') .OR. (CARD(1:1) .EQ. 'd')) THEN
C...D_LINE FOUND
         IF (LDLINES .EQ. 2) THEN
C...CONVERT TO CODE
            CARD(1:1) = ' '
C...MAXIMUM STORAGE FOR COMMENTS EXCEEDED ?
         ELSE IF (EX) THEN
C...YEP - SKIP IT, GET ANOTHER
            GO TO 10
         ELSE
C...NO, STORE AS COMMENT
            NCMTS = NCMTS + 1
C...DOES THIS COMMENT PUT US OVER THE LIMIT ?
            IF (NCMTS .GT. MXCM) THEN
C...YEP - SET FLAG, [WARN USER]
               EX = .TRUE.
               IF (WARN) WRITE (NWARN,910) SUBNAM
               NCMTS = NCMTS - 1
            ELSE
C...CONVERT D_LINE TO COMMENT ?
               IF (LDLINES .EQ. 1) CARD(1:1) = CMTCHR
               CCARDS(NCMTS) = CARD
            ENDIF
C...GET ANOTHER CARD
            GO TO 10
         ENDIF
      ENDIF
C
C --- CHECK FOR VAX TAB CONTINUATION EXTENSION
C
      IF (CARD(1:1) .EQ. CHAR(9)) THEN
         IF ((CARD(2:2) .GE. '1') .AND. (CARD(2:2) .LE. '9')) THEN
            CARD = '     $' // CARD(3:)
         ELSE
            CARD = '      ' // CARD(2:)
         ENDIF
      ENDIF
      CALL UNTAB (CARD)
C            
      LENCRD = LENGTH(CARD)
      IF ((INDEX(CARD(2:LENCRD),'!') .NE. 0) .AND. (POINT)) THEN
C
C --- CHECK FOR '!' TYPE COMMENTS --- LOOK FOR '!', BUT NOT IN A
C --- TEXT STRING
C
          IPCD   = 1
20        IPCD = IPCD + 1
          IF (CARD(IPCD:IPCD) .EQ. '''') THEN
C
C --- CHECK FOR EMBEDDED QUOTE
C
              IF (CARD(IPCD+1:IPCD+1) .EQ. '''') THEN
                 IPCD = IPCD + 1
                 GO TO 20
              ENDIF
C
C --- IF WE ARE IN A STRING, WE ARE OUT NOW, AND VICE VERSA
C
              IF (INSTRG) THEN
                 INSTRG = .FALSE.
              ELSE
                 INSTRG = .TRUE.
              ENDIF
          ELSE IF (CARD(IPCD:IPCD) .EQ. '!') THEN
              IF (.NOT.INSTRG) THEN
C
C --- COMMENT FOUND - COPY TO COMMENT BUFFER
C
                 IF (.NOT. EX) THEN
                    NCMTS = NCMTS + 1
                    CCARDS(NCMTS) = CARD(IPCD:LENCRD)
                    IF (COMM) CCARDS(NCMTS)(1:1) = CMTCHR
                 ENDIF
                 IF (CARD(1:IPCD) .EQ. ' ') THEN
                     GO TO 10
                 ELSE
C
C --- REMOVE THE COMMENT FROM THE CARD
C
                     CARD(IPCD:LENCRD) = ' '
                     GO TO 30
                  ENDIF
               ENDIF
           ENDIF
           IF (IPCD .LT. LENCRD) GO TO 20
      ENDIF
C
C --- CHECK FOR CONTINUATION CARD
C
30    IF (CARD(6:6) .NE. ' ') CONT = .TRUE.
      RETURN
100   IF (NIN .NE. 95) THEN
C
C --- IF 'NIN' IS NOT 10, WE HAVE REACHED THE END OF AN INCLUDE FILE
C
          CLOSE (UNIT=NIN)
          NIN  = NIN - 1
C
C --- PUT IN LAST CARD READ BEFORE 'INCLUDE' STATEMENT
C
          CARD  = TCARD(NTCRD)
          NTCRD = NTCRD - 1
      ELSE
          EOF = .TRUE.
      ENDIF
      RETURN
900   FORMAT ( A80 )
910   FORMAT (' ********** WARNING - ',/
     $ 12X,'More than 200 COMMENTS in a row in subprogram ',A,/
     $ 12X,'the rest are being deleted.')
      END
C
C---END GETCRD
C
      SUBROUTINE GETOPT (OSTRG)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          GETOPT           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          GET OPTIONS
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS219-1                                 
C*          NASA/Ames Research Center               
C*          Moffett Field, CA 94035                 
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          THIS SUBPROGRAM PROCESSES THE CARDS CONTAINING OPTIONS 
C*
C*     INPUT ARGUMENTS :
C*          OSTRG - STRING CONTAINING OPTIONS
C*
C*     COMMON BLOCKS :
C*          FILES, OPTIONS, STUB
C*
C*     FILE REFERENCES :
C*          NIN, NWARN, NAUTH
C*
C*     SUBPROGRAM REFERENCES :
C*          INDEX, BLANKS, GETOKE, LENGTH, SEARCH, RIGHT
C*
C*     ERROR PROCESSING :
C*          ERROR MESSAGES PRODUCED FOR INVALID COMMANDS
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     13-NOV-86 
C*
C*     CHANGE HISTORY :
C*          13-NOV-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXCALLS=400,MXCOMS=100,MXFIL=10,MXARG=50,MXNAME=20,
     $          NUMOPT=14,MXINC=10,MXAUTH=10,MAXOPT=20)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      CHARACTER *(*) OSTRG
      CHARACTER *40 AUTHOR
      CHARACTER *10 CMNDS(NUMOPT), COMND(MAXOPT), TOKEN  
      CHARACTER *5 CMIN, CINC
      CHARACTER *2 COL
      CHARACTER *1 CONCHR, TYPE, CMTCHR, OPTNUM
      LOGICAL ADD, ALIGN, ARG, COMM, INDENT, MOVE, PROLOG, RENUM, 
     $        STRUC, WARN, TOMANY, NO, ERR, EXEM, MATCH, AMBIG,
     $        POINT
      DATA CMNDS /   'ALIGN     ', 'ARGUMENT  ', 'COMMENT   ', 
     $ 'CONTINUE  ', 'DLINES    ', 'EXCOMM    ', 'EXEMPT    ', 
     $ 'INCLUDE   ', 'INDENT    ', 'MOVE      ', 'PROLOGUE  ', 
     $ 'RENUMBER  ', 'STRUCTURE ', 'WARNING   '/
C
C --- REMOVE BLANKS FROM OPTION STRING
C
      CALL BLANKS (OSTRG)
      LEN = LENGTH (OSTRG)
      IP = 0
      NTOKE = 0
      DO 3 ICOM = 1,20
         COMND(ICOM) = ' '
3     CONTINUE
C
C --- PARSE THE STRING
C
5     CALL GETOKE ( OSTRG(1:LEN), LEN, IP, TOKEN, TYPE, ERR)      
      IF ( ERR ) THEN
          RETURN
      ELSE
          IF (TYPE .NE. 'E') THEN
             NTOKE = NTOKE + 1
             IF ((NTOKE .GT. MAXOPT) .AND.(WARN)) THEN
                WRITE(NWARN,945) OSTRG(1:LEN)
                GO TO 7
             ELSE
                COMND(NTOKE) = TOKEN
             ENDIF
             GO TO 5
          ENDIF
      ENDIF
7     NINDEX = 0
C
C --- LOOP UNTIL ALL COMMANDS IN THIS STRING ARE PROCESSED
C                    
10    NINDEX = NINDEX + 1     
      IF (NINDEX .GT. NTOKE) GO TO 180
      NO = COMND(NINDEX)(1:2) .EQ. 'NO'
      IF (NO) COMND(NINDEX) = COMND(NINDEX)(3:)
C
C --- SEARCH ARRAY OF VALID COMMANDS FOR THIS COMMMAND
C
      CALL SEARCH (CMNDS, NUMOPT, COMND(NINDEX), I, MATCH, AMBIG)
      IF (.NOT. MATCH) THEN
C
C --- INVALID COMMAND
C
         IF (WARN) WRITE(NWARN,900) COMND(NINDEX),OSTRG(1:LENGTH(OSTRG))
         GO TO 10
      ELSE IF (AMBIG) THEN
C 
C --- AMBIGUOUS COMMAND
C
         IF (WARN) WRITE(NWARN,940) COMND(NINDEX)
         GO TO 10
      ENDIF
C
C --- CHECK FOR 'NO'
C
      GO TO (40,50,60,70,80,90,100,110,120,130,140,150,160,170), I
C---ALIGN OPTION
40    IF (NO) THEN
          ALIGN = .FALSE.
      ELSE
          ALIGN = .TRUE.
          IF (COMND(NINDEX+1)(1:1) .EQ. '=') THEN
C
C --- GET ALIGNMENT COLUMN FOR '='
C
             NINDEX = NINDEX + 2
             COL = COMND(NINDEX)(1:2)
             CALL RIGHT (COL)
             READ(COL,910,ERR=45) NCOL
          ELSE
             NCOL = 8
          ENDIF
          IF ((NCOL .LT. 3).OR.(NCOL .GT. 15)) NCOL = 8
      ENDIF
      GO TO 10
45    WRITE(NWARN,950) CMNDS(I)
      GO TO 10
C---ARGUMENT
50    IF (NO) THEN
         ARG = .FALSE.
      ELSE
         ARG = .TRUE.
      ENDIF
      GO TO 10
C---COMMENTS
60    IF (NO) THEN
         COMM = .FALSE.
      ELSE 
         COMM = .TRUE.
         IF (COMND(NINDEX+1)(1:1) .EQ. '=')  THEN
C
C --- GET COMMENT CHARACTER
C
            NINDEX = NINDEX + 2
            CMTCHR = COMND(NINDEX)(1:1)
            IF ((CMTCHR .NE. 'C').AND.(CMTCHR .NE. '*')) CMTCHR = 'C'
         ENDIF
      ENDIF
      GO TO 10
C---CONTINUE
70    IF (NO) THEN
         CONCHR = ' '
      ELSE IF (COMND(NINDEX+1)(1:1) .EQ. '=') THEN
C
C --- GET CONTINUE CHARACTER
C
          NINDEX = NINDEX + 2
          CONCHR = COMND(NINDEX)(1:1)
      ELSE
          CONCHR = ' '
      ENDIF
      GO TO 10
C---DLINES
80    IF (COMND(NINDEX+1)(1:1) .EQ. '=') THEN
C
C --- GET DLINES OPTION
C
         NINDEX = NINDEX + 2
         OPTNUM = COMND(NINDEX)(1:1)
         READ(OPTNUM,910,ERR=85) INOPT      
         IF ((INOPT .LT. 0) .OR. (INOPT .GT. 2)) THEN
            WRITE (NWARN,950) CMNDS(I)
            LDLINES = 0
         ELSE
            LDLINES = INOPT
         ENDIF           
      ENDIF
      GO TO 10
85    WRITE (NWARN,950) CMNDS(I)
C---EXCOMM
90    IF (NO) THEN
         POINT = .FALSE.
      ELSE
         POINT = .TRUE.
      ENDIF
      GO TO 10
C---EXEMPT    
100    IF (.NOT. NO) EXEM = .TRUE.
      GO TO 10
C---INCLUDE
110   IF (NO) THEN
          ADD = .FALSE.
      ELSE
          ADD = .TRUE.
      ENDIF
      GO TO 10
C---INDENT
120   IF (NO) THEN
         INDENT = .FALSE.
      ELSE
         INDENT = .TRUE.
         IF (COMND(NINDEX+1)(1:1) .EQ. '=') THEN
C
C --- GET NUMBER OF COLUMNS TO INDENT
C
             NINDEX = NINDEX + 2
             NIND = ICHAR(COMND(NINDEX)(1:1)) - ICHAR('0')
         ELSE
             NIND = 3
         ENDIF
         IF ((NIND .LT. 1) .OR. (NIND .GT. 9)) NIND = 3
      ENDIF
      GO TO 10
C---MOVE
130   IF (NO) THEN
          MOVE = .FALSE.
      ELSE
          MOVE = .TRUE.
      ENDIF
      GO TO 10
C---PROLOGUE
140   IF (NO) THEN
          PROLOG = .FALSE.
      ELSE
          PROLOG = .TRUE.
C
C --- CHECK FOR OPTIONAL AUTHOR INFORMATION
C
          IF (COMND(NINDEX+1)(1:1) .EQ. '*') THEN
              NINDEX = NINDEX + 1
C
C --- CHECK FOR FILE ENTERED ON COMMAND LINE
C
              OPEN (NAUTH,STATUS='OLD',ERR=121)
              GO TO 122
C
C --- NO AUTHOR FILE ON COMMAND LINE, CHECK IN LOGIN DIRECTORY
C
121           OPEN (NAUTH,FILE='SYS$LOGIN:AUTHOR.DAT',STATUS='OLD',
     $              ERR=190)
122           I = 0
123           I = I + 1
              IF (I .GT. 10) THEN
                 WRITE(NWARN,915) SUBNAM
                 GO TO 125
              ENDIF
              READ (NAUTH,920,END=125) AUTHOR(I)
              GO TO 123
125           NLINES = I - 1
         ENDIF
      ENDIF
      GO TO 10
C---RENUMBER
150   IF (NO) THEN
          RENUM = .FALSE.
      ELSE
          RENUM = .TRUE.
          MIN = 0
          INC = 10
          IF (COMND(NINDEX+1) .EQ. '=') THEN
C
C --- GET MINIMUM STATEMENT NUMBER
C
              NINDEX = NINDEX + 2
              N = 1
              L = LENGTH (COMND(NINDEX))
              CMIN = COMND(NINDEX)(N:L)
              CALL RIGHT(CMIN)
              READ(CMIN,910,ERR=135) MIN
135           IF (COMND(NINDEX+1)(1:1) .EQ. '/') THEN
C
C --- GET INCREMENT TO STATEMENT NUMBERS
C
                 NINDEX = NINDEX + 2   
                 N = 1
                 L = LENGTH (COMND(NINDEX))
                 CINC = COMND(NINDEX)(N:L)
                 CALL RIGHT(CINC)
                 READ(CINC,910,ERR=137) INC  
              ENDIF
          ENDIF
137       IF ( (MIN .LT. 0) .OR. (MIN .GT. 99000) ) MIN = 0
          IF ( (INC .LT. 1) .OR. (INC .GT. 1000) ) INC = 10  
      ENDIF
      GO TO 10
C---STRUCTURE
160   IF (NO) THEN
          STRUC = .FALSE.
      ELSE
          STRUC = .TRUE.
      ENDIF
      GO TO 10
C---WARNING
170   IF (NO) THEN
          WARN = .FALSE.
      ELSE
          WARN = .TRUE.
      ENDIF 
      GO TO 10
180   RETURN
190   WRITE(NWARN,930)
      GO TO 10
900   FORMAT(' ********** WARNING -- INVALID COMMAND : ''',A,' ''',/,
     $ 12X,'IN CONTROL CARD : ',A)
910   FORMAT(I5)
915   FORMAT(' ********** WARNING -- TOO MANY AUTHOR INFORMATION LINES'
     $ ,/,12X,'The rest will not be included in subprogram ',A)
920   FORMAT(A40)
930   FORMAT (' ********** ERROR OPENING AUTHOR INFORMATION FILE - ',
     $                    'NO AUTHOR INFORMATION WILL BE INCLUDED.')
940   FORMAT (' ********** WARNING -- AMBIGUOUS COMMAND : ''',A,' ''',/,
     $ 12X,A)
945   FORMAT (' ********** WARNING -- TOO MANY OPTIONS IN OPTION CARD'
     $ ,/,12X,A)
950   FORMAT (' ********** ERROR -- ILLEGAL VALUE FOR ',A,/
     $      '                       DEFAULT IN EFFECT')
      END
C     
C---END GETOPT
C     
      SUBROUTINE NOPRO 
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          NOPRO            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          NO PROCESSING                           
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          WRITES CARDS TO OUTPUT FILE, UNTIL 'NOEXEMPT' IS FOUND
C*
C*     COMMON BLOCKS :
C*          FILES, STATMT, COMMS
C*
C*     FILE REFERENCES :
C*          NIN, NOUT
C*
C*     SUBPROGRAM REFERENCES :
C*          ENDUP, LENGTH, GETCRD
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     17-NOV-86 
C*
C*     CHANGE HISTORY :
C*          17-NOV-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXSTLN=1520,MXINC=10,MXCM=200)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / COMMS / CCARDS, NCMTS
      CHARACTER *(MXSTLN) STMT
      CHARACTER *80 CARD, TCARD(MXINC), CCARDS(MXCM)
      CHARACTER *5 CLABEL
      LOGICAL CONT, EOF, LOGIF, STAT
C
C --- WRITE OUT ANY STORED COMMENTS
C
      IF (NCMTS .GT. 0) THEN
         DO 5 I = 1,NCMTS
            WRITE(NOUT,900) (CCARDS(I))
5        CONTINUE
         NCMTS = 0
      ENDIF
C
C --- WRITE CARDS UNTIL 'NOEXEMPT' IS FOUND
C
10    L = LENGTH(CARD)
      WRITE(NOUT,900) CARD(1:L)
      READ (NIN,900,END=20) CARD
      IF ((INDEX(CARD,'NOEX') .NE. 0).AND.(CARD(1:7) .EQ. 'CLEANUP'))
     $ THEN
         CALL GETCRD
         RETURN
      ENDIF
      GO TO 10
C
C --- EOF DURING NOPRO
C
20    STAT = .TRUE.
      CALL ENDUP (STAT)
900   FORMAT ( A )
      END
C
C---END NOPRO 
C
      SUBROUTINE NAMEX ( NAME )
C* 
C*                  ******************************* 
C*                  ******************************* 
C*                  **                           ** 
C*                  **          NAMEX            ** 
C*                  **                           ** 
C*                  ******************************* 
C*                  ******************************* 
C* 
C*     SUBPROGRAM : 
C*          NAME EXTRACTION 
C* 
C*     AUTHOR : 
C*          ART RAGOSTA 
C*          MS 219-1 
C*          AMES RESEARCH CENTER 
C*          MOFFETT FIELD, CALIF 94035 
C*          (415)965-5578 
C* 
C*     PURPOSE : 
C*          EXTRACT THE SUBPROGRAM NAME FROM THE STATEMENT. 
C* 
C*     OUTPUT ARGUMENTS : 
C*          NAME  - THE NAME OF THE SUBPROGRAM
C* 
C*     COMMON BLOCKS : 
C*          STATMT
C* 
C*     SUBPROGRAM REFERENCES : 
C*          INDEX
C* 
C*     LANGUAGE AND COMPILER : 
C*          ANSI FORTRAN 77
C* 
C*     VERSION AND DATE : 
C*          VERSION II.0     01/24/84
C* 
C*     CHANGE HISTORY : 
C*          12/05/86     MODIFIED FOR CLEANUP
C*          01/24/84     CONVERTED TO VAX
C*          10/13/83     INITIAL VERSION 
C* 
C***********************************************************************
C* 
      PARAMETER(MXNAME=20,MXSTLN=1520,MXINC=10)
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      CHARACTER *(MXSTLN) STMT
      CHARACTER *(MXNAME) NAME
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *5 CLABEL 
      LOGICAL EOF, CONT, LOGIF 
C                            
C --- START EXTRACTING NAME THE FIRST CHARACTER AFTER THE KEYWORD
C
      IF (ITYPE .EQ. 32) THEN
         NSTART = 11
      ELSEIF (ITYPE .EQ. 3) THEN
         NSTART = INDEX(STMT,'CALL') + 4
      ELSEIF (ITYPE .EQ. 27) THEN
         NSTART = 8      
      ELSEIF (ITYPE .EQ. 45) THEN
         NSTART = (INDEX(STMT,'FUNCTION')) + 8
      ELSEIF (ITYPE .EQ. 13) THEN
         NSTART = 6
      ENDIF
C                          
C --- STOP SEARCHING AFTER (MXNAME) CHARACTERS, WHEN A '(' IS FOUND, OR
C AT THE END OF THE STATEMENT; WHICHEVER COMES FIRST
C
      NPLUS20 = NSTART+MXNAME
      IF (NPLUS20 .GT. LENST) NPLUS20 = LENST
      DO 10 I = NSTART,NPLUS20
         IF (STMT(I:I) .EQ. '(')GO TO 20
   10 CONTINUE
      I = NPLUS20+1
   20 I = I-1
      NAME = STMT(NSTART:I)
      RETURN 
      END       
C
C---END NAMEX
C
      SUBROUTINE ARGEX 
C* 
C*                  ******************************* 
C*                  ******************************* 
C*                  **                           ** 
C*                  **          ARGEX            ** 
C*                  **                           ** 
C*                  ******************************* 
C*                  ******************************* 
C* 
C*     SUBPROGRAM : 
C*          ARGUMENT EXTRACTION 
C* 
C*     AUTHOR : 
C*          ART RAGOSTA 
C*          MS 219-1 
C*          AMES RESEARCH CENTER 
C*          MOFFETT FIELD, CALIF 94035 
C*          (415)965-5578 
C* 
C*     PURPOSE : 
C*          EXTRACT THE NAMES AND THE NUMBER OF ARGUMENTS FROM THE
C*          STATEMENT.
C* 
C*     COMMON BLOCKS : 
C*          FILES, OPTIONS, STATMT, STUB
C* 
C*     FILE REFERENCES : 
C*          NWARN
C* 
C*     SUBPROGRAM REFERENCES : 
C*          INDEX
C* 
C*     ERROR PROCESSING :      
C*          CHECK FOR BALANCED PARENS IN ARGUMENT LIST
C* 
C*     LANGUAGE AND COMPILER : 
C*          ANSI FORTRAN 77
C* 
C*     VERSION AND DATE : 
C*          VERSION II.2     JUNE 4 1985
C* 
C*     CHANGE HISTORY : 
C*          12/09/86     MODIFIED FOR CLEANUP
C*          06/04/85     FIXED BUG IN SUBSCRIPTED ARGUMENTS
C*          04/22/85     LITERAL STRING HANDLING IMPROVED
C*          01/24/84     CONVERTED TO VAX
C*          10/13/83     INITIAL VERSION 
C* 
C***********************************************************************
C* 
      PARAMETER(MXCALLS=400,MXCOMS=100,MXFIL=10,MXARG=50,MXNAME=20,
     $          MXSTLN=1520,MXINC=10,MXAUTH=10)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      CHARACTER *(MXSTLN) STMT
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *40 AUTHOR    
      CHARACTER *5 CLABEL
      CHARACTER *1 CMTCHR, CONCHR
      LOGICAL CONT, EOF, LOGIF, TOMANY, ADD, ALIGN, ARG, COMM, INDENT,
     $        MOVE, PROLOG, RENUM, STRUC, WARN, EXEM, POINT
C                             
      NARGS = 0
C
C --- START COUNTING ARGUMENTS AT THE '(' UNLESS THERE IS NO ARGUMENT
C --- LIST
C
      I = INDEX(STMT,'(')
      IF (I .EQ. 0) RETURN
C
C --- THE NUMBER OF ARGUMENTS IS THE NUMBER OF COMMAS PLUS ONE
C --- DON'T COUNT COMMAS IN ARRAY INDICES
C
      NEST = 0
C
C --- GET FIRST ARGUMENT
C
      GO TO 14
10    I = I + 1
      IF (I .GT. LENST) THEN
         IF (WARN) WRITE (NWARN, 900) STMT(1:LENST)
         RETURN
      ENDIF
C
C --- IF WE ARE NOT NESTED AND WE FIND A COMMA, INCREMENT NUMBER OF
C ARGUMENTS
C --- IF WE FIND A '(' INCREMENT NEST LEVEL
C --- IF WE FIND A ')' DECREMENT NEST LEVEL UNLESS NEST LEVEL IS ALREADY
C 0 IN WHICH CASE WE FALL THROUGH TO THE RETURN STATEMENT
C
      IF (STMT(I:I) .EQ. ','  .AND.  NEST .EQ. 0) THEN
C
C --- EXTRACT NAME
C
14        NSTART = I + 1
15        I = I + 1
          IF (((STMT(I:I) .GE. 'A').AND.(STMT(I:I) .LE. 'Z')) .OR.
     $       ((STMT(I:I) .GE. '0').AND.(STMT(I:I) .LE. '9')) .OR.
     $       (STMT(I:I) .EQ. '$') .OR. (STMT(I:I) .EQ. '_')) 
     $       GO TO 15
          I = I - 1
          IF (NARGS .GT. MXARG) THEN
             IF (WARN) WRITE(NWARN,910) SUBNAM
             RETURN
          ELSE
             NARGS = NARGS + 1
             ARGNAM(NARGS) = STMT(NSTART:I)
          ENDIF
      ENDIF
      IF (STMT(I:I) .EQ. '(') THEN
         NEST = NEST+1
      ELSE IF (STMT(I:I) .EQ. ')') THEN
         IF (NEST .GT. 0) THEN
            NEST = NEST-1
         ELSE
C
C ----- ALL ARGUMENTS HAVE BEEN FOUND... EXIT ROUTINE
C
            GO TO 30
         ENDIF
C
C --- ALL OTHER CHARACTERS ARE SKIPPED
C
      ENDIF
      GO TO 10
30    RETURN 
900   FORMAT (' ********** ERROR, unbalanced parentheses encountered'/
     $        '            in statement ',A)
910   FORMAT (' ********** WARNING - ',/,
     $ 12X,'Number of arguments exceeds the maximum for prologues',/
     $ 12X,'in subprogram ',A)
      END 
C
C---END ARGEX
C
      SUBROUTINE GETNAM ( NAME )
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          GETNAM           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          GET NAME                                
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          GET NAME OF COMMON BLOCK FROM FORTRAN COMMON STATEMENT      
C*
C*     OUTPUT ARGUMENTS :
C*          NAME - THE NAME OF THE COMMON BLOCK ($BLANK, IF NOT NAMED)
C*
C*     COMMON BLOCKS :
C*          STATMT
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     26-NOV-86 
C*
C*     CHANGE HISTORY :
C*          26-NOV-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXNAME=20,MXSTLN=1520,MXINC=10)
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      CHARACTER *(MXSTLN) STMT
      CHARACTER *(MXNAME) NAME
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *5 CLABEL
      LOGICAL EOF, CONT, LOGIF 
C
      NAME = ' '
      ISL = INDEX(STMT,'/')
C
C --- NO SLASH --> BLANK COMMON
C
      IF (ISL .EQ. 0) THEN
         NAME = '$BLANK'
         RETURN
      ENDIF
C
C --- EXTRACT NAME FROM BETWEEN THE SLASHES
C
      NSTART = ISL + 1
      IND = 1
      DO 10 I = NSTART, LENST
         IF (STMT(I:I) .EQ. '/') THEN
            GO TO 20
         ELSE
            NAME(IND:IND) = STMT(I:I)
            IND = IND + 1
         ENDIF
10    CONTINUE  
20    RETURN
      END
C
C---END GETNAM
C
      SUBROUTINE PROLG
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          PROLG            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          PROLOGUE                                
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*      BASED ON PROGRAM 'STUB' BY ART RAGOSTA
C*
C*     PURPOSE :
C*          CREATE A PROLOGUE FOR A SUBPROGRAM INCLUDING AUTHOR
C*          INFORMATION (IF ANY), SUBPROGRAM NAME, ARGUMENTS, 
C*          COMMON BLOCKS REFERENCED, SUBROUTINES CALLED AND
C*          FILES REFERENCED
C*
C*     COMMON BLOCKS :
C*          FILES, STUB
C*
C*     FILE REFERENCES :
C*          NOUT
C*
C*     SUBPROGRAM REFERENCES :
C*          DATE, BUILD, PUTLIN
C*
C*     TRANSPORTABILITY LIMITATIONS :
C*          SYSTEM-SPECIFIC ROUTINE DATE
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     25-NOV-86 
C*                                             
C*     CHANGE HISTORY :
C*          25-NOV-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXCALLS=400,MXCOMS=100,MXFIL=10,MXARG=50,MXAUTH=10,
     $          MXNAME=20)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      CHARACTER *870 CLINE, CBLINE, FLINE, ALINE
      CHARACTER *40 AUTHOR
      CHARACTER *10 IDATE
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      LOGICAL TOMANY
C                                  
C --- GET DATE
C
      CALL DATE (IDATE)                         
      WRITE(NOUT,900)
      WRITE(NOUT,910) SUBNAM
      WRITE(NOUT,900)
      WRITE(NOUT,915) SUBNAM
      WRITE(NOUT,900)
C
C --- WRITE AUTHOR INFORMATION
C
      IF (NLINES .GT. 0) THEN
         WRITE(NOUT,920)
         DO 10 I = 1,NLINES
            WRITE(NOUT,925) AUTHOR(I)
10       CONTINUE
         WRITE(NOUT,900)
      ENDIF
      WRITE(NOUT,935)
      WRITE(NOUT,900)
C 
C --- WRITE SUBPROGRAM ARGUMENTS
C
      IF (NARGS .NE. 0) THEN
         WRITE(NOUT,960)
         CALL BUILD (ARGNAM,MXARG,NARGS,ALINE,LENLIN)
         CALL PUTLIN (ALINE,LENLIN)
         WRITE(NOUT,900)
      ENDIF
      WRITE(NOUT,980)
      WRITE(NOUT,900)
C
C --- WRITE COMMON BLOCKS REFERENCED
C
      IF (NCOMS .NE. 0) THEN
         WRITE(NOUT,990)
         CALL BUILD (COMNAM,MXCOMS,NCOMS,CBLINE,LENLIN) 
         CALL PUTLIN (CBLINE,LENLIN)
         WRITE(NOUT,900)                        
      ENDIF
C
C --- WRITE FILES REFERENCED
C
      IF (NFREF .NE. 0) THEN
         WRITE(NOUT,9000)
         CALL BUILD (FILREF,MXFIL,NFREF,FLINE,LENLIN)
         CALL PUTLIN (FLINE,LENLIN)
         WRITE(NOUT,900)
      ENDIF
C
C --- WRITE SUBPROGRAMS CALLED
C
      IF (NCALLS .NE. 0) THEN
         WRITE(NOUT,9020)
         CALL BUILD (CALNAM, MXCALLS, NCALLS, CLINE, LENLIN)
         CALL PUTLIN (CLINE, LENLIN)
         WRITE(NOUT,900)    
      ENDIF
      WRITE(NOUT,9030)
      WRITE(NOUT,900)
      WRITE(NOUT,9040)
      WRITE(NOUT,900)
      WRITE(NOUT,9050)
      WRITE(NOUT,900)
      WRITE(NOUT,9060)
      WRITE(NOUT,900)
      WRITE(NOUT,9070)IDATE
      WRITE(NOUT,900)
      WRITE(NOUT,9080)IDATE
      WRITE(NOUT,900)
      WRITE(NOUT,9090)
      WRITE(NOUT,900)
      RETURN
  900 FORMAT('C*')
  910 FORMAT(2('C*',18X,'*******************************',/),
     $ 'C*',18X,'**',27X,'**',/,'C*',18X,'**',10X,A6,
     $ 11X,'**',/,'C*',18X,'**',27X,'**',
     $ 2(/,'C*',18X,'*******************************'))
  915 FORMAT('C*',5X,'SUBPROGRAM :',/,'C*',10X,A)
  920 FORMAT('C*',5X,'AUTHOR :')
  925 FORMAT('C*',10X,A40)
  935 FORMAT('C*',5X,'PURPOSE :'/,'C*',10X,'(You tell me.)')
  960 FORMAT('C*',5X,'ARGUMENTS :')
  980 FORMAT('C*',5X,'INTERNAL WORK AREAS :',/,'C*',10X,'NONE')
  990 FORMAT('C*',5X,'COMMON BLOCKS :')
 9000 FORMAT('C*',5X,'FILE REFERENCES :')
 9020 FORMAT('C*',5X,'SUBPROGRAM REFERENCES :')
 9030 FORMAT('C*',5X,'ERROR PROCESSING :',/,'C*',10X,'NONE')
 9040 FORMAT('C*',5X,'TRANSPORTABILITY LIMITATIONS :',/,
     $ 'C*',10X,'NONE')
 9050 FORMAT('C*',5X,'ASSUMPTIONS AND RESTRICTIONS :',/,
     $ 'C*',10X,'NONE')
 9060 FORMAT('C*',5X,'LANGUAGE AND COMPILER :',/,
     $ 'C*',10X,'VAX FORTRAN 77')
 9070 FORMAT('C*',5X,'VERSION AND DATE :',/,'C*',10X,
     $ 'VERSION I.0     ',A10)
 9080 FORMAT('C*',5X,'CHANGE HISTORY :',/,'C*',10X,A10,
     $ 3X,'INITIAL VERSION')
 9090 FORMAT('C***********************************************',
     $ '************************')
      END
C
C---END PROLG
C 
      SUBROUTINE BUILD (ARRAY, LENARR, NARR, LINE, LINLEN)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          BUILD            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          BUILD OUTPUT LINE                       
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          BUILD A LINE OF NAMES FOR PROLOGUE FROM SPECIFIED ARRAY     
C*          (E.G., COMMON BLOCK NAMES, FILE REFERENCES, ETC.)
C*
C*     INPUT ARGUMENTS :
C*          ARRAY  - THE ARRAY OF NAMES
C*          LENARR - DEFINED LENGTH OF THE ARRAY
C*          NARR   - NUMBER OF ENTRIES IN THE ARRAY
C*
C*     OUTPUT ARGUMENTS :
C*          LINE   - THE LINE CONTAINING THE NAMES
C*          LINLEN - THE LENGTH OF THE LINE
C*
C*     SUBPROGRAM REFERENCES :
C*          LENGTH
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     10-DEC-86 
C*
C*     CHANGE HISTORY :
C*          10-DEC-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXNAME=20)
      CHARACTER *(*) LINE
      CHARACTER *(MXNAME) ARRAY(LENARR)
C
       LINE = ' '
       IND = 1
       DO 10 I = 1, NARR-1
          LEN = LENGTH(ARRAY(I))
          LINE(IND:IND+LEN) = ARRAY(I)(1:LEN)
          IND = IND + LEN
          LINE(IND:IND+1) = ', '
          IND = IND + 2
10    CONTINUE
      LEN = LENGTH(ARRAY(NARR))
      LINE(IND:IND+LEN) = ARRAY(NARR)(1:LEN)
      LINLEN = IND+LEN-1
      RETURN
      END
C 
C---END BUILD
C
      SUBROUTINE PUTLIN (LINE, LEN)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          PUTLIN           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          PUT LINE                                
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          OUTPUT A LINE OF NAMES IN THE PROLOGUE TO OUTPUT FILE
C*
C*     INPUT ARGUMENTS :
C*          LINE - THE LINE TO BE PUT
C*          LEN  - THE LENGTH OF THE LINE
C*
C*     COMMON BLOCKS :
C*          FILES
C*
C*     FILE REFERENCES :
C*          NOUT
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     10-DEC-86 
C*
C*     CHANGE HISTORY :
C*          10-DEC-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXLIN=60)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      CHARACTER *(*) LINE
C
      IF (LEN .LE. 60) THEN
         WRITE(NOUT,900) LINE(1:LEN)
      ELSE
         IST = 1
         IT = 1
         NBREAK = 1
10       NBREAK = MXLIN * IT  
         IT = IT + 1
15       NBREAK = NBREAK - 1
         IF (NBREAK .GE. LEN) THEN
            WRITE (NOUT,900) LINE(IST:NBREAK)
            GO TO 100
         ENDIF
C
C --- BREAK THE LINE ONLY AFTER A COMMA
C
         IF (LINE(NBREAK:NBREAK) .NE. ',') GO TO 15
         WRITE (NOUT,900) LINE(IST:NBREAK)
         IST = NBREAK + 2
         IF (IST .LT. LEN) GO TO 10
      ENDIF
100   RETURN
900   FORMAT('C*',10X,A)
      END
C
C---END PUTLIN
C
      SUBROUTINE PROSUB
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          PROSUB           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          PROCESS SUBPROGRAM                      
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS219-1                                 
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (451)604-5578                           
C*
C*     PURPOSE :
C*          DO INITIAL PROCESSING OF ONE SUBPROGRAM AND WRITE IT TO     
C*          A TEMPORARY FILE                                            
C*
C*     COMMON BLOCKS :
C*          FILES, STATMT, OPTIONS, STUB, TEXT
C*
C*     FILE REFERENCES :
C*          NTEMP, NWARN, NFORM
C*
C*     SUBPROGRAM REFERENCES :
C*          GETSTM, CATEG, NAMEX, RESTOR, RIGHT, REFNUM, DLIST, 
C*          RLIST, ARGMNT, GETNAM, ARGEX, GETFIL, ADDCODE, GETNUM,
C*          LEFT, LENGTH, LINEUP, SPASGN, SPLOG, PUTSTR, SPARG
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77   
C*
C*     VERSION AND DATE :
C*          VERSION I.0     13-NOV-86 
C*
C*     CHANGE HISTORY :
C*          13-NOV-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXCALLS=400,MXCOMS=100,MXFIL=10,MXARG=50,MXNAME=20,
     $          MXSTLN=1520,MXSTRGS=200,MXINC=10,MXAUTH=10)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      COMMON / TEXT / STRINGS, NUMST, CREP
      CHARACTER *(MXSTLN) STMT, STRINGS(MXSTRGS)         
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *40 AUTHOR                  
      CHARACTER *(MXNAME) CNAME, SUBNAM, CALNAM, COMNAM, CBNAM, FILREF, 
     $           ARGNAM, ENAME
      CHARACTER *5 CLABEL, CSPEC
      CHARACTER *4 CREP
      CHARACTER *1 CONCHR, LAST, CMTCHR
      LOGICAL ADD, ALIGN, ARG, COMM, INDENT, MOVE, PROLOG, RENUM, 
     $        STRUC, WARN, CONT, EOF, NONE, LOGIF, RFONLY, DUMFL,
     $        TOMANY, EXEM, POINT
C
C --- CATEGORIZE THE STATEMENT
C
5     CALL CATEG
      NLAB = 0
      LOC  = 1
      IF (RENUM) THEN
          RFONLY = .FALSE.
      ELSE
          RFONLY = .TRUE.
      ENDIF
C
C --- CHECK FOR LOGICAL IF
C
      IF (LOGIF) THEN
          CALL RESTOR(2,0,1)
          LOC = ISTART + 1
      ENDIF
C
C --- PROCESS THE STATEMENT BY TYPE
C
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     $       170,180,190,200,210,220,230,240,250,260,270,280,290,300,
     $       310,320,330,340,350,360,370,380,390,400,410,420,430,440, 
     $       450,460,470,480,490,500),ITYPE
C --- ASSIGN
10    CALL DLIST
      CALL REFNUM (7,LABEL,NONE,LAST,LLST,RFONLY)
      IF (.NOT. NONE) CALL RLIST (LABEL)
      NLAB = 1
      CALL RESTOR (6,0,LOC)
      IF (LOGIF) THEN
         CALL SPLOG (NADDED)
         IF (NADDED .GT. 0) LOC = LOC + NADDED
      ENDIF
      GO TO 510
C --- BLOCK DATA
20    CALL RESTOR (5,4,1)
      SUBNAM = 'BLOCKD'
      GO TO 510
C --- CALL
30    CALL DLIST
C
C --- GET NAME OF SUBPROGRAM CALLED 
C
      CALL NAMEX (CNAME)
      IF (PROLOG .OR. ARG) THEN
C
C --- CHECK FOR DUPLICATE NAME
C
         DO 35 I = 1,NCALLS
            IF (CNAME .EQ. CALNAM(I)) GO TO 37
35       CONTINUE          
         IF (NCALLS .GT. MXCALLS) THEN
            IF (WARN) WRITE(NWARN,920) SUBNAM
         ELSE
            NCALLS = NCALLS + 1
            CALNAM(NCALLS) = CNAME
         ENDIF
      ENDIF
37    IF (.NOT. ARG) THEN
         L = LENGTH (CNAME)
         CALL RESTOR (4,L,LOC)
      ELSE
         CALL RESTOR (4,0,LOC)
         CALL ARGMNT
      ENDIF
      CALL SPLOG (NADDED)
      GO TO 510
C --- CHARACTER 
40    IF (.NOT. STRUC) THEN
         CALL RESTOR (9,0,1)
C
C --- RESTORE LENGTH SPECIFICATION
C
         IF (INDEX(STMT,'CHARACTER *') .NE. 0) THEN
            I = INDEX(STMT,'CHARACTER *(') + 10
            IF (I .EQ. 11) THEN
C
C --- LENGTH SPECIFICATION IS A PARAMETER
C
               J = INDEX(STMT,')') 
               CALL RESTOR (J,0,1)
            ELSE
C
C --- LENGTH SPECIFICATION IS AN INTEGER
C
               DUMFL = .TRUE.
               CALL REFNUM (12,ISPEC,NONE,LAST,LLST,DUMFL)
               WRITE(CSPEC,900) ISPEC
               CALL LEFT (CSPEC)
               L = LENGTH(CSPEC) + 11
               CALL RESTOR(L,0,1)
            ENDIF
         ENDIF
      ENDIF
      GO TO 510
C --- COMMON
C --- GET COMMON BLOCK NAME FOR PROLOGUE
50    CALL GETNAM (CBNAM)
      IF (PROLOG) THEN
         IF (NCOMS .GT. MXCOMS) THEN
            IF (WARN) WRITE(NWARN,930) SUBNAM
         ELSE
            NCOMS = NCOMS + 1
            COMNAM(NCOMS) = CBNAM
         ENDIF
      ENDIF 
      IF (.NOT. STRUC) THEN
         IF (CBNAM .NE. '$BLANK') THEN
            LEN2 = LENGTH(CBNAM) + 2
         ELSE
            LEN2 = 0
         ENDIF
         CALL RESTOR (6,LEN2,1)
      ENDIF
      GO TO 510
C --- COMPLEX
60    IF (.NOT. STRUC) CALL RESTOR (7,0,1)
      GO TO 510
C --- CONTINUE
70    IF (CLABEL .EQ. ' ') THEN
C
C --- UNLABELED CONTINUE STATEMENT, DELETE IT
C
         IF ( WARN ) WRITE(NWARN,910) SUBNAM
         CALL GETSTM   
         GO TO 5
      ENDIF
      CALL DLIST
      GO TO 510
C --- DIMENSION
80    IF (.NOT. STRUC) CALL RESTOR (9,0,1)
      GO TO 510
C --- DOUBLE PRECISION
90    IF (.NOT. STRUC) CALL RESTOR (6,9,1)
      GO TO 510
C --- ELSE IF
100   CALL RESTOR (4,2,1)
      L = LENST - 4
      CALL RESTOR (L,0,1)
      CALL SPLOG (NADDED)
      GO TO 510
C --- ELSE
110   GO TO 510
C --- ENDIF
120   CALL RESTOR(3,2,1)
      GO TO 510
C --- ENTRY
130   IF (ARG) THEN
         CALL RESTOR (5,0,1)
         CALL ARGMNT
      ELSE
         CALL NAMEX (ENAME)
         L = LENGTH(ENAME)
         CALL RESTOR (5,L,1)
      ENDIF
      GO TO 510
C --- EQUIVALENCE
140   CALL RESTOR (11,0,1)
      GO TO 510
C --- EXTERNAL
150   CALL RESTOR (8,0,1)
      GO TO 510
C --- FORMAT
160   IF (NUMST .GT. 0) THEN
C 
C --- PUT STRINGS BACK IN STATEMENT
C
          DO 165 IST = 1, NUMST
             CALL PUTSTR (IST)
165       CONTINUE
      ENDIF         
      IF (MOVE) THEN
         WRITE(NFORM) LENST, CLABEL, STMT(1:LENST)
         NFMTS = NFMTS + 1
         CALL GETSTM       
         GO TO 5
      ENDIF
      CALL DLIST
      GO TO 510
C --- COMPUTED GO TO
170   CALL DLIST
      I = INDEX(STMT,'GOTO(') + 5
C
C --- GET STATEMENT NUMBERS
C
175   CALL REFNUM (I,LABEL,NONE,LAST,LLST,RFONLY)
      IF (.NOT.NONE) THEN
         NLAB = NLAB + 1
         CALL RLIST(LABEL)
      ENDIF
      IF (LAST .EQ. ',') THEN
         I = LLST + 1
         GO TO 175
      ENDIF
      CALL RESTOR (2,2,LOC)
      IRP = INDEX(STMT,')') 
      CALL RESTOR (IRP,0,1)
      GO TO 510
C --- INFAMOUS GO TO
180   CALL DLIST
      I = INDEX(STMT,'GOTO') + 4
C
C --- GET STATEMENT NUMBER
C
      CALL REFNUM (I,LABEL,NONE,LAST,LLST,RFONLY)
      IF (.NOT. NONE) THEN
          NLAB = NLAB + 1
          CALL RLIST (LABEL)
      ENDIF
      CALL RESTOR(2,2,LOC)
      IF (LOGIF) THEN
         CALL SPLOG (NADDED)
         IF (NADDED .GT. 0) LOC = LOC + NADDED
      ENDIF
      GO TO 510
C --- IMPLICIT
190   CALL RESTOR(8,0,1)
      GO TO 510
C --- INCLUDE
200   IF (ADD) THEN
         CALL PUTSTR(1)
         CALL ADDCODE
         CALL GETSTM
         GO TO 5
      ELSE
         CALL RESTOR(7,0,1)
      ENDIF
      GO TO 510
C --- INTEGER
210   IF (.NOT. STRUC) CALL RESTOR (7,0,1)
      GO TO 510
C --- INTRINSIC
220   CALL RESTOR (9,0,1)
      GO TO 510
C --- LOGICAL
230   IF (.NOT. STRUC) CALL RESTOR (7,0,1)
      GO TO 510
C --- NAMELIST
240   IF (.NOT. STRUC) CALL RESTOR (8,0,1)
      GO TO 510
C --- PAUSE
250   CALL DLIST
      CALL RESTOR(5,0,LOC)
      IF (LOGIF) THEN
         CALL SPLOG (NADDED)
         IF (NADDED .GT. 0) LOC = LOC + NADDED
      ENDIF
      GO TO 510
C --- PRINT
260   CALL DLIST
C --- GET FORMAT REFERENCE, IF ANY
      I = INDEX(STMT,'PRINT') + 5
      CALL REFNUM (I,LAB,NONE,LAST,LLST,RFONLY)
      IF (.NOT. NONE) THEN
         CALL RLIST (LAB) 
         NLAB = NLAB + 1
      ENDIF
      CALL RESTOR(5,0,LOC)
      CALL SPLOG (NADDED)
      GO TO 510
C --- PROGRAM 
C --- GET PROGRAM NAME
270   CALL NAMEX (SUBNAM)
      CALL RESTOR (7,0,1)
      GO TO 510
C --- REAL
280   IF (.NOT. STRUC) CALL RESTOR (4,0,1)
      GO TO 510
C --- RETURN
290   CALL DLIST
      IF (LOGIF) THEN
         CALL RESTOR(6,0,LOC)
         CALL SPLOG (NADDED)
         IF (NADDED .GT. 0) LOC = LOC + NADDED
      ENDIF
      GO TO 510
C --- SAVE
300   CALL RESTOR (4,0,1)
      GO TO 510
C --- STOP
310   CALL DLIST
      IF (LOGIF) THEN
         CALL RESTOR(4,0,LOC)
         CALL SPLOG (NADDED)
         IF (NADDED .GT. 0) LOC = LOC + NADDED
      ENDIF
      GO TO 510
C --- SUBROUTINE
C --- GET SUBROUTINE NAME 
320   CALL NAMEX (SUBNAM)
C --- GET ARGUMENT NAMES FOR PROLOGUE
      IF (PROLOG) CALL ARGEX
      CALL RESTOR(10,0,1)
C --- SPACE ARGUMENTS
      IF (ARG) THEN
         CALL ARGMNT
      ELSE
         L = LENGTH(SUBNAM) + 11
         CALL RESTOR(L,0,1)
      ENDIF
      GO TO 510
C --- TYPE
330   CALL DLIST
C --- GET FORMAT REFERENCE, IF ANY
      I = INDEX(STMT,'TYPE') + 4
      CALL REFNUM (I,LAB,NONE,LAST,LLST,RFONLY)
      IF (.NOT. NONE) THEN
         CALL RLIST (LAB)
         NLAB = 1
      ENDIF
      CALL RESTOR(4,0,LOC)
      CALL SPLOG (NADDED)
      GO TO 510 
C --- END STATEMENT; CHECK FOR FORMATS TO MOVE
340   IF ((MOVE) .AND. (NFMTS .GT. 0)) THEN
C 
C --- MOVE FORMATS
C
          REWIND(NFORM)
          DO 345 I = 1,NFMTS
             READ(NFORM) LENST, CLABEL, STMT(1:LENST)
             NLAB = 0
             ITYPE = 16
             LOGIF = .FALSE.
             CALL DLIST
             WRITE (NTEMP) ITYPE, LENST, CLABEL, STMT(1:LENST), NLAB,
     $                     LOGIF
345       CONTINUE
C              
C --- REBUILD END STATEMENT
C
          STMT = 'END'
          LENST = 3
          ITYPE = 34
          CLABEL = ' '
      ENDIF
      WRITE(NTEMP) ITYPE, LENST, CLABEL, STMT(1:LENST), NLAB, LOGIF
      RETURN
C --- OPEN
350   LW = 4
      GO TO 405
C --- CLOSE
360   LW = 5
      GO TO 405
C --- INQUIRE              
370   LW = 7
      GO TO 405
C --- BACKSPACE
380   LW = 9
      GO TO 405
C --- ENDFILE                
390   LW = 7
      GO TO 405
C --- REWIND   
400   LW = 6
405   CALL DLIST
C             
C --- GET REFERENCED STATEMENT NUMBER (IF ANY)
C 
      I = INDEX(STMT,'ERR=') + 4
      IF (I .NE. 4) THEN
         CALL REFNUM(I, LAB, NONE,LAST,LLST,RFONLY)
         IF (.NOT. NONE) CALL RLIST (LAB)
         NLAB = 1
      ENDIF
C
C --- GET FILE REFERENCES ( IF ANY )
C
      IF (PROLOG) CALL GETFIL 
      CALL RESTOR(LW,0,LOC)
      IF (LOGIF) THEN
         CALL SPLOG (NADDED)
         IF (NADDED .GT. 0) LOC = LOC + NADDED
      ENDIF
      GO TO 510
C --- READ
410   CALL DLIST
      CALL GETNUM (NLAB)
      IF (PROLOG) CALL GETFIL
      CALL RESTOR (4,0,LOC)
      IF (LOGIF) THEN
         CALL SPLOG (NADDED)
         IF (NADDED .GT. 0) LOC = LOC + NADDED
      ENDIF
      CALL SPARG (LOC)
      GO TO 510
C --- WRITE
420   CALL DLIST
      CALL GETNUM (NLAB)
      IF (PROLOG) CALL GETFIL 
      CALL SPARG (LOC)
      CALL RESTOR (5,0,LOC)
      CALL SPLOG (NADDED)
      GO TO 510
C --- PARAMETER
430   GO TO 510
C --- DATA
440   L2 = INDEX(STMT,'/') - 5
      CALL RESTOR(4,L2,1)
      GO TO 510
C --- FUNCTION
C --- GET FUNCTION NAME 
450   CALL NAMEX (SUBNAM)
      IF (PROLOG) CALL ARGEX 
      L = INDEX(STMT,'FUNCTION')
      CALL RESTOR (8,0,L)
      IF (ARG) CALL ARGMNT
      GO TO 510
C --- DO LOOP
460   CALL DLIST
      CALL RESTOR(2,0,1)
      I = INDEX(STMT,'=')
      CALL RESTOR(I-1,1,1)
      NLAB = 1
      GO TO 510
C --- IF THEN
470   CALL DLIST
      L = LENST - 6
      CALL RESTOR(2,L,1)
      CALL SPLOG (NADDED)
      GO TO 510
C --- ARITHMETIC IF
480   CALL DLIST
C 
C --- GET STATEMENT NUMBERS
C
      I = INDEX(STMT,'IF(') + 2
      NEST = 1         
485   I = I + 1
      IF (STMT(I:I) .EQ. '(') THEN
         NEST = NEST + 1
      ELSE IF (STMT(I:I) .EQ. ')') THEN
         NEST = NEST - 1
         IF (NEST .EQ. 0) GO TO 487
      ENDIF
      GO TO 485
487   CALL RESTOR (I,0,1)
      I = I + 2
      DO 489 II = 1,3
         CALL REFNUM (I,LABEL,NONE,LAST,LLST,RFONLY)
         IF (.NOT.NONE) CALL RLIST(LABEL)
         I = LLST + 1
489   CONTINUE
      NLAB = 3
      CALL RESTOR (2,0,1)
      GO TO 510
C--- ASSIGNMENT STATEMENT 
490   CALL DLIST
      IF (LOGIF) CALL RESTOR (LOC-1,0,1)
      I = INDEX(STMT,'=')
      IF (I .NE. 0) THEN 
          CALL SPASGN (I)
          CALL RESTOR(1,0,I)
          IF ((ALIGN).AND.(.NOT.LOGIF)) CALL LINEUP (I)
      ENDIF
      CALL SPLOG (NADDED)
      GO TO 510
C---ILLEGAL STATEMENT 
500   IF (WARN) WRITE(NWARN,940) SUBNAM, STMT(1:72)
C
C --- PUT CHARACTER STRINGS (IF ANY) BACK INTO THE STATEMENT
C
510   IF (NUMST .GT. 0) THEN
         DO 515 II = 1, NUMST
           CALL PUTSTR (II)
515      CONTINUE
      ENDIF
C              
C --- WRITE THE STATEMENT TO THE TEMPORARY FILE
C
      WRITE (NTEMP) ITYPE, LENST, CLABEL, STMT(1:LENST), NLAB, LOGIF
C     
C --- GET NEXT STATEMENT
C
      CALL GETSTM
      GO TO 5
900   FORMAT (I5)
910   FORMAT (' ********** WARNING -- ',/,
     $ 12X,'Un-numbered CONTINUE was deleted in subprogram ',A)
920   FORMAT (' ********** WARNING -- ',/,
     $ 12X,'Number of CALL statements exceeds maximum for prologues',/,
     $ 12X,'in subprogram ',A)
930   FORMAT (' ********** WARNING -- ',/,
     $ 12X,'Number of COMMON blocks exceeds maximum for prologues',/,
     $ 12X,'in subprogram ',A)               
940   FORMAT (' ********** WARNING --- ',/,
     $ 12X,'ILLEGAL STATEMENT in subprogram ',A,/,12X,A)
      END
C
C---END PROSUB
C
      SUBROUTINE GETSTM
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          GETSTM           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          GET STATEMENT                           
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS219-1                                 
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415)604-5578                           
C*
C*     PURPOSE :
C*          GET THE NEXT ENTIRE FORTRAN STATEMENT FROM THE SOURCE FILE, 
C*          REPLACING HOLLERITH FIELDS WITH TEXT STRINGS, REMOVING 
C*          TEXT STRINGS, AND CAPITALIZING WHERE NECESSARY
C*
C*     COMMON BLOCKS :
C*          OPTIONS, STATMT, FILES, STUB, TEXT
C*
C*     FILE REFERENCES :
C*          NWARN
C*
C*     SUBPROGRAM REFERENCES :
C*          NOPRO, LENGTH, GETCRD, CHKHOL, ENDUP
C*
C*     ERROR PROCESSING :
C*          JOB WILL BE TERMINATED IF STATEMENT EXCEEDS MAXIMUM LENGTH
C*
C*     ASSUMPTIONS AND RESTRICTIONS :
C*          MAXIMUM STATEMENT LENGTH IS 1520 CHARACTERS
C*    
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     13-NOV-86 
C*
C*     CHANGE HISTORY :
C*          29-JAN-87    MODIFIED TO BETTER HANDLE TEXT STRINGS
C*          13-NOV-86    INITIAL VERSION
C*
C***********************************************************************
C*                        
      PARAMETER (MXSTLN=1520,MXSTRGS=200,MXNAME=20,MXCALLS=400,MXFIL=10,
     $           MXCOMS=100,MXARG=50,MXINC=10,MXAUTH=10)
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      COMMON / TEXT / STRINGS, NUMST, CREP
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      CHARACTER *(MXSTLN) STMT, TSTM, STRINGS(MXSTRGS)
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *40 AUTHOR
      CHARACTER *5 CLABEL
      CHARACTER *4 CREP
      CHARACTER *1 CONCHR, CMTCHR
      LOGICAL CONT, EOF, LOGIF, TOMANY, STAT, ADD, ALIGN, ARG, COMM,
     $        INDENT, MOVE, PROLOG, RENUM, STRUC, WARN, EXEM, POINT, 
     $        FND
      DATA CREP /'C_$$'/              
C
C --- CHECK FOR EXEMPT
C
      IF (EXEM) THEN
         CALL NOPRO
         EXEM = .FALSE.
      ENDIF
C
      STMT = ' '
      TSTM = ' '
      NUMST = 0
      IPTR = 1
      JPTR = 0
C
C --- GET STATEMENT LABEL
C
      CLABEL = CARD(1:5)
C
C --- COPY ALL CHARACTERS INTO TSTM
C
10    LEN = LENGTH(CARD)
      DO 20 I = 7, LEN 
         JPTR = JPTR + 1
         IF (JPTR .GT. MXSTLN) GO TO 100
         TSTM(JPTR:JPTR) = CARD(I:I)
20    CONTINUE
C
C --- CONTINUE COPYING IF THERE'S A CONTINUATION CARD
C     
      CALL GETCRD
      IF (CONT) GO TO 10
      LENTST = JPTR 
C
C --- DO HOLLERITH CHECKING AND CONVERSION
C
      IF ((INDEX(TSTM(1:LENTST),'H') .NE. 0) .OR.
     $    (INDEX(TSTM(1:LENTST),'h') .NE. 0)) THEN
           CALL CHKHOL (TSTM, LENTST, FND)
           IF ((FND).AND.(WARN)) WRITE(NWARN,920) SUBNAM
      ENDIF
C
C --- RE-READ STATEMENT, STORING AND REPLACING ALL CHARACTER STRINGS 
C --- WITH A DUMMY VARIABLE
C
      I = 0
30    I = I + 1
      IF ((TSTM(I:I) .NE. '''') .AND. (TSTM(I:I) .NE.' ')) THEN
          CALL CAPITAL (TSTM(I:I))
          STMT(IPTR:IPTR) = TSTM(I:I)
          IPTR = IPTR + 1
       ELSE IF (TSTM(I:I) .EQ. '''') THEN
C
C --- CHARACTER STRING BEGINS HERE
C
          ISP   = 1
          IF (NUMST .GT. MXSTRGS) GO TO 200
          NUMST = NUMST + 1
C
C --- INSERT THE DUMMY VARIABLE INTO THE STATEMENT
C
          STMT(IPTR:IPTR+3) = CREP
          IPTR = IPTR + 4
          NSTART = I
40        I = I + 1
          ISP = ISP + 1 
C
C --- COPY THE CHARACTER STRING INTO THE BUFFER
C
         IF (TSTM(I:I) .EQ. '''') THEN
C
C --- CHECK FOR EMBEDDED QUOTE
C
            IF (TSTM(I+1:I+1) .EQ. '''') THEN
               I = I + 1
               ISP = ISP + 1
               IF (I .LT. LENTST) GO TO 40
            ENDIF
C
C --- THIS IS THE END OF THE STRING, COPY INTO BUFFER
C
            STRINGS(NUMST) = ' '
            STRINGS(NUMST)(1:ISP) = TSTM(NSTART:I)
            GO TO 30
         ENDIF
         IF (I .LT. LENTST) GO TO 40
      ENDIF
      IF (I .LT. LENTST) GO TO 30
      LENST = IPTR - 1
      RETURN 
100   WRITE(NWARN,900) STMT(1:72),SUBNAM
      CALL ENDUP (STAT)
200   WRITE(NWARN,910) STMT(1:72),SUBNAM
      CALL ENDUP (STAT)
900   FORMAT(' ********** FATAL ERROR - ',/
     $ ' STATEMENT LENGTH EXCEEDS DIMENSIONS ',/
     $ A72,/,' IN SUBPROGRAM ',A,' - JOB TERMINATED.')
910   FORMAT(' ********** FATAL ERROR - TOO MANY STRINGS IN STATEMENT ',
     $ /,A72,/,' IN SUBPROGRAM ',A,' - JOB TERMINATED.')
920   FORMAT(' ***** HOLLERITH FIELD REPLACED WITH STRING',/,
     $       '       IN SUBPROGRAM ',A)
      END 
C
C---END GETSTM
C
      SUBROUTINE CHKHOL (TSTM, LENTST, FOUND)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          CHKHOL           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          CHECK HOLLERITH                            
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          CHECK FORTRAN STATEMENT FOR HOLLERITH FIELDS AND STRINGS.
C*
C*     INPUT ARGUMENTS :
C*          TSTM - FORTRAN STATEMENT WITH POTENTIAL HOLLERITHS
C*          LENTST - LENGTH OF THE STATEMENT
C*
C*     SUBPROGRAM REFERENCES :
C*          DOHOLL, RIGHT
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     11-DEC-86 
C*
C*     CHANGE HISTORY :
C*          11-DEC-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXSTLN=1520)
      CHARACTER *(MXSTLN) TSTM
      CHARACTER *5 CNUM
      CHARACTER *1 SPCHR(7)
      DATA SPCHR / '=', ',', '(', '/', ')', '+', '-'/
      LOGICAL DIG, FOUND
C
C --- FIND FIRST SPECIAL CHARACTER IN STATEMENT 
C
      FOUND = .FALSE.
      DO 10 I = 1, LENTST
         DO 15 J = 1,7
            IF (TSTM(I:I) .EQ. SPCHR(J)) GO TO 40
15       CONTINUE
10    CONTINUE        
C
C --- NO SPECIAL CHARACTER, NO HOLLERITH - EXIT           
C
      GO TO 100
C
C --- WE HAVE FIRST SPECIAL CHARACTER, START CHECKING FOR HOLLERITHS
C
40    ITPTR = I
43    ITPTR = ITPTR + 1            
      IF ((TSTM(ITPTR:ITPTR) .EQ. 'H') .OR. 
     $    (TSTM(ITPTR:ITPTR) .EQ. 'h')) THEN
C
C --- WE HAVE AN 'H', LOOK FOR PRECEDING DIGITS OR BLANKS
C
          DIG = .FALSE.
          NDIG = 0
          LOCH = ITPTR
          LBH = ITPTR
45        LBH = LBH - 1
          IF (TSTM(LBH:LBH) .EQ. ' ') GO TO 45
          IF ((TSTM(LBH:LBH) .GE. '0').AND.(TSTM(LBH:LBH) .LE. '9'))
     $        THEN
C
C --- WE HAVE AN 'H', PRECEDED BY A DIGIT. LOOK FOR MORE PRECEEDING
C DIGITS.
C
               IF (.NOT.DIG) DIG = .TRUE.
               LOCD = LBH
               NDIG = NDIG + 1
               GO TO 45
          ENDIF
          IF (DIG) THEN
C
C --- LOOK FOR SPECIAL CHARACTER PRECEDING THE DIGITS
C
              DO 50 J = 1,8
                  IF (TSTM(LBH:LBH) .EQ. SPCHR(J)) GO TO 55
50             CONTINUE
            ENDIF
            GO TO 60
C
C --- WE HAVE A 'H', PRECEDED BY ONE OR MORE DIGITS, PRECEDED BY
C --- A SPECIAL CHAR;  GET NUMBER OF HOLLERITH CHARACTERS
C 
55          IL = LOCD + NDIG - 1
            CNUM = TSTM(LOCD:IL)
            CALL RIGHT (CNUM)
            READ (CNUM,900) NUM
C
C --- REPLACE HOLLERITH STRING WITH CHARACTER STRING
C
            IF (.NOT. FOUND) FOUND = .TRUE.
            CALL DOHOLL(TSTM, LOCH, LOCD, NUM, LENTST)
            ITPTR = ITPTR + NUM
         ENDIF
60    IF (ITPTR .LT. LENTST) GO TO 43
100   RETURN
900   FORMAT(I5)
      END
C
C---END CHKHOL
C                            
      SUBROUTINE DOHOLL (STRING, LH, LD, NUM, LEN)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          DOHOLL           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          DO HOLLERITH                            
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415)604-5578                           
C*
C*     PURPOSE :
C*          REPLACE A HOLLERITH CONSTANT WITH THE APPROPRIATE           
C*          CHARACTER STRING                                            
C*
C*     INPUT ARGUMENTS :
C*          STRING - THE STRING CONTAINING THE HOLLERITH
C*          LH     - LOCATION OF 'H' IN THE STRING
C*          LD     - LOCATION OF THE FIRST DIGIT IN THE HOLLERITH
C*          NUM    - THE NUMBER OF HOLLERITH CHARACTERS
C*          LEN    - THE LENGTH OF THE STRING
C*
C*     OUTPUT ARGUMENTS :
C*          STRING - THE STRING WITH THE HOLLERITH REPLACED
C*
C*     INTERNAL WORK AREAS :
C*          WORK - TEMPORARY VARIABLE USED TO BUILD NEW STRING
C*
C*     SUBPROGRAM REFERENCES :
C*          LENGTH
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     12-DEC-86 
C*
C*     CHANGE HISTORY :
C*          30-NOV-87    MODIFIED TO PROPERLY REPLACE SINGLE QUOTES
C*          12-DEC-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXSTLN=1520)
      CHARACTER *(*) STRING
      CHARACTER *(MXSTLN) WORK
C
      WORK  = ' '
      NCOPY = 0
C
C --- COPY STRING UP TO 'H'
C
      LBH = LD - 1
      IWK = LBH
      WORK(1:IWK) = STRING(1:LBH)
C
C --- SKIP 'H' AND DIGITS IN STRING
C
      LBH = LBH + (LH - LBH + 1)
      IWK = IWK + 1
C
C --- PUT IN A SINGLE QUOTE
C
      WORK(IWK:IWK) = ''''
      IWK = IWK + 1
C
C --- COPY CHARACTERS FROM STRING TO WORK, ONE AT A TIME,
C --- CHECKING FOR SINGLE QUOTES WITHIN THE HOLLERITH FIELD.
C
10    IF (STRING(LBH:LBH) .EQ. '''') THEN
C
C --- SINGLE QUOTES MUST BE REPLACED WITH 2 SINGLE QUOTES FOR
C --- FORTRAN CHARACTER STRING
C
         WORK(IWK:IWK+1) = ''''''
         IWK = IWK + 2
      ELSE
         WORK(IWK:IWK) = STRING(LBH:LBH)
         IWK = IWK + 1
      ENDIF
      LBH = LBH + 1
      NCOPY = NCOPY + 1
      IF (NCOPY .LT. NUM) GO TO 10
C                           
C --- PUT IN ANOTHER SINGLE QUOTE
C
      WORK(IWK:IWK) = ''''
      IWK = IWK + 1   
C
C --- COPY REMAINING STRING INTO WORK
C
      WORK(IWK:) = STRING(LBH:LEN)
      LEN = LENGTH(WORK)
      STRING(1:LEN) = WORK(1:LEN)
      RETURN               
      END
C
C---END DOHOLL
C
      SUBROUTINE CATEG
C* 
C*                  ******************************* 
C*                  ******************************* 
C*                  **                           ** 
C*                  **           CATEG           ** 
C*                  **                           ** 
C*                  ******************************* 
C*                  ******************************* 
C* 
C*     SUBPROGRAM : 
C*          CATEGORIZE
C* 
C*     AUTHOR : 
C*          LAURA JURGELEIT
C*          MS 219-1 
C*          AMES RESEARCH CENTER 
C*          MOFFETT FIELD, CALIF 94035 
C*          (415)965-5578 
C* 
C*     PURPOSE : 
C*          CATEGORIZE THIS STATEMENT
C* 
C*     COMMON BLOCKS : 
C*          STATMT, OPTIONS
C* 
C*     SUBPROGRAM REFERENCES : 
C*          INDEX, LENGTH, ISKEY, CHKEQ, RESTOR, VRFYDO, RLIST, CATIF,
C*          FASSUR
C* 
C*     LANGUAGE AND COMPILER : 
C*          ANSI FORTRAN 77
C* 
C*     VERSION AND DATE : 
C*          VERSION I.0     11/18/86
C* 
C*     CHANGE HISTORY : 
C*          11/18/86     INITIAL VERSION 
C* 
C***********************************************************************
C* 
C                           CURRENT TYPES
C                           -------------
C
C            1.   ASSIGN                        26.   PRINT
C            2.   BLOCK DATA                    27.   PROGRAM
C            3.   CALL                          28.   REAL
C            4.   CHARACTER                     29.   RETURN
C            5.   COMMON                        30.   SAVE
C            6.   COMPLEX                       31.   STOP
C            7.   CONTINUE                      32.   SUBROUTINE
C            8.   DIMENSION                     33.   TYPE
C            9.   DOUBLE PRECISION              34.   END
C           10.   ELSE IF                       35.   OPEN
C           11.   ELSE                          36.   CLOSE
C           12.   END IF                        37.   INQUIRE
C           13.   ENTRY                         38.   BACKSPACE
C           14.   EQUIVALENCE                   39.   ENDFILE
C           15.   EXTERNAL                      40.   REWIND
C           16.   FORMAT                        41.   READ(
C           17.   GO TO (computed)              42.   WRITE(
C           18.   GO TO (infamous)              43.   PARAMETER
C           19.   IMPLICIT                      44.   DATA
C           20.   INCLUDE                       45.   FUNCTION
C           21.   INTEGER                       46.   DO
C           22.   INTRINSIC                     47.   IF ( ) THEN
C           23.   LOGICAL                       48.   ARITHMETIC IF
C           24.   NAMELIST                      49.   ASSIGNMENT
C           25.   PAUSE                         50.   ILLEGAL STATEMENT
C                       51.  COMMENT (TYPED IN GETCRD)
C
      PARAMETER (NKYWDS=33,MXSTLN=1520,MXINC=10)
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      LOGICAL ADD, ALIGN, ARG, COMM, INDENT, MOVE, PROLOG, RENUM, 
     $        STRUC, WARN, CONT, EOF, LOGIF, IS, ISDO, FASSUR, EXEM,
     $        POINT
      CHARACTER *(MXSTLN) STMT, WORK
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *10 KEYWDS(NKYWDS)          
      CHARACTER *5 CLABEL
      CHARACTER *1 CONCHR, CMTCHR
      DATA KEYWDS /  'ASSIGN    ', 'BLOCKDATA ', 'CALL      ', 
     $ 'CHARACTER ', 'COMMON    ', 'COMPLEX   ', 'CONTINUE  ',
     $ 'DIMENSION ', 'DOUBLEPREC', 'ELSEIF(   ', 'ELSE      ',
     $ 'ENDIF     ', 'ENTRY     ', 'EQUIVALENC', 'EXTERNAL  ',
     $ 'FORMAT    ', 'GOTO(     ', 'GOTO      ', 'IMPLICIT  ',
     $ 'INCLUDE   ', 'INTEGER   ', 'INTRINSIC ', 'LOGICAL   ',
     $ 'NAMELIST  ', 'PAUSE     ', 'PRINT     ', 'PROGRAM   ',
     $ 'REAL      ', 'RETURN    ', 'SAVE      ', 'STOP      ',
     $ 'SUBROUTINE', 'TYPE      ' /      
C            
C --- COPY STMT INTO WORK
C
      WORK = STMT(1:LENST)
      LENWK = LENST
      LOGIF = .FALSE.
C
C --- CATEGORIZE FUNCTION STATEMENTS BEFORE SPECIFICATION STATEMENTS
C
      IF (INDEX(WORK,'FUNCTION') .NE. 0) THEN
         IF (FASSUR(WORK)) THEN
            ITYPE = NKYWDS + 12
            RETURN
         ENDIF
      ENDIF
C
C --- KEYWORDS THAT DO NOT USE '='
C
7     DO 20 I = 1,NKYWDS
         LEN = LENGTH (KEYWDS(I))
         IF ( (WORK(1:LEN) .EQ. KEYWDS(I) (1:LEN)) .AND.
     $        (INDEX(WORK,'=') .EQ. 0) ) THEN 
            ITYPE = I
            RETURN
         ENDIF 
20    CONTINUE
C
C --- OTHER KEYWORDS
C
      IF (WORK(1:4) .EQ. 'END ') THEN
         ITYPE = NKYWDS + 1
         RETURN
      ELSE IF (WORK(1:5) .EQ. 'OPEN(') THEN
         NST = 6
         CALL ISKEY(WORK,LENWK,NST,IS) 
         IF (IS) THEN 
            ITYPE = NKYWDS + 2
            RETURN
         ENDIF
      ELSE IF (WORK(1:6) .EQ. 'CLOSE(') THEN
         NST = 7
         CALL ISKEY(WORK,LENWK,NST,IS)
         IF (IS) THEN
            ITYPE = NKYWDS + 3
            RETURN
         ENDIF
      ELSE IF (WORK(1:8) .EQ. 'INQUIRE(') THEN
         NST = 9
         CALL ISKEY(WORK,LENWK,NST,IS)
         IF (IS) THEN
            ITYPE = NKYWDS + 4
            RETURN
         ENDIF
      ELSE IF (WORK(1:9) .EQ. 'BACKSPACE')  THEN
         NST = INDEX(WORK,'BACKSPACE(') + 10
         CALL ISKEY(WORK,LENWK,NST,IS)
         IF (IS) THEN
            ITYPE = NKYWDS + 5
            RETURN
         ENDIF
      ELSE IF (WORK(1:7) .EQ. 'ENDFILE')  THEN
         NST = INDEX(WORK,'ENDFILE(') + 8
         CALL ISKEY(WORK,LENWK,NST,IS)
         IF (IS) THEN
            ITYPE = NKYWDS + 6
            RETURN
         ENDIF
      ELSE IF (WORK(1:6) .EQ. 'REWIND') THEN
         NST = INDEX(WORK,'REWIND(') + 7
         CALL ISKEY(WORK,LENWK,NST,IS)
         IF (IS) THEN
            ITYPE = NKYWDS + 7
            RETURN
         ENDIF 
C
C --- FOR READ AND WRITE, CHECK FOR '='. IF FOUND, IT MUST BE INSIDE
C --- PARENS IN ORDER TO BE THE KEYWORD
C
      ELSE IF (WORK(1:5) .EQ. 'READ(') THEN
         LE = INDEX(WORK,'=')
         NST = 6
         CALL CHKEQ (WORK,LENWK,NST,LE,IS,LOC1ST)
         IF (IS) THEN
             ITYPE = NKYWDS + 8
             IF (LOGIF) LOC1ST = LOC1ST + ISTART - 1
             CALL RESTOR(LOC1ST,0,1)
             RETURN
         ENDIF
      ELSE IF (WORK(1:6) .EQ. 'WRITE(') THEN
         LE = INDEX(WORK,'=')
         NST = 7
         CALL CHKEQ(WORK,LENWK,NST,LE,IS,LOC1ST)
         IF (IS) THEN
            ITYPE = NKYWDS + 9
            IF (LOGIF)  LOC1ST = LOC1ST + ISTART - 1
            CALL RESTOR(LOC1ST,0,1)
            RETURN 
         ENDIF
      ELSE IF (WORK(1:10) .EQ. 'PARAMETER(') THEN
         NST = 10                      
         CALL ISKEY(WORK,LENST,NST,IS)
         IF (IS) THEN
            ITYPE = NKYWDS + 10
            RETURN
         ENDIF
      ELSE IF (WORK(1:4) .EQ. 'DATA') THEN
         ISL = INDEX(WORK,'/') 
         IF (ISL .NE. 0) THEN
            IF (WORK(ISL:ISL+1) .NE. '/') THEN
               ITYPE = NKYWDS + 11
               RETURN
            ENDIF
         ENDIF
      ELSE IF (WORK(1:2) .EQ. 'DO') THEN
         CALL VRFYDO (ISDO,LABEL,LL)
         IF (ISDO) THEN
            ITYPE = NKYWDS + 13
            CALL RLIST (LABEL)
            IF (.NOT. RENUM) CALL RESTOR (LL-1,0,1)
            RETURN
         ENDIF 
      ELSE IF (WORK(1:3) .EQ. 'IF(') THEN
         CALL CATIF (WORK, LENWK, ITYP, N)   
         IF (ITYP .EQ. 1) THEN 
C
C --- LOGICAL IF, CATEGORIZE THE STATEMENT FOLLOWING
C
            LOGIF = .TRUE.
            ISTART = N 
            WORK = WORK(N:LENWK)
            LENWK = LENWK - N + 1
            GO TO 7            
         ELSE IF (ITYP .EQ. 2) THEN
C
C --- IF - THEN
C
            ITYPE = NKYWDS + 14
            RETURN             
         ELSE IF (ITYP .EQ. 3) THEN
C
C --- ARITHMETIC IF
C
            ITYPE = NKYWDS + 15  
            RETURN             
         ENDIF                 
      ENDIF                   
C
C --- ALL STATEMENTS HAVE BEEN CATEGORIZED
C --- CHECK FOR AN ASSIGNMENT STATEMENT 
C
      IEQ = INDEX(WORK,'=')
      IF (IEQ .NE. 0) THEN
         IP = INDEX(WORK,'(') + 1
         IF (IP .EQ. 1) THEN
            ITYPE = NKYWDS + 16
            RETURN
         ELSE
            CALL CHKEQ (WORK, LENWK, IP, IEQ, IS, IDUM)
            IF (.NOT. IS) THEN
               ITYPE = NKYWDS + 16
               RETURN
            ENDIF
         ENDIF
      ENDIF
C
C --- STATEMENT IS NOT AN ASSIGNMENT STATEMENT, MUST BE ILLEGAL
C
      ITYPE = NKYWDS + 17
      RETURN                   
      END
C                              
C---END CATEG            
C 
      SUBROUTINE ISKEY (STRING,LEN,NSTART,KEY)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          ISKEY            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          IS KEYWORD? 
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          VERIFY THAT POTENTIAL KEYWORD IS, IN FACT, THE
C*          KEYWORD FOR FILE PROCESSING STATEMENTS
C*
C*     INPUT ARGUMENTS :
C*          STRING - STATEMENT CONTAINING THE POTENTIAL KEYWORD
C*          LEN    - LENGTH OF THE STRING
C*          NSTART - POSITION IN STRING TO START SEARCHING
C*
C*     OUTPUT ARGUMENTS :
C*          KEY = TRUE IF POTENTIAL KEYWORD IS THE KEYWORD, 
C*                  FALSE OTHERWISE
C*
C*     SUBPROGRAM REFERENCES :
C*          INDEX
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     21-NOV-86 
C*
C*     CHANGE HISTORY :
C*          21-NOV-86    INITIAL VERSION
C*
C***********************************************************************
C*
      CHARACTER*(*) STRING
      LOGICAL KEY
C
      KEY = .FALSE.
C
C --- CHECK FOR '=' SIGN
C
      IEQ = INDEX(STRING,'=')
      IF (IEQ .EQ. 0) THEN
C
C --- IF NO '=', KEYWORD FOUND
C
         KEY = .TRUE.
         RETURN
      ENDIF
C        
C --- CHECK FOR '=' INSIDE PARENS
C
      NEST = 1
      DO 10 IND = NSTART,LEN
         IF (STRING(IND:IND) .EQ. '(') THEN
            NEST = NEST + 1
         ELSE IF (STRING(IND:IND) .EQ. ')') THEN
            IF (NEST .GT. 0) THEN
               NEST = NEST - 1           
               IF (NEST .EQ. 0) GO TO 20
            ENDIF
         ENDIF
10    CONTINUE
C
C --- WE ARE NOW OUTSIDE PARENS, CHECK IF '=' IS ALSO 
C
20    IF (IND .GE. LEN) THEN
         KEY = .TRUE.
      ENDIF
      RETURN
      END                                             
C
C---END ISKEY 
C
      SUBROUTINE CHKEQ (STRING, LEN, NSTART, LOCEQ, INSIDE, LO1STP)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          CHKEQ            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          CHECK EQUAL 
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          CHECK FOR NESTED EQUAL SIGN
C*
C*     INPUT ARGUMENTS :
C*          STRING - THE STRING TO CHECK
C*          LEN    - LENGTH OF STRING
C*          NSTART - LOCATION IN STRING TO START CHECKING
C*          LOCEQ  - LOCATION OF EQUAL SIGN IN THE STRING
C*
C*     OUTPUT ARGUMENTS :
C*          INSIDE - WAS EQUAL SIGN INSIDE PARENS?
C*          LO1STP - LOCATION OUTSIDE FIRST PARENTHESES
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     21-JAN-87 
C*
C*     CHANGE HISTORY :
C*          21-JAN-87    INITIAL VERSION
C*
C***********************************************************************
C*
      CHARACTER *(*) STRING
      LOGICAL INSIDE
C
      INSIDE = .TRUE.
      NEST = 1
C
C --- FIND LOCATION OUTSIDE 1ST PARENS FOR STATEMENT
C --- RESTORATION UPON RETURN
C
      DO 10 IND = NSTART, LEN
         IF (STRING(IND:IND) .EQ. '(') THEN
            NEST = NEST + 1
         ELSE IF (STRING(IND:IND) .EQ. ')') THEN
            IF (NEST .GT. 0) THEN
               NEST = NEST - 1
               IF (NEST .EQ. 0) GO TO 20
            ENDIF
         ENDIF
10    CONTINUE
C
C --- WE ARE NOW OUTSIDE 1ST PARENTHESES. CHECK IF EQUAL SIGN
C --- WAS INSIDE
C
20    LO1STP = IND
C
C --- CHECK FOR '=' BEFORE 1ST PARENS
C
      IF (LOCEQ .EQ. 0) RETURN
      IF (LOCEQ .LT. NSTART) THEN
         INSIDE = .FALSE.
         RETURN
      ENDIF
25    IF (LOCEQ .LT. IND) RETURN
      LOCP = IND
C
C --- FIND LOCATION OF NEXT PARENS, IF ANY
C
      NIND = INDEX(STRING(IND:LEN),'(')  
      IF (NIND .EQ. 0) THEN
         INSIDE = .FALSE.
         RETURN
      ELSE
         IND = NIND + LOCP - 1
         IF (LOCEQ .LT. IND) THEN
             INSIDE = .FALSE.
             RETURN
         ENDIF
      ENDIF
      NEST = 1
C
C --- GET OUT OF THESE PARENS AND CHECK IF '=' WAS INSIDE
C
40    IND = IND + 1
      IF (IND .GT. LEN) THEN
         INSIDE = .FALSE.
         RETURN
      ELSE IF (STRING(IND:IND) .EQ. '(') THEN
         NEST = NEST + 1
      ELSE IF (STRING(IND:IND) .EQ. ')') THEN
         NEST = NEST - 1
         IF (NEST .EQ. 0) GO TO 25
      ENDIF
      IF (IND .LT. LEN) GO TO 40
      RETURN
      END
C
C---END CHKEQ 
C
      LOGICAL FUNCTION FASSUR ( STRING )
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          FASSUR           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          ASSURE STATEMENT TYPE                   
C*
C*     AUTHOR :
C*          ART RAGOSTA                             
C*          MS 219-1                                
C*          AMES RESEARCH CENTER                    
C*          MOFFETT FIELD, CA  94035                
C*          (415) 965-5578                          
C*
C*     PURPOSE :
C*          TO ASSURE THAT THE INDEX OF THE STATEMENT KEYWORD WAS       
C*          NOT IN A LITERAL FIELD.                                     
C*
C*     METHODOLOGY :
C*          REMOVE SPACES AND CHECK FOR THE KEYWORD IN THE FIRST        
C*          COLUMNS OF THE RESULTING STRING.                            
C*
C*     INPUT ARGUMENTS :
C*          STRING - THE STATEMENT IDENTIFICATION STRING (EG,
C 'FUNCTION')
C*
C*     OUTPUT VALUE :
C*          TRUE IF THE STRING WAS FOUND FIRST IN THE STATEMENT...
C*           FALSE OTHERWISE.
C*
C*     INTERNAL WORK AREAS :
C*          WORK - HOLDS THE PACKED STRING
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     18-SEP-84 
C*
C*     CHANGE HISTORY :
C*          18-SEP-84    INITIAL VERSION
C*
C***********************************************************************
C*
      CHARACTER *(*) STRING
C
C --- CHECK TO SEE IF THE KEYWORD WAS FOUND
C
      FASSUR = .FALSE.
      IF ((STRING(1:4) .EQ. 'FUNC') .OR. (STRING(1:4) .EQ. 'LOGI') .OR.
     $    (STRING(1:4) .EQ. 'INTE') .OR. (STRING(1:4) .EQ. 'REAL') .OR.
     $    (STRING(1:4) .EQ. 'DOUB') .OR. (STRING(1:4) .EQ. 'COMP') .OR.
     $    (STRING(1:4) .EQ. 'CHAR')) FASSUR = .TRUE.
      RETURN
      END
C
C---END FASSUR
C
      SUBROUTINE VRFYDO (IS,NUM,LOCLAB)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **         VRFYDO            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          VERIFY DO
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (514) 604-5578                          
C*
C*     PURPOSE :
C*          VERIFY THAT THE STATEMENT CONTAINING 'DO' IS                
C*          A DO LOOP                                                   
C*
C*     OUTPUT ARGUMENTS :
C*          IS  - TRUE IF DO LOOP, FALSE OTHERWISE
C*          NUM - CONTAINS DO LOOP LABEL IF IS = TRUE
C*          LOCLAB - LOCATION OF THE DO LABEL
C*
C*     COMMON BLOCKS :
C*          OPTIONS, STATMT
C*
C*     SUBPROGRAM REFERENCES :
C*          REFNUM
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     24-NOV-86 
C*
C*     CHANGE HISTORY :
C*          24-NOV-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXSTLN=1520,MXINC=10)
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      CHARACTER *(MXSTLN) STMT
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *5 CLAB, CLABEL
      CHARACTER *1 LAST, CMTCHR, CONCHR
      LOGICAL ADD, ALIGN, ARG, COMM, INDENT, MOVE, PROLOG, RENUM, 
     $        STRUC, WARN, NO, IS, EOF, CONT, LOGIF, RFONLY, EXEM,
     $        POINT
C
      IF (RENUM) THEN   
         RFONLY = .FALSE.
      ELSE
         RFONLY = .TRUE.
      ENDIF
      IS   = .FALSE. 
C
C --- CHECK FOR DO LABEL
C
       CALL REFNUM (3,NUM,NO,LAST,I,RFONLY)
       IF (NO) RETURN
       LOCLAB = I
C
C --- HAVE LABEL, CHECK FOR OPTIONAL COMMA
C
      IF (STMT(I:I) .EQ. ',') THEN
         IS = .TRUE. 
         RETURN
      ENDIF
C
C --- NO OPTIONAL COMMA, CHECK FOR VARIABLE NAME
C
      IF ((STMT(I:I) .LT. 'A').OR.(STMT(I:I).GT.'Z')) RETURN
C
C --- FIRST CHARACTER IS ALPHABETIC, LOOK FOR MORE ALPHANUMERIC
C --- CHARACTERS, '$', '_' OR '='
C
40    I = I + 1
      IF (((STMT(I:I) .GE. 'A').AND.(STMT(I:I) .LE. 'Z')) .OR.
     $    ((STMT(I:I) .GE. '0').AND.(STMT(I:I) .LE. '9')) .OR.
     $    (STMT(I:I) .EQ. '$') .OR. (STMT(I:I) .EQ. '_'))  GO TO 40
      IF (STMT(I:I) .NE. '=') RETURN
C
C --- HAVE '=', LOOK FOR COMMA OUTSIDE PARENS
C
      I = I + 1
      NEST = 0
      DO 50 J = I,LENST
         IF (STMT(J:J) .EQ. ',') THEN
            IF (NEST .EQ. 0) THEN
C
C --- COMMA IS OUTSIDE OF PARENS
C
               IS = .TRUE.
            ENDIF
            RETURN
         ELSE IF (STMT(J:J) .EQ. '(') THEN
            NEST = NEST + 1
         ELSE IF (STMT(J:J) .EQ. ')') THEN
            NEST = NEST - 1
         ENDIF
50    CONTINUE 
C
C --- NO COMMA, NO DO LOOP
C
      RETURN
      END 
C
C---END VRFYDO
C
      SUBROUTINE CATIF (STRING, LSTRG, NTYPE, NLAST)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          CATIF            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          CATEGORIZE IF 
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          CATEGORIZE IF STATEMENT AS IF ( ) THEN, ARITHMETIC IF, OR
C*          IF ( ) LOGICAL
C*
C*     INPUT ARGUMENTS :
C*          STRING - STATEMENT CONTAINING POTENTIAL IF
C*          LSTRG  - LENGTH OF THE STRING
C*
C*     OUTPUT ARGUMENTS :
C*          NTYPE -  = 1 FOR LOGICAL IF
C*                   = 2 FOR IF ( ) THEN
C*                   = 3 FOR ARITHMETIC IF
C*          NLAST -  POSITION OF FIRST CHAR. OUTSIDE PARENS 
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0      3-DEC-86 
C*
C*     CHANGE HISTORY :
C*           3-DEC-86    INITIAL VERSION
C*
C***********************************************************************
C*
      CHARACTER *(*) STRING
C
      IND  = 3
      NEST = 1
C
C --- START CHECKING OUTSIDE PARENS
C
10    IND = IND + 1
      IF (STRING(IND:IND) .EQ. '(') THEN
         NEST = NEST + 1
      ELSE IF (STRING(IND:IND) .EQ. ')') THEN
         NEST = NEST - 1
         IF (NEST .EQ. 0) GO TO 20
      ENDIF
      GO TO 10
20    IND = IND + 1   
      NLAST = IND
C
C --- CHECK FOR 'THEN' AS LAST CHARACTERS IN STATEMENT
C
      IF ((STRING(IND:IND+3) .EQ. 'THEN').AND.(IND+3 .EQ. LSTRG)) THEN
         NTYPE = 2
      ELSE
C
C --- CHECK FOR STATMENT NUMBER
C
         IF ((STRING(IND:IND).LT.'0').OR.(STRING(IND:IND).GT.'9')) THEN
            NTYPE = 1
         ELSE 
            NTYPE = 3
         ENDIF
      ENDIF
      RETURN
      END
C
C---END CATIF 
C
      SUBROUTINE ADDCODE
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          ADDCODE          **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          ADD CODE                                
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          ADD THE CODE SPECIFIED BY 'INCLUDE' STATEMENTS TO THE       
C*          FILE BEING CLEANED UP                                       
C*
C*     COMMON BLOCKS :
C*          FILES, STATMT
C*
C*     FILE REFERENCES :
C*          NIN, NWARN
C*
C*     SUBPROGRAM REFERENCES :
C*          GETCRD, ENDUP
C*
C*     ERROR PROCESSING :
C*          PROGRAM WILL BE TERMINATED IF THERE ARE TOO MANY NESTED
C*          INCLUDES (I.E., AN INCLUDE WITHIN AN INCLUDED FILE....)
C*
C*     ASSUMPTIONS AND RESTRICTIONS :
C*          MAXIMUM OF 10 NESTED INCLUDES
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0      3-FEB-87 
C*
C*     CHANGE HISTORY :
C*           3-FEB-87    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXSTLN=1520,MXINC=10)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      CHARACTER *(MXSTLN) STMT
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *40 FNAME
      CHARACTER *5 CLABEL
      LOGICAL EOF, CONT, LOGIF, STAT
C
C --- GET NAME OF INCLUDE FILE
C
      I = INDEX(STMT,'''')+1
      J = I
10    J = J + 1
      IF (STMT(J:J) .NE. '''') GO TO 10
      FNAME = STMT(I:J-1)
      NIN = NIN + 1
      OPEN(UNIT=NIN,NAME=FNAME,STATUS='OLD',ERR=100)
C
C --- HOLD PRESENT CARD UNTIL AFTER INCLUDE FILE IS READ
C
      NTCRD = NTCRD + 1
      IF (NTCRD .GT. MXINC) GO TO 200
      TCARD(NTCRD) = CARD
      CALL GETCRD
      RETURN
100   WRITE(NWARN,900) FNAME
      RETURN
200   WRITE(NWARN,910) FNAME
      CALL ENDUP (STAT)
900   FORMAT(' ********** ERROR OPENING INCLUDE FILE ',A)
910   FORMAT(' ********** FATAL ERROR - TOO MANY NESTED INCLUDE FILES',/
     $ ' WITH FILE ',A,' JOB TERMINATED.')
      END    
C
C---END ADDCODE
C
      SUBROUTINE REFNUM (NSTART,ILAB,NOLAB,LSTCHR,LOCLST,REF)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          REFNUM           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          REFERENCED STATEMENT NUMBERS            
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          GET THE REFERENCED STATEMENT NUMBER FROM THE STATEMENT      
C*          CONTAINING IT
C*
C*     INPUT ARGUMENTS :
C*          NSTART - LOCATION OF START OF STATEMENT NUMBER
C*          REF    - FLAG THE REFERENCE FOR LATER RENUMBERING ?
C*          
C*     OUTPUT ARGUMENTS:
C*          ILAB   - CONTAINS THE REFERENCED NUMBER 
C*          NOLAB  - SET TO TRUE IF NO REFERENCED NUMBER WAS FOUND 
C*          LSTCHR - THE CHARACTER IMMEDIATELY FOLLOWING THE NUMBER
C*          LOCLST - LOCATION OF LSTCHR
C*
C*     COMMON BLOCKS :
C*          STATMT
C*
C*     SUBPROGRAM REFERENCES :
C*          RIGHT
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0      1-DEC-86 
C*
C*     CHANGE HISTORY :
C*           1-DEC-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXSTLN=1520,MXINC=10)
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      CHARACTER *(MXSTLN) STMT, DUMST
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *5 CLABEL, REFLAB
      CHARACTER *1 LSTCHR
      LOGICAL CONT, EOF, NOLAB, LOGIF, REF
C
      NOLAB = .FALSE.
      I = NSTART - 1
10    I = I + 1
        IF ((STMT(I:I) .LT. '0').OR.(STMT(I:I) .GT. '9')) GO TO 20
      GO TO 10
20    NEND = I - 1
      LSTCHR = STMT(I:I)
      LOCLST = I
      IF (NEND .LT. NSTART) GO TO 1000
      REFLAB = STMT(NSTART:NEND)
      CALL RIGHT (REFLAB)
      READ (REFLAB,900,ERR=1000) ILAB
      IF (.NOT.REF) THEN
C
C --- FLAG REFERENCE FOR LATER RENUMBERING
C
         DUMST = ' '
         IPTR = NSTART - 1
         DUMST(1:IPTR) = STMT(1:NSTART-1)
         IPTR = IPTR + 1
         DUMST(IPTR:IPTR+1) = '*#'
         IPTR = IPTR + 2
         DUMST(IPTR:) = STMT(NSTART:LENST)
         LOCLST = LOCLST + 2      
         STMT = DUMST
         LENST = LENST + 2
      ENDIF
      RETURN
1000  NOLAB = .TRUE.
      RETURN
900   FORMAT(I5)
      END
C
C---END REFNUM
C
      SUBROUTINE GETNUM (NLAB)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          GETNUM           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          GET STATEMENT NUMBER                    
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1                                
C*          NASA-Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          GET THE STATEMENT NUMBER(S) FROM A READ OR A WRITE          
C*          STATEMENT.                                                  
C*
C*     OUTPUT ARGUMENTS :
C*          NLAB - NUMBER OF LABELS FOUND
C*
C*     COMMON BLOCKS :
C*          STATMT, OPTIONS
C*
C*     SUBPROGRAM REFERENCES :
C*          INDEX, REFNUM, RLIST
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0      2-DEC-86 
C*
C*     CHANGE HISTORY :
C*           2-DEC-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXSTLN=1520,MXINC=10)
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      CHARACTER *(MXSTLN) STMT
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *5 CLABEL
      CHARACTER *1 LAST, CMTCHR, CONCHR
      LOGICAL ADD, ALIGN, ARG, COMM, INDENT, MOVE, PROLOG, RENUM, 
     $        STRUC, WARN, EOF, CONT, NONUM, LOGIF, RFONLY, EXEM,
     $        POINT
C
      IF (RENUM) THEN
         RFONLY = .FALSE.
      ELSE
         RFONLY = .TRUE.
      ENDIF
C
C --- CHECK FOR 'FMT='
C
      IBEGIN = INDEX(STMT,'FMT=') + 4
      IF (IBEGIN .NE. 4) THEN
         CALL REFNUM (IBEGIN,LAB,NONUM,LAST,LLST,RFONLY)
         IF (.NOT. NONUM) THEN
            CALL RLIST(LAB)
            NLAB = NLAB + 1
         ENDIF
      ELSE
C
C --- NO 'FMT=', GET THE LABEL AFTER THE FIRST ',' IN
C --- PARENS
C
         IF (LOGIF) THEN
            IP = INDEX(STMT(ISTART:LENST),'(') + ISTART
         ELSE
            IP = INDEX(STMT,'(')
         ENDIF
         NEST = 1
10       IP = IP + 1
         IF (STMT(IP:IP) .EQ. ',') THEN
            IF (NEST .EQ. 1) GO TO 15
          ELSE IF (STMT(IP:IP) .EQ. ')') THEN
             NEST = NEST - 1
             IF (NEST .EQ. 0) GO TO 20
          ELSE IF (STMT(IP:IP) .EQ. '(') THEN
             NEST = NEST + 1
          ENDIF
          IF (IP .LT. LENST) GO TO 10
15        IP = IP + 1
          CALL REFNUM (IP,LAB,NONUM,LAST,LLST,RFONLY)   
          IF (.NOT. NONUM) THEN
             CALL RLIST (LAB)
             NLAB = NLAB + 1
          ENDIF
      ENDIF
C
C --- CHECK FOR 'END=' (READ ONLY)
C
20    IF (ITYPE .EQ. 41) THEN
         IBEGIN = INDEX(STMT,'END=') + 4
         IF (IBEGIN .NE. 4) THEN
            CALL REFNUM (IBEGIN,LAB,NONUM,LAST,LLST,RFONLY)
            IF (.NOT. NONUM) THEN
               CALL RLIST (LAB)
               NLAB = NLAB + 1
            ENDIF
         ENDIF
      ENDIF  
C 
C --- CHECK FOR 'ERR='
C
      IBEGIN = INDEX(STMT,'ERR=') + 4
      IF (IBEGIN .NE. 4) THEN
         CALL REFNUM(IBEGIN,LAB,NONUM,LAST,LLST,RFONLY)
         IF (.NOT. NONUM) THEN
            CALL RLIST(LAB)
            NLAB = NLAB + 1
         ENDIF
      ENDIF
      RETURN  
      END                    
C
C---END GETNUM
C
      SUBROUTINE GETFIL 
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          GETFIL           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          GET FILE REFERENCE                      
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          GET THE FILE REFERENCE FROM AN OPEN, CLOSE, READ, WRITE,    
C*          BACKSPACE, REWIND OR INQUIRE STATEMENT                      
C*
C*     COMMON BLOCKS :
C*          FILES, OPTIONS, STATMT, STUB
C*
C*     SUBPROGRAM REFERENCES :
C*          INDEX
C*
C*     FILE REFERENCES :
C*          NWARN
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0      8-DEC-86 
C*
C*     CHANGE HISTORY :
C*           8-DEC-86    INITIAL VERSION
C*
C***********************************************************************
C*    
      PARAMETER(MXCALLS=400,MXCOMS=100,MXFIL=10,MXARG=50,MXNAME=20,
     $          MXSTLN=1520,MXINC=10,MXAUTH=10)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FNAME, FILREF, ARGNAM
      CHARACTER *(MXSTLN) STMT
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *40 AUTHOR    
      CHARACTER *5 CLABEL
      CHARACTER *1 CONCHR, CMTCHR
      LOGICAL COMM, EOF, CONT, LOGIF, TOMANY, ADD, ALIGN, ARG, INDENT, 
     $        MOVE, PROLOG, RENUM, STRUC, WARN, EXEM, POINT
C                             
C --- CHECK STMT FOR 'UNIT='
C
      I = INDEX(STMT,'UNIT=') + 5
      IF (I .NE. 5) THEN
         GO TO 5
C
C --- NO 'UNIT=', CHECK FOR BACKSPACE, ENDFILE, OR REWIND
C --- WHICH MAY OR MAY NOT HAVE PARENS, I.E. REWIND(N), OR REWIND N
C 
      ELSE IF (ITYPE .EQ. 38) THEN
         I = INDEX(STMT,'BACKSPACE(')
         IF (I .NE. 0) THEN
            I = I + 10
         ELSE
            I = INDEX(STMT,'BACKSPACE') + 9
         ENDIF
      ELSE IF (ITYPE .EQ. 39) THEN
         I = INDEX(STMT,'ENDFILE(')
         IF (I .NE. 0) THEN
            I = I + 8   
         ELSE 
            I = INDEX(STMT,'ENDFILE') + 7
         ENDIF
      ELSE IF (ITYPE .EQ. 40) THEN
         I = INDEX(STMT,'REWIND(')
         IF (I .NE. 0) THEN
            I = I + 7
         ELSE
            I = INDEX(STMT,'REWIND') + 6
         ENDIF
C
C --- CHECK FOR REMAINING TYPES
C
      ELSE IF (ITYPE .EQ. 36) THEN
          I = INDEX(STMT,'CLOSE(') + 6
      ELSE IF (ITYPE .EQ. 37) THEN
          I = INDEX(STMT,'INQUIRE(') + 8
      ELSE IF (ITYPE .EQ. 35) THEN
          I = INDEX(STMT,'OPEN(') + 5
      ELSE IF (ITYPE .EQ. 41) THEN
          I = INDEX(STMT,'READ(') + 5
      ELSE IF (ITYPE .EQ. 42) THEN
          I = INDEX(STMT,'WRITE(') + 6
      ENDIF
C
C --- COPY ALL ALPHANUMERIC CHARACTERS + '_' AND '$'
C
5     IEND = I
10    IEND = IEND + 1    
      IF (((STMT(IEND:IEND) .GE. 'A').AND.(STMT(IEND:IEND) .LE. 'Z'))
     $   .OR.((STMT(IEND:IEND) .GE. '0').AND.(STMT(IEND:IEND) .LE. '9'))
     $   .OR.(STMT(IEND:IEND) .EQ. '$').OR.(STMT(IEND:IEND) .EQ. '_'))
     $   GO TO 10
      IEND = IEND - 1
      FNAME = STMT(I:IEND)            
C
C --- CHECK FOR DUPLICATE REFERENCE
C
      DO 20 I = 1, NFREF
         IF (FNAME .EQ. FILREF(I)) GO TO 100
20    CONTINUE
      IF (.NOT. TOMANY) THEN 
         NFREF = NFREF + 1
         IF (NFREF .GT. MXFIL) THEN
            TOMANY = .TRUE.
            IF (WARN) WRITE(NWARN,900) SUBNAM
            NFREF = NFREF - 1
         ELSE
            FILREF(NFREF) = FNAME
         ENDIF
      ENDIF
100   RETURN
900   FORMAT(' ********** WARNING - ',/,
     $ 12X,'Number of file references exceeds maximum for prologues',/,
     $ 12X,'in subprogram ',A)
      END         
C
C---END GETFIL
C
      SUBROUTINE DLIST 
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          DLIST            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          DEFINED LIST                            
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          ADD THE STATEMENT LABEL TO THE DEFINED STATEMENT LIST       
C*
C*     COMMON BLOCKS :
C*          STATMT, OPTIONS, LABELS, FILES, STUB
C*
C*     SUBPROGRAM REFERENCES :
C*          RIGHT, ENDUP
C*
C*     FILE REFERENCES :
C*          NWARN
C*
C*     ERROR PROCESSING :
C*          JOB TERMINATED IF NUMBER OF LABELS EXCEEDS DIMENSIONS
C*          (RENUMBER OPTION ONLY)
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0      9-JAN-87 
C*
C*     CHANGE HISTORY :
C*           9-JAN-87    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXLBL=300,MXNEST=32,MXSTLN=1520,MXCALLS=400,MXCOMS=100,
     $          MXNAME=20,MXARG=50,MXFIL=10,MXINC=10,MXAUTH=10)
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / LABELS / LABDEF(MXLBL), NDEF, LABREF(MXLBL), NREF,
     $                  LABDOS(MXLBL), NDOS, LABFMT(MXLBL), NFLAB,
     $                  LABCNT(MXLBL), NCLAB, FUSED(MXLBL), 
     $                  CUSED(MXLBL), EXCEED, TOLD
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      CHARACTER *(MXSTLN) STMT         
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *40 AUTHOR         
      CHARACTER *5 CLABEL                                         
      CHARACTER *1 CONCHR, CMTCHR
      LOGICAL ADD, ALIGN, ARG, COMM, INDENT, MOVE, PROLOG, RENUM, 
     $        STRUC, WARN, FUSED, CUSED, CONT, EOF, LOGIF, EXCEED,
     $        TOMANY, TOLD, STAT, EXEM, POINT
C                                  
      IF (CLABEL .EQ. ' ') RETURN
      CALL RIGHT (CLABEL)
      READ (CLABEL,900) ILABEL
      NDEF = NDEF + 1
      IF (NDEF .GT. MXLBL) THEN
C
C --- NUMBER OF LABELS EXCEEDS MAXIMUM
C
         IF (RENUM) THEN
            WRITE(NWARN,910) SUBNAM
            CALL ENDUP (STAT)
         ELSE IF (.NOT. EXCEED) THEN
            EXCEED = .TRUE.
            IF (WARN) WRITE(NWARN,920) SUBNAM
         ENDIF
         RETURN
      ELSE
C
C --- ADD LABEL TO LIST OF DEFINED LABELS
C
          LABDEF (NDEF) = ILABEL
      ENDIF
C
C --- COLLECT FORMAT LABELS
C
      IF (ITYPE .EQ. 16) THEN
         NFLAB = NFLAB + 1
         LABFMT(NFLAB) = ILABEL
C
C --- COLLECT CONTINUE LABELS
C
      ELSE IF (ITYPE .EQ. 7) THEN
         NCLAB = NCLAB + 1
         LABCNT(NCLAB) = ILABEL
      ENDIF
      RETURN
900   FORMAT(I5)
910   FORMAT(' ********** FATAL ERROR - ',/,
     $ 12X,'Too many referenced LABELS in subprogram ',A,/,
     $ 12X,'JOB TERMINATED.')                          
920   FORMAT(' ********** WARNING - ',/,
     $ 12X,'number of LABELS exceeds maximum ',/,
     $ 12X,'rest will not be processed in subprogram ',A)
      END
C
C---END DLIST 
C
      SUBROUTINE RLIST (LABNUM)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          RLIST            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          REFERENCED LIST                         
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          ADD REFERENCED STATEMENT NUMBER TO LIST, IF UNIQUE          
C*
C*     INPUT ARGUMENTS :
C*          LABNUM - REFERENCED STATEMENT NUMBER TO ADD TO LIST
C*
C*     COMMON BLOCKS :
C*          FILES, OPTIONS, LABELS, STUB
C*
C*     SUBPROGRAM REFERENCES :
C*          ENDUP
C*
C*     ERROR PROCESSING :
C*          JOB TERMINATED IF NUMBER OF LABELS EXCEEDS DIMENSIONS
C*          (FOR RENUMBER OPTION ONLY)
C*
C*     ASSUMPTIONS AND RESTRICTIONS :
C*          MAXIMUM NUMBER OF LABELS IS 200
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0      1-DEC-86 
C*
C*     CHANGE HISTORY :
C*           1-DEC-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXLBL=300,MXNEST=32,MXNAME=20,MXCALLS=400,MXCOMS=100,
     $          MXFIL=10,MXARG=50,MXAUTH=10)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / LABELS / LABDEF(MXLBL), NDEF, LABREF(MXLBL), NREF,
     $                  LABDOS(MXLBL), NDOS, LABFMT(MXLBL), NFLAB,
     $                  LABCNT(MXLBL), NCLAB, FUSED(MXLBL), 
     $                  EXCEED, CUSED(MXLBL), TOLD
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      CHARACTER *40 AUTHOR
      CHARACTER *1 CONCHR, CMTCHR
      LOGICAL ADD, ALIGN, ARG, COMM, INDENT, MOVE, PROLOG, RENUM, 
     $        STRUC, WARN, FUSED, CUSED, EXCEED, TOMANY, TOLD, STAT,
     $        EXEM, POINT
C                                              
C --- CHECK FOR NEW REFERENCE
C
      DO 10 I = 1,NREF
         IF (LABNUM .EQ. LABREF(I)) RETURN
10    CONTINUE
      NREF = NREF + 1
      IF (NREF .GT. MXLBL) THEN
C
C --- NUMBER OF LABELS EXCEEDS MAXIMUM
C
         IF (RENUM) THEN
            WRITE(NWARN,910) SUBNAM
            CALL ENDUP (STAT)
         ELSE IF (.NOT. EXCEED) THEN
            EXCEED = .TRUE.
            IF (WARN) WRITE(NWARN,900) SUBNAM
         ENDIF
         RETURN
      ELSE
C
C --- ADD TO LIST
C
         LABREF(NREF) = LABNUM
      ENDIF
      RETURN
900   FORMAT(' ********** WARNING - ',/,
     $ 12X,'Too many referenced LABELS in subprogram ',A,/,
     $ 12X,'The rest will not be processed.')
910   FORMAT(' ********** FATAL ERROR - ',/,
     $ 12X,'TOO MANY REFERENCED LABELS IN SUBPROGRAM ',A,/,
     $ 12X,'JOB TERMINATED.')                          
      END
C
C---END RLIST 
C
      SUBROUTINE ARGMNT
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          ARGMNT           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          ARGUMENT                                
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*    BASED ON SUBPROGRAM 'ARGEX' BY ART RAGOSTA
C*
C*     PURPOSE :
C*          STRUCTURE THE ARGUMENT LIST IN CALL, FUNCTION, ENTRY, 
C*          AND SUBROUTINE STATEMENTS
C*
C*     INTERNAL WORK AREAS :
C*          TEMST - TEMPORARY VARIABLE FOR REBUILDING STATEMENT
C*
C*     COMMON BLOCKS :
C*          STATMT
C*
C*     SUBPROGRAM REFERENCES :
C*          INDEX
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     29-DEC-86 
C*
C*     CHANGE HISTORY :
C*          29-DEC-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXSTLN=1520,MXINC=10)
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      CHARACTER *(MXSTLN) STMT, TEMST
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *5 CLABEL
      LOGICAL CONT, EOF, LOGIF 
      INTEGER TEMPTR
C
C --- COPY UP TO FIRST LEFT PAREN, INSERTING A BLANK BEFORE IT
C --- UNLESS THERE IS NO LEFT PAREN, IN WHICH CASE THERE ARE NO
C --- ARGUMENTS
C
      TEMST = ' '
      TEMPTR = 1
      NADD = 1
      IF (ITYPE .EQ. 3) THEN
         IF (STMT(1:4) .NE. 'CALL') THEN
            I = INDEX(STMT,') CALL') + 7
5           I = I + 1
            IF (STMT(I:I) .EQ. '(') GO TO 7
            IF (I .LT. LENST) GO TO 5
            RETURN
         ENDIF
      ENDIF
      I = INDEX(STMT,'(') 
      IF (I .EQ. 0) RETURN
7     I = I - 1
      TEMST(TEMPTR:I) = STMT(1:I)
      TEMPTR = TEMPTR + I 
C
C --- ADD ' ', AND COPY LEFT PAREN
C
      I = I + 1
      TEMPTR = TEMPTR + 1
      TEMST(TEMPTR:TEMPTR) = STMT(I:I)
      TEMPTR = TEMPTR + 1
C
C --- COPY THE ARGUMENTS, INSERTING A ' ' AFTER EACH
C
      NEST = 0
      IST = I + 1
10    I = I + 1
      IF (STMT(I:I) .EQ. ',' .AND. NEST .EQ. 0) THEN
         TEMST(TEMPTR:TEMPTR+I-IST) = STMT(IST:I)
         TEMPTR = TEMPTR + I - IST + 1
         IST = I + 1
         TEMPTR = TEMPTR + 1
         NADD = NADD + 1
      ENDIF
      IF (STMT(I:I) .EQ. '(') THEN
         NEST = NEST + 1
      ELSE IF (STMT(I:I) .EQ. ')') THEN
         IF (NEST .GT. 0) THEN
            NEST = NEST - 1
         ELSE
C
C --- ALL ARGUMENTS FOUND, COPY REST OF STATEMENT AND EXIT
C
            TEMST(TEMPTR:) = STMT(IST:I)
            LENST = LENST + NADD 
            STMT = TEMST(1:LENST)
            RETURN
          ENDIF
      ENDIF
      GO TO 10
      END
C
C---END ARGMNT
C
      SUBROUTINE STRUCT
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          STRUCT           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          STRUCTURE
C*
C*     AUTHOR :
C*          L JURGELEIT
C*          MS 219-1
C*          AMES RESEARCH CENTER
C*          MOFFETT FIELD, CALIF 94035
C*          (415)965-6235
C* 
C* -- BASED ON PROGRAM "COMCLEAN" BY ART RAGOSTA
C*
C*     PURPOSE :
C*          STRUCTURE SPECIFICATION STATEMENTS, (E.G.
C*          REAL, INTEGER, DIMENSION, ETC.) AND WRITE THEM
C*          OUT IN FINAL FORM.
C*
C*     COMMON BLOCKS :   
C*          STATMT, FILES, OPTIONS, STUB
C*
C*     FILE REFERENCES :
C*          NOUT, NWARN
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77       
C*
C*     VERSION AND DATE :
C*          VERSION I.0     09/29/83
C*
C*     CHANGE HISTORY :
C*          09/29/83     INITIAL VERSION
C*          12/05/86     MODIFIED FOR CLEANUP
C*
C***********************************************************************
C*
      PARAMETER(MXCALLS=400,MXCOMS=100,MXFIL=10,MXARG=50,MXNAME=20,
     $          MXSTLN=1520,MXINC=10,MXAUTH=10)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      DIMENSION ITAB(20)
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      CHARACTER *(MXSTLN) STMT
      CHARACTER *80 CARD, CARD1, TCARD(MXINC)
      CHARACTER *40 AUTHOR
      CHARACTER *5 CLABEL
      CHARACTER *1 STM(MXSTLN), CRD(80), CONCHR, CMTCHR
      LOGICAL ADD, ALIGN, ARG, COMM, INDENT, MOVE, PROLOG, RENUM, 
     $        STRUC, WARN, EOF, CONT, INPARN, LOGIF, TOMANY, EXEM,
     $        POINT
      INTEGER SPTR, CPTR, TPTR
      DATA ITAB/7,17,26,35,44,53,62,13*0/
      DATA MAXTAB,NASC1,NASC2 /7,48,55/
      EQUIVALENCE (STMT,STM(1)), (CARD1,CRD(1))
C
C --- CHECK FOR BLANK COMMON ( NO SLASHES )
C
      INPARN = .FALSE.  
      IT = 0
      IF (ITYPE .EQ. 5) THEN
         IF (STM(7) .NE. '/') THEN
            CARD1(1:13) = '      COMMON '
            SPTR = 6
            CPTR = 13
            TPTR = 2
            GO TO 27
         ENDIF
         CARD1(1:15) = '      COMMON / '
         SPTR = 7
         CPTR = 15
      ELSEIF (ITYPE .EQ. 24) THEN
         CARD1(1:17) = '      NAMELIST / '
         SPTR = 9
         CPTR = 17
      ELSEIF (ITYPE .EQ. 4) THEN
         IF (STM(10) .NE. '*') THEN
            CARD1(1:16) = '      CHARACTER '
            SPTR = 9
            CPTR = 16
            TPTR = 2
         ELSE
            CARD1(1:17) = '      CHARACTER *'
C
C --- GET LENGTH SPECIFICATION
C
            TPTR = 3
            SPTR = 10
            CPTR = 17
            IST = SPTR + 1
            IF ((STM(IST).NE.'(')) THEN
C
C --- LENGTH SPECIFICATION IS AN INTEGER, COPY IT
C
               L = 0
5              SPTR = SPTR + 1
               IF ((STM(SPTR) .GE. '0').AND.(STM(SPTR).LE.'9')) THEN
                  L = L + 1
                  GO TO 5
               ENDIF
               SPTR = SPTR - 1
               CARD1(18:18+L) = STMT(IST:SPTR)
               CPTR = CPTR + L
            ELSE
C
C --- LENGTH SPECIFICATION IS A PARAMETER, COPY 'TIL MATCHING PAREN
C
               IST = SPTR + 1
               NEND = INDEX(STMT,')')
               CARD1(18:18+(NEND-IST+1)) = STMT(IST:NEND)
               CPTR = CPTR + (NEND-IST+1)
               SPTR = SPTR + (NEND-IST+1)
            ENDIF                        
         ENDIF            
         GO TO 27
      ELSEIF (ITYPE .EQ. 28) THEN
         CARD1(1:11) = '      REAL '
         SPTR = 4
         CPTR = 11
         TPTR = 2
         GO TO 27
      ELSEIF (ITYPE .EQ. 21) THEN
         CARD1(1:14) = '      INTEGER '
         SPTR = 7
         CPTR = 14
         TPTR = 2
         GO TO 27
      ELSEIF (ITYPE .EQ. 8) THEN
         CARD1(1:16) = '      DIMENSION '
         SPTR = 9
         CPTR = 16
         TPTR = 2
         GO TO 27
      ELSEIF (ITYPE .EQ. 23) THEN
         CARD1(1:14) = '      LOGICAL '
         SPTR = 7
         CPTR = 14
         TPTR = 2
         GO TO 27
      ELSE IF (ITYPE .EQ. 6) THEN
         CARD1(1:14) = '      COMPLEX '
         SPTR = 7
         CPTR = 14
         TPTR = 2
         GO TO 27
      ELSE IF (ITYPE .EQ. 9 ) THEN
         CARD1(1:23) = '      DOUBLE PRECISION '
         SPTR = 15
         CPTR = 23
         TPTR = 3
         GO TO 27
      ENDIF
      TPTR = 3
C
C --- SKIP CHARACTERS UNTIL START OF NAME
C
      INAME = 0
20    CPTR = CPTR + 1
      SPTR = SPTR + 1
      INAME = INAME + 1
      CRD(CPTR) = STM(SPTR)
      IF (STM(SPTR) .NE. '/')GO TO 20
      IF (INAME .LE. 7) THEN
         DO 25 I = INAME,7
            CRD(CPTR) = ' '
            CPTR = CPTR + 1
25       CONTINUE
      ENDIF
      CRD(CPTR) = '/'
      CPTR = CPTR + 1
      CRD(CPTR) = ' '
27    IF (CPTR .LT. ITAB(TPTR)) THEN
         CPTR = CPTR + 1
         CRD(CPTR) = ' '
         GO TO 27
      ENDIF
C
C --- NOW ADD ELEMENTS TO COMMON BLOCK
C
30    CPTR = CPTR + 1
      SPTR = SPTR + 1
      CRD(CPTR) = STM(SPTR)
      IF (STM(SPTR) .EQ. '(') THEN
         INPARN = .TRUE.
      ELSE IF (STM(SPTR) .EQ. ')')THEN
         INPARN = .FALSE.
C
C --- SPACE TO THE START OF NEXT ITEM
C
      ELSE IF ((STM(SPTR) .EQ. ',') .AND. (.NOT. INPARN)) THEN
C
C --- NEW CARD IF PAST LAST TAB LOCATION
C
         IF (TPTR .GT. MAXTAB) THEN
             TPTR = 1
40           CPTR = CPTR + 1
             CRD(CPTR) = ' '
             IF (CPTR .LT. 80) GO TO 40
             WRITE(NOUT,900)CARD1(1:LENGTH(CARD1))
             IT = IT + 1
             IF ((IT .GT. 20) .AND. (WARN)) WRITE(NWARN,910) SUBNAM
             CARD1(1:5) = ' '
             IF (CONCHR .NE. ' ') THEN
                CARD1(6:6) = CONCHR
             ELSE IF (IT .GT. 9) THEN
                CARD1(6:6) = CHAR(IT+NASC2)
             ELSE
                CARD1(6:6) = CHAR(IT+NASC1)
             ENDIF
             CPTR = 6
50           CPTR = CPTR + 1
             CRD(CPTR) = ' '
             IF (CPTR .LT. ITAB(TPTR)) GO TO 50
         ELSE
C
C --- TAB OUT TO NEXT TAB LOCATION
C
60           IF (CPTR .GT. ITAB(TPTR)) THEN
                TPTR = TPTR + 1
                IF (TPTR .GT. MAXTAB) THEN
                   TPTR = 1
65                 CPTR = CPTR + 1
                   CRD(CPTR) = ' '
                   IF (CPTR .LT. 80) GO TO 65
                   WRITE(NOUT,900) CARD1(1:LENGTH(CARD1))
                   IT = IT + 1
                   CARD1(1:5) = ' '
                   IF (CONCHR .NE. ' ') THEN
                      CARD1(6:6) = CONCHR
                   ELSE IF (IT .GT. 9) THEN
                      CARD1(6:6) = CHAR(IT+NASC2)
                   ELSE
                      CARD1(6:6) = CHAR(IT+NASC1)
                   ENDIF
                   CPTR = 6
70                 CPTR = CPTR + 1
                   CRD(CPTR) = ' '
                   IF (CPTR .LT. ITAB(TPTR)) GO TO 70
                ENDIF
                GO TO 60
             ENDIF
75           IF (CPTR .LT. ITAB(TPTR)) THEN
                CPTR = CPTR + 1
                CRD(CPTR) = ' '
                IF (CPTR .LT. ITAB(TPTR)) GO TO 75
             ENDIF    
             TPTR = TPTR + 1
         ENDIF
      ENDIF
C
C --- IF WE HAVE GONE TOO FAR, BACKUP
C
      IF (CPTR .GE. 72) THEN
80       CPTR = CPTR - 1
         SPTR = SPTR - 1
         IF (CRD(CPTR) .NE. ' ')GO TO 80
85       CPTR = CPTR + 1
         CRD(CPTR) = ' '
         IF (CPTR .NE. 80)GO TO 85
         WRITE(NOUT,900)CARD1(1:LENGTH(CARD1))
         IT = IT + 1
         CARD1(1:5) = ' '
         IF (CONCHR .NE. ' ') THEN
             CARD1(6:6) = CONCHR
         ELSE IF (IT .GT. 9) THEN
             CARD1(6:6) = CHAR(IT+NASC2)
         ELSE
             CARD1(6:6) = CHAR(IT+NASC1)
         ENDIF
         CPTR = 6
         TPTR = 1
90       CPTR = CPTR + 1
         CRD(CPTR) = ' '
         IF (CPTR .LT. ITAB(TPTR)) GO TO 90
      ENDIF
      IF (SPTR .LT. LENST) GO TO 30
C
C --- ALL CHARACTERS HAVE BEEN COPIED FROM INPUT LINE
C  -- PAD WITH BLANKS
C
95    CPTR = CPTR + 1
      CRD(CPTR) = ' '
      IF (CPTR .NE. 80)GO TO 95
      WRITE(NOUT,900) CARD1(1:LENGTH(CARD1))
      IT = IT + 1
      IF (IT .GT. 20) WRITE (NWARN,910) SUBNAM
      RETURN
900   FORMAT ( A )
910   FORMAT (' ********** WARNING - ',/,
     $ 12X,'More than 19 continuations cards is not standard FORTRAN',/,
     $ 12X,'in subprogram ',A)
      END
C
C---END STRUCT
C
      SUBROUTINE RESTOR (LKEY1,LKEY2,LOC)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          RESTOR           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          RESTORE                                 
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          RESTORE THE KEYWORD(S) IN THE STATEMENT; 
C*          I.E., PUT IN SPACES
C*
C*     INPUT ARGUMENTS :
C*          LKEY1 - LENGTH OF THE FIRST KEYWORD
C*          LKEY2 - LENGTH OF THE SECOND KEYWORD (IF ANY)
C*          LOC   - LOCATION OF THE FIRST KEYWORD IN THE STATEMENT
C*
C*     INTERNAL WORK AREAS :
C*          TSTMT - TEMPORARY STORAGE FOR STATEMENT WHILE
C*                  BEING REBUILT
C*
C*     COMMON BLOCKS :
C*          STATMT
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     29-DEC-86 
C*
C*     CHANGE HISTORY :
C*          29-DEC-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXSTLN=1520,MXINC=10)
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      CHARACTER *(MXSTLN) STMT, TSTMT
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *5 CLABEL
      LOGICAL EOF, CONT, LOGIF 
C
      TSTMT = ' '
      ITPTR = LOC - 1
      ISPTR = LOC - 1
      NADD = 1
      IF (LOC .NE. 1) THEN
C
C --- COPY STATEMENT UP TO KEYWORD, AND ADD ONE BLANK
C
         TSTMT(1:ITPTR) = STMT(1:ISPTR)
         NADD = NADD + 1
         ITPTR = ITPTR + 1
         LOC = LOC + 1
      ENDIF
C        
C --- ADD FIRST KEYWORD, FOLLOWED BY A ' '
C
      ITPTR = ITPTR + 1
      ISPTR = ISPTR + 1
      TSTMT(ITPTR:ITPTR+LKEY1-1) = STMT(ISPTR:ISPTR+LKEY1-1)
      ITPTR = ITPTR + LKEY1 
      ISPTR = ISPTR + LKEY1 
C
C --- ADD SECOND KEYWORD, IF ANY
C
      IF (LKEY2 .NE. 0) THEN
         ITPTR = ITPTR + 1
         TSTMT(ITPTR:ITPTR+LKEY2-1) = STMT(ISPTR:ISPTR+LKEY2-1)
         ITPTR = ITPTR + LKEY2
         ISPTR = ISPTR + LKEY2
C
C --- IF NOT END OF STATEMENT, ADD ANOTHER BLANK
C
         IF (STMT(ISPTR:ISPTR) .NE. ' ') NADD = NADD + 1
      ENDIF
C
C --- COPY THE REST OF THE STATEMENT UNCHANGED
C
      IF (ISPTR .LE. LENST) THEN
         ITPTR = ITPTR + 1
         TSTMT(ITPTR:) = STMT(ISPTR:LENST)
      ENDIF
      LENST = LENST + NADD
      STMT = TSTMT(1:LENST)
      RETURN
      END
C
C---END RESTOR
C
      SUBROUTINE SPLOG (NADDED)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          SPLOG            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          SPACE LOGICAL                           
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          PUT A BLANK ON EITHER SIDE OF LOGICAL OPERATORS, E.G.,      
C*          .NOT., .AND., .OR., ETC.                                    
C*
C*     COMMON BLOCKS :
C*          STATMT
C*
C*     OUTPUT ARGUMENTS :
C*          NADDED - NUMBER OF SPACES ADDED TO THE STATMENT
C*
C*     SUBPROGRAM REFERENCES :
C*          RESTOR, INDEX
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     30-JAN-87 
C*
C*     CHANGE HISTORY :
C*          30-JAN-87    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXSTLN=1520,MXINC=10)
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      CHARACTER *(MXSTLN) STMT         
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *5 CLABEL, LG4CHR
      CHARACTER *4 LG3CHR(3)
      CHARACTER *3 LG2CHR(7)
      LOGICAL CONT, EOF, LOGIF
      DATA LG2CHR / 'LT.', 'LE.', 'EQ.', 'NE.', 'GE.', 'GT.', 'OR.' /
      DATA LG3CHR / 'NOT.', 'AND.', 'EQV.' /
      DATA LG4CHR / 'NEQV.' /
C
      NADDED = 0
C
C --- LOOK FOR '.' WITHIN THE STATEMENT
C
      IPTR = INDEX(STMT,'.')
      IF (IPTR .EQ. 0) RETURN
10    IPTR = IPTR + 1
C
C --- SEARCH FOR LOGICAL OPERATOR
C
      DO 20 I = 1,7
         IF (STMT(IPTR:IPTR+2) .EQ. LG2CHR(I)) THEN
            L = 4
            GO TO 40
         ENDIF
20    CONTINUE
      DO 30 I = 1,3
         IF (STMT(IPTR:IPTR+3) .EQ. LG3CHR(I)) THEN
            L = 5
            GO TO 40
         ENDIF
30    CONTINUE
      IF (STMT(IPTR:IPTR+4) .EQ. LG4CHR) THEN
          L = 6
          GO TO 40
      ENDIF
C
C --- NO LOGICAL OPERATOR FOUND, RETURN
C
      IF (IPTR .GE. LENST) THEN
         RETURN
      ELSE
         IPTR = IPTR + 1
         GO TO 45
      ENDIF
40    CALL RESTOR (IPTR-2,L,1)
      IPTR = IPTR + L + 1
      NADDED = NADDED + 2
      IF (IPTR .GT. LENST) RETURN
45    IF (INDEX(STMT(IPTR:LENST),'.') .EQ. 0) RETURN
      IPTR = INDEX(STMT(IPTR:LENST),'.') + IPTR - 1
      GO TO 10
      END
C
C---END SPLOG 
C
      SUBROUTINE SPARG (IPOS)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          SPARG            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          SPACE ARGUMENTS                         
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          SPACE THE ARGUMENTS IN READ AND WRITE STATEMENTS            
C*
C*     INPUT ARGUMENTS :
C*          IPOS - POSITION OF READ OR WRITE IN THE STATEMENT
C*
C*     INTERNAL WORK AREAS :
C*          TEMPST - TEMPORARY VARIABLE USED TO REBUILD STATEMENT
C*
C*     COMMON BLOCKS :
C*          STATMT
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     18-MAR-87 
C*
C*     CHANGE HISTORY :
C*          18-MAR-87    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXSTLN=1520,MXINC=10)
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      CHARACTER *(MXSTLN) STMT, TEMPST
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *5 CLABEL
      LOGICAL CONT, EOF, LOGIF 
C
C --- READ PAST FIRST SET OF PARENS 
C
      NEST = 1
      IF (ITYPE .EQ. 41) THEN
         ISPTR = IPOS + 5
      ELSE 
         ISPTR = IPOS + 6
      ENDIF
10    ISPTR = ISPTR + 1
      IF (STMT(ISPTR:ISPTR) .EQ. '(') THEN
         NEST = NEST + 1
      ELSE IF (STMT(ISPTR:ISPTR) .EQ. ')') THEN
         NEST = NEST - 1
         IF (NEST .EQ. 0) GO TO 20
      ENDIF
      GO TO 10
C
C --- WE ARE OUTSIDE FIRST PARENS, RETURN IF THERE ARE NO ARGUMENTS
C
20    IF (ISPTR .EQ. LENST) RETURN
C
C --- COPY FIRST SET OF PARENS
C
      TEMPST = ' '
      ITPTR  = 1
      NADD = 1
      TEMPST(ITPTR:ITPTR+ISPTR-1) = STMT(1:ISPTR)
      ITPTR = ITPTR + ISPTR 
C
C --- COPY THE ARGUMENTS, ADDING A SPACE AFTER EACH
C
      NEST = 0
      IP = ISPTR + 1
30    ISPTR = ISPTR + 1
      IF (STMT(ISPTR:ISPTR) .EQ. ',' .AND. NEST .EQ. 0) THEN
          TEMPST(ITPTR:ITPTR+ISPTR-IP) = STMT(IP:ISPTR)          
          ITPTR = ITPTR + ISPTR - IP + 1
          IP = ISPTR + 1
          ITPTR = ITPTR + 1
          NADD = NADD + 1
      ENDIF
      IF (STMT(ISPTR:ISPTR) .EQ. '(') THEN
          NEST = NEST + 1
      ELSE IF (STMT(ISPTR:ISPTR) .EQ. ')') THEN
          NEST = NEST - 1
      ENDIF
      IF (ISPTR .LT. LENST) GO TO 30
C
C --- COPY TEMPORARY STATEMENT BACK INTO ORIGINAL STATEMENT
C
      TEMPST(ITPTR:) = STMT(IP:ISPTR)
      LENST = LENST + NADD
      STMT = TEMPST(1:LENST)
      RETURN
      END      
C
C---END SPARG
C
      SUBROUTINE SPASGN (LOCEQ)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          SPASGN           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          SPACE ASSIGNMENT STATEMENT              
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          PUT A BLANK SPACE ON EITHER SIDE OF NAKED PLUS (+) AND      
C*          MINUS (-) SIGNS IN ARITHMETIC ASSIGNMENT STATEMENTS         
C*
C*     INPUT ARGUMENTS :
C*          LOCEQ - LOCATION OF THE EQUAL SIGN
C*
C*     COMMON BLOCKS :
C*          STATMT
C*
C*     SUBPROGRAM REFERENCES :
C*          RESTOR
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     27-JAN-87 
C*
C*     CHANGE HISTORY :
C*          27-JAN-87    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXSTLN=1520,MXINC=10)
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      CHARACTER *(MXSTLN) STMT         
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *5 CLABEL
      LOGICAL CONT, EOF, LOGIF
C
C --- LOOK FOR PLUS AND MINUS OUTSIDE PARENS
C
      IPTR = LOCEQ 
      NEST = 0
10    IPTR = IPTR + 1
      IF (STMT(IPTR:IPTR) .EQ. '(') THEN
         NEST = NEST + 1
      ELSE IF (STMT(IPTR:IPTR) .EQ. ')') THEN
         NEST = NEST - 1
      ELSE IF (STMT(IPTR:IPTR) .EQ. '+') THEN
         IF (NEST .EQ. 0) THEN
            CALL RESTOR(IPTR-1,1,1)
            IPTR = IPTR + 2
         ENDIF
      ELSE IF (STMT(IPTR:IPTR) .EQ. '-') THEN
         IF (NEST .EQ. 0) THEN
            CALL RESTOR(IPTR-1,1,1)
            IPTR = IPTR + 2
         ENDIF
      ENDIF
      IF (IPTR .LT. LENST) GO TO 10
      RETURN
      END
C
C---END SPASGN
C
      SUBROUTINE LINEUP (LOCEQ)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          LINEUP           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          LINE UP 
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          ALIGN THE EQUAL SIGNS IN ASSIGNMENT STATEMENTS              
C*
C*     INPUT ARGUMENTS :
C*          LOCEQ - LOCATION OF THE EQUAL SIGN
C*
C*     INTERNAL WORK AREAS :
C*          TEMPST - TEMPORARY STATEMENT USED WHILE ADDING SPACES
C*
C*     COMMON BLOCKS :
C*          STATMT
C*
C*     SUBPROGRAM REFERENCES :
C*          LENGTH
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     27-JAN-87 
C*
C*     CHANGE HISTORY :
C*          27-JAN-87    INITIAL VERSION
C*          19-MAR-87    MODIFIED TO PROCESS VARIABLE ALIGNMENT
C*                       POSITIONS
C*
C***********************************************************************
C*
      PARAMETER(MXSTLN=1520,MXINC=10)
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      CHARACTER *(MXSTLN) STMT, TEMPST
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *5 CLABEL
      CHARACTER *1 CONCHR, CMTCHR
      LOGICAL EOF, CONT, LOGIF, ADD, ALIGN, ARG, INDENT, MOVE, EXEM,
     $        PROLOG, RENUM, STRUC, WARN, COMM, POINT
C
      IPTR  = 1
      ITPTR = 1
      TEMPST = ' '
C
C --- COPY VARIABLE NAME AND ADD ONE SPACE
C        
      TEMPST(ITPTR:LOCEQ-1) = STMT(IPTR:LOCEQ-1)
      ITPTR = LOCEQ - 1
      IPTR = LOCEQ - 1
C
C --- IF LOCATION OF EQUAL SIGN IN STATEMENT IS LESS THAN LOCATION 
C --- TO PUT EQUAL SIGN FOR ALIGNMENT, PAD NAME WITH BLANKS
C
      IF (LOCEQ .LT. NCOL) ITPTR = NCOL - 1
C
C --- COPY REST OF STATEMENT
C
      TEMPST(ITPTR:) = STMT(IPTR:LENST)
      LENST = LENGTH(TEMPST)
C
C --- RECOPY INTO STMT
C
      STMT = TEMPST
      RETURN
      END
C
C---END LINEUP
C
      SUBROUTINE PUTSTR (NST)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          PUTSTR           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          PUT STRING                              
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          PUT THE CHARACTER STRINGS BACK INTO THIS STATEMENT          
C*
C*     COMMON BLOCKS :
C*          STATMT, TEXT
C*
C*     INPUT ARGUMENTS :
C*          NST - POINTER TO THE STRING TO PUT BACK
C*
C*     SUBPROGRAM REFERENCES :
C*          LENGTH
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     29-JAN-87 
C*
C*     CHANGE HISTORY :
C*          29-JAN-87    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXSTLN=1520,MXSTRGS=200,MXINC=10)
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / TEXT / STRINGS, NUMST, CREP
      CHARACTER *(MXSTLN) STMT, STRINGS(MXSTRGS), TEMPST
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *5 CLABEL
      CHARACTER *4 CREP
      LOGICAL EOF, CONT, LOGIF
C
      IPTR = 0
      TEMPST = ' '
      ITB = 1
      ISB = 1
10    IPTR = IPTR + 1
C
C --- LOOK FOR DUMMY VARIABLE
C
      IF (STMT(IPTR:IPTR+3) .EQ. CREP) THEN
         TEMPST(ITB:IPTR-1) = STMT(ISB:IPTR-1)
         ISB = ISB + IPTR + 3
         ITB = ITB + IPTR - 1
C
C --- PUT THE STRING BACK IN
C
         L = LENGTH(STRINGS(NST))
         TEMPST(ITB:ITB+L-1) = STRINGS(NST)(1:L)
         ITB = ITB + L
C
C --- COPY THE REST OF THE STATMENT
C
         IF (ISB .LE. LENST) TEMPST(ITB:) = STMT(ISB:LENST)
         LENST = LENGTH(TEMPST)
         STMT = TEMPST
         RETURN
      ENDIF
      IF (IPTR .LT. LENST) GO TO 10
      RETURN
      END
C
C---END PUTSTR
C
      SUBROUTINE CHKLAB
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          CHKLAB           **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          CHECK LABELS                            
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          CHECK IF DEFINED STATEMENT NUMBERS ARE REFERENCED. 
C*
C*     COMMON BLOCKS :
C*          LABELS
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     23-DEC-86 
C*
C*     CHANGE HISTORY :
C*          23-DEC-86    INITIAL VERSION
C*
C***********************************************************************
C*    
      PARAMETER(MXLBL=300,MXCALLS=400,MXCOMS=100,MXFIL=10,MXARG=50,
     $          MXNAME=20,MXAUTH=10)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY  
      COMMON / LABELS / LABDEF(MXLBL), NDEF, LABREF(MXLBL), NREF,
     $                  LABDOS(MXLBL), NDOS, LABFMT(MXLBL), NFLAB,
     $                  LABCNT(MXLBL), NCLAB, FUSED(MXLBL), 
     $                  CUSED(MXLBL), EXCEED, TOLD
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      CHARACTER *40 AUTHOR
      CHARACTER *1 CONCHR, CMTCHR
      LOGICAL FUSED, CUSED, EXCEED, TOLD, ADD, ALIGN, ARG, INDENT,
     $        MOVE, EXEM, PROLOG, RENUM, STRUC, WARN, COMM, TOMANY,
     $        POINT
C
      IF ((NDEF .EQ. 0) .OR. (EXCEED)) RETURN
C
C --- SCAN DEFINED STATEMENT LABEL LIST FOR REFERENCES
C
      IPTR = 0
      DO 20 I = 1,NDEF
         DO 10 J = 1,NREF
            IF (LABDEF(I) .EQ. LABREF(J)) GO TO 15
10       CONTINUE
C
C --- LABEL WAS NOT REFERENCED, CHECK FOR A FORMAT
C
         DO 11 J = 1,NFLAB
            IF (LABDEF(I) .EQ. LABFMT(J)) THEN
C
C --- UNREFERENCED LABEL IS FORMAT
C
                FUSED(J) = .TRUE.
                GO TO 15
            ENDIF
11       CONTINUE
C
C --- NOT A FORMAT, MAYBE A CONTINUE ?
C
         DO 13 K = 1,NCLAB
            IF (LABDEF(I) .EQ. LABCNT(K)) THEN
C
C --- UNREFERNECED LABEL IS A CONTINUE
C
               CUSED(K) = .TRUE.
               GO TO 20
            ENDIF
13       CONTINUE
C
C --- DEFINED LABEL WAS NOT REFERENCED; DELETE IT
C
         IF (WARN) WRITE(NWARN,900) LABDEF(I), SUBNAM
         GO TO 20
15       IPTR = IPTR + 1
         LABDEF(IPTR) = LABDEF(I)
20    CONTINUE   
      NDEF = IPTR
      RETURN
900   FORMAT(' ********** WARNING - ',/,
     $ 12X,'Unreferenced statement label ',I5,
     $     ' was deleted in subprogram ',A)
      END
C
C---END CHKLAB
C
      SUBROUTINE WRITSUB
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          WRITSUB          **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          WRITE SUBPROGRAM                        
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          WRITE A SUBPROGRAM TO THE OUTPUT FILE IN FINAL FORM         
C*
C*     COMMON BLOCKS :
C*          FILES, STATMT, OPTIONS, LABELS, COMMS, OUT, STUB
C*
C*     FILE REFERENCES :
C*          NTEMP, NFORM, NOUT
C*                                
C*     SUBPROGRAM REFERENCES :
C*          STOUT, PROLG, STRUCT, RELAB, DOLAB
C*                                            
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0      5-DEC-86 
C*
C*     CHANGE HISTORY :
C*           5-DEC-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER (NSPCHR=8,MXSTLN=1520,MXCM=200,MXCALLS=400,MXCOMS=100,
     $           MXARG=50,MXNAME=20,MXFIL=10,MXINC=10,MXLBL=300,
     $           MXAUTH=10)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / LABELS / LABDEF(MXLBL), NDEF, LABREF(MXLBL), NREF,
     $                  LABDOS(MXLBL), NDOS, LABFMT(MXLBL), NFLAB,
     $                  LABCNT(MXLBL), NCLAB, FUSED(MXLBL), 
     $                  CUSED(MXLBL), EXCEED, TOLD
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      COMMON / COMMS / CCARDS, NCMTS
      COMMON / OUT / SEQ, SPCHR, NASC1, NASC2
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      CHARACTER *(MXSTLN) STMT
      CHARACTER *80 CARD, CCARDS(MXCM), TCARD(MXINC)
      CHARACTER *40 AUTHOR
      CHARACTER *5 CLABEL
      CHARACTER *1 CONCHR, SPCHR(NSPCHR), CMTCHR
      LOGICAL ADD, ALIGN, ARG, COMM, INDENT, MOVE, PROLOG, RENUM, 
     $        STRUC, WARN, CONT, EOF, LOGIF, SEQ, FMT, TOMANY, FUSED, 
     $        CUSED, EXCEED, TOLD, EXEM, POINT
C
C --- REWIND SCRATCH FILE
C
      REWIND (NTEMP)
      SEQ = CONCHR .EQ. ' '
C
C --- IF PROLOGUES ARE TO BE CREATED, WRITE FIRST LINE OF SUBPROGRAM
C --- (E.G. SUBROUTINE, FUNCTION, PROGRAM, ETC.) IF ANY
C
      IF (PROLOG) THEN
10       STMT = ' '
         READ (NTEMP) ITYPE, LENST, CLABEL, STMT(1:LENST), NLAB, LOGIF
C
C --- COMMENT
C
         IF (ITYPE .EQ. 51) THEN
            WRITE(NOUT,900) STMT(1:LENST)
            GO TO 10
         ENDIF
         IF ((ITYPE .EQ. 45) .OR. (ITYPE .EQ. 27) .OR. 
     $      (ITYPE .EQ. 32) .OR. (ITYPE .EQ. 2)) THEN
            CALL STOUT (FMT)
         ENDIF
         CALL PROLG       
      ENDIF  
C
C --- READ AND PROCESS REST OF SUBPROGRAM TIL END STATEMENT FOUND
C
30    STMT = ' '
      FMT = .FALSE.
      READ (NTEMP) ITYPE,LENST,CLABEL,STMT(1:LENST), NLAB, LOGIF
      IF (ITYPE .EQ. 51) THEN
C
C --- COMMENT
C
         WRITE(NOUT,900) STMT(1:LENST)
         GO TO 30
      ELSE IF (ITYPE .EQ. 34) THEN
C
C --- WRITE END STATEMENT AND EXIT
C
         CALL STOUT (FMT)
C
C --- WRITE ANY STORED COMMENTS IF EOF
C
         IF ((EOF).AND.(NCMTS.GT.0)) THEN
            DO 35 I = 1,NCMTS
               WRITE(NOUT,900) CCARDS(I)(1:LENGTH(CCARDS(I)))
35          CONTINUE
         ENDIF
         RETURN
C
C --- STRUCTURE SPECIFICATION STATEMENTS
C
      ELSE IF (((ITYPE .EQ. 5).OR.(ITYPE .EQ. 8).OR.(ITYPE .EQ. 21)
     $         .OR.(ITYPE .EQ. 23).OR.(ITYPE .EQ. 24).OR.(ITYPE .EQ.
     $         28).OR.(ITYPE.EQ.6).OR.(ITYPE.EQ.9 ).OR.(ITYPE.EQ.4)) 
     $         .AND. (STRUC)) THEN 
              CALL STRUCT 
              GO TO 30
      ELSE IF (ITYPE.EQ.7) THEN                       
C
C --- CHECK FOR UNREFERENCED CONTINUE STATEMENT
C        
         IF (.NOT. EXCEED) THEN
            READ(CLABEL,930) ILAB
            DO 36 INUM = 1,NCLAB
               IF ((ILAB .EQ. LABCNT(INUM)) .AND. 
     $            (CUSED(INUM) .EQ. .TRUE.)) THEN
C 
C --- UNUSED CONTINUE, DELETE IT
C
                  IF (WARN) WRITE(NWARN,910) SUBNAM, CLABEL, STMT(1:8)
                  GO TO 30
               ENDIF
36        CONTINUE
         ENDIF
      ELSE IF (ITYPE.EQ.16) THEN
C
C --- CHECK FOR UNUSED FORMAT
C
         IF (.NOT. EXCEED) THEN
            READ(CLABEL,930) ILAB
            DO 37 INUM = 1,NFLAB
               IF ((ILAB .EQ. LABFMT(INUM)) .AND. 
     $             (FUSED(INUM) .EQ. .TRUE.)) THEN
C
C --- UNUSED FORMAT, WRITE IT AS A COMMENT
C
                   IF (WARN) WRITE(NWARN,920) SUBNAM, CLABEL, STMT(1:20)
                   FMT = .TRUE.
                   CALL STOUT (FMT)
                   GO TO 30
               ENDIF
37         CONTINUE
         ENDIF
      ENDIF         
C          
C --- RENUMBER THE STATEMENT LABEL
C
      IF (CLABEL.NE.' ') CALL RELAB 
C
C --- RENUMBER ANY LABEL REFERENCES IN THIS STATEMENT
C
      IF (NLAB .GT. 0) THEN
          DO 40 I = 1,NLAB
             CALL DOLAB 
40        CONTINUE
      ENDIF
C
C --- INDENTATION DONE IN STOUT
C
      CALL STOUT (FMT)
      GO TO 30
900   FORMAT(A)
910   FORMAT(' ********** WARNING - ',/,
     $ 12X,'Unused CONTINUE statement was deleted in subprogram ',A,/,
     $ 12X,A5,1X,A)
920   FORMAT(' ********** WARNING - ',/,
     $ 12X,'Unused FORMAT statement was converted to a COMMENT ',/,
     $ 12X,'in subprogram ',A,1X,A5,1X,A20)
930   FORMAT(I5)
      END 
C
C---END WRITSUB
C
      SUBROUTINE DOLAB 
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          DOLAB            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          DO LABELS                               
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          REPLACE THE REFERENCED STATEMENT NUMBERS IN THIS            
C*          STATEMENT WITH THE NEW NUMBERS                              
C*
C*     INTERNAL WORK AREAS :
C*          TEMPST - TEMPORARY STATEMENT
C*
C*     COMMON BLOCKS :
C*          FILES, LABELS, OPTIONS, STATMT, STUB
C*
C*     SUBPROGRAM REFERENCES :
C*          RIGHT, LEFT, LENGTH
C*
C*     FILE REFERENCES :
C*          NWARN
C*
C*     ERROR PROCESSING :
C*          IF REFERENCED NUMBER IS NOT DEFINED, OLD REFERENCE
C*          WILL BE LEFT UNCHANGED
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*    
C*     VERSION AND DATE :
C*          VERSION I.0     13-JAN-87 
C*
C*     CHANGE HISTORY :
C*          13-JAN-87    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXLBL=300,MXNEST=32,MXCALLS=400,MXCOMS=100,MXFIL=10,
     $          MXARG=50,MXNAME=20,MXSTLN=1520,MXINC=10,MXAUTH=10,
     $          MINF=9000,INCF=10)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / LABELS / LABDEF(MXLBL), NDEF, LABREF(MXLBL), NREF,
     $                  LABDOS(MXLBL), NDOS, LABFMT(MXLBL), NFLAB,
     $                  LABCNT(MXLBL), NCLAB, FUSED(MXLBL), 
     $                  CUSED(MXLBL), EXCEED, TOLD
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      CHARACTER *(MXSTLN) STMT, TEMPST
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *40 AUTHOR            
      CHARACTER *5 CLABEL, CTEMP
      CHARACTER *1 CONCHR, CMTCHR
      LOGICAL ADD, ALIGN, ARG, COMM, INDENT, MOVE, PROLOG, RENUM, 
     $        STRUC, WARN, FUSED, CUSED, EOF, CONT, LOGIF, EXCEED,
     $        TOMANY, TOLD, EXEM, POINT
C
C --- MAKE SURE NUMBER OF LABELS IS COMPATIBLE WITH USER-CHOSEN
C --- MINIMUM AND INCREMENT; IF NOT, SET THEM TO DEFAULTS FOR THIS
C --- SUBPROGRAM ONLY.
C
      MINTEM = MIN
      INCTEM = INC
      IF ((NREF*INC+MIN) .GT. 99999) THEN
          IF (.NOT. TOLD) THEN
             TOLD = .TRUE.
             IF (WARN) WRITE(NWARN,920) SUBNAM
          ENDIF
          MINTEM = 0
          INCTEM = 10
      ENDIF
C                                     
C --- LOOK FOR '*#' FLAG
C
      TEMPST = ' '
      IPTR = 0
      ITB = 1
      ISB = 1
10    IPTR = IPTR + 1
      IF (STMT(IPTR:IPTR+1) .EQ. '*#') THEN
         TEMPST(ITB:IPTR-1) = STMT(ISB:IPTR-1)
         ISB = ISB + IPTR + 1
         ITB = ITB + IPTR - 1
C
C --- GET THE REFERENCE
C
         IPTR = IPTR + 2
         IST = IPTR
15       IPTR = IPTR + 1
           IF ((STMT(IPTR:IPTR) .LT. '0').OR.(STMT(IPTR:IPTR).GT.'9'))
     $        GO TO 20
         GO TO 15
20       NEND = IPTR - 1
         CTEMP = STMT(IST:NEND)
         CALL RIGHT(CTEMP)
         READ (CTEMP,900) ILABEL
C
C --- CHECK FOR FORMAT TO START AT 9000
C
         IF (((ITYPE .EQ. 26).OR.(ITYPE .EQ. 33).OR.(ITYPE .EQ. 41).OR.
     $       (ITYPE .EQ. 42)).AND.MOVE)  THEN
              DO 25 IF = 1,NFLAB
                 IF (LABFMT(IF) .EQ. ILABEL) THEN
C
C --- CALCULATE NEW FORMAT LABEL STARTING AT 9000
C
                    CTEMP = ' '
                    NEWF = (IF-1) * INCF + MINF
                    WRITE(CTEMP,900) NEWF
                    GO TO 50
                 ENDIF
25            CONTINUE
         ENDIF
C
C --- SEARCH DEFINED LIST FOR REFERENCE
C
         DO 30 I = 1,NDEF
            IF (LABDEF(I) .EQ. ILABEL) GO TO 40
30       CONTINUE
C
C --- LABEL REFERENCED BUT NOT DEFINED, LEAVE IN OLD REFERENCE
C
         WRITE (NWARN,910) ILABEL, SUBNAM
         GO TO 50
C
C --- CALCULATE NEW NUMBER
C
40       CTEMP = ' '
         IF (MINTEM .NE. 0) I = I - 1
         NEWNUM = (I) * INCTEM + MINTEM
         WRITE(CTEMP,900) NEWNUM
C
C --- INSERT THE NEW REFERENCE
C
50       CALL LEFT (CTEMP)
         L = LENGTH(CTEMP)
         TEMPST(ITB:ITB+L-1) = CTEMP(1:L)
C
C --- ADD A BLANK SPACE AFTER THE NUMBER(IF IT'S A DO LOOP)
C
         IF (ITYPE .EQ. 46) THEN
            ITB = ITB + L + 1
         ELSE
            ITB = ITB + L
         ENDIF
C
C --- COPY THE REST OF THE STATEMENT
C
         IF (IPTR .LE. LENST) TEMPST(ITB:) = STMT(IPTR:LENST)
         LENST = LENGTH (TEMPST)
         STMT = TEMPST
         RETURN
      ENDIF
      IF (IPTR .LT. LENST) GO TO 10
900   FORMAT(I5)
910   FORMAT(' ********** ERROR, LABEL ',I5,' REFERENCED, BUT'
     $       ' NOT DEFINED',/,11X,'IN SUBPROGRAM ',A)
920   FORMAT(' ********** WARNING -',/,
     $ 12X,'Too many referenced labels for RENUMBER options chosen - ',
     $ 'defaults will be used in subprogram ',A)
      END
C
C---END DOLAB 
C
      SUBROUTINE RELAB 
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          RELAB            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          RE-LABEL                                
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          RENUMBER THE STATEMENT LABEL
C*
C*     COMMON BLOCKS :
C*          FILES, STATMT, STUB, LABELS, OPTIONS
C*
C*     FILE REFERENCES :
C*          NWARN
C*
C*     ERROR PROCESSING :
C*          UNREFERENCED STATEMENT LABELS ARE DELETED
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0      5-JAN-87 
C*
C*     CHANGE HISTORY :
C*           5-JAN-87    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXLBL=300,MXCALLS=400,MXCOMS=100,MXFIL=10,MXARG=50,
     $          MXNAME=20,MXAUTH=10,MXSTLN=1520,MINF=9000,INCF=10,
     $          MXINC=10)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      COMMON / LABELS / LABDEF(MXLBL), NDEF, LABREF(MXLBL), NREF,
     $                  LABDOS(MXLBL), NDOS, LABFMT(MXLBL), NFLAB,
     $                  LABCNT(MXLBL), NCLAB, FUSED(MXLBL), 
     $                  CUSED(MXLBL), EXCEED, TOLD
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      CHARACTER *(MXSTLN) STMT
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *40 AUTHOR
      CHARACTER *5 CLABEL
      CHARACTER *1 CONCHR, CMTCHR
      LOGICAL FUSED, CUSED, EXCEED, ADD, ALIGN, ARG, COMM, INDENT, 
     $        MOVE, PROLOG, RENUM, STRUC, WARN, TOMANY, TOLD, EXEM,
     $        EOF, CONT, LOGIF, POINT
C
C --- SEARCH DEFINED STATEMENT LIST FOR LABEL
C
      READ (CLABEL,900) ILABEL
      DO 10 I = 1,NDEF
         IF (LABDEF(I) .EQ. ILABEL) GO TO 20
10    CONTINUE
C
C --- LABEL NOT FOUND, DELETE IT
C
      CLABEL = ' '
      RETURN
C
C --- MAKE SURE NUMBER OF LABELS IS COMPATIBLE WITH USER CHOSEN
C --- MINIMUM AND INCREMENT; IF NOT, USE THE DEFAULTS
C
20    IF (.NOT. RENUM) RETURN
      CLABEL = ' '
      IF ((ITYPE .EQ. 16) .AND. (MOVE)) THEN
C
C --- SEARCH DEFINED FORMAT LABELS FOR ILABEL
C
         DO 30 IF = 1,NFLAB
            IF (LABFMT(IF) .EQ. ILABEL) THEN
C
C --- CALCULATE NEW FORMAT LABEL 
C
                NEWNUM = (IF-1) * INCF + MINF
                GO TO 50
             ENDIF
30       CONTINUE
      ELSE
         MINTEM = MIN
         INCTEM = INC
         IF ((NDEF*INC+MIN) .GT. 99999) THEN
            IF (.NOT. TOLD) THEN
               TOLD = .TRUE.
               IF (WARN) WRITE(NWARN,910) SUBNAM
            ENDIF
            MINTEM = 0
            INCTEM = 10
         ENDIF
C
C --- CALCULATE NEW STATEMENT NUMBER
C
         IF (MINTEM .NE. 0) I = I - 1
         NEWNUM = (I) * INCTEM + MINTEM
      ENDIF
C     
C --- PUT IN NEW LABEL
C
50    WRITE(CLABEL,900) NEWNUM
      RETURN
C
900   FORMAT(I5)
910   FORMAT (' ********** WARNING -',/,
     $ 12X,'Too many defined labels for RENUMBER options chosen - ',
     $ 'defaults will be used in subprogram ',A)
      END
C
C---END RELAB 
C
      SUBROUTINE STOUT (FORM)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          STOUT            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          STATEMENT OUT
C*
C*     AUTHOR :
C*          L JURGELEIT                             
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          PERFORM INDENTATION OF DO-LOOPS AND 
C*          IF-THEN-ELSEIF-ELSE-ENDIF BLOCKS AND
C*          WRITE THE STATEMENT IN FINAL FORM
C*
C*     COMMON BLOCKS :
C*          FILES, STATMT, OPTIONS, LABELS, STUB, OUT, IDAT
C*
C*     INPUT ARGUMENTS :
C*          FORM - IS THIS AN UNUSED FORMAT ?
C*
C*     FILE REFERENCES :
C*          NOUT, NWARN
C*
C*     SUBPROGRAM REFERENCES :
C*          REFNUM
C*
C*     ERROR PROCESSING :
C*          WARNINGS PRODUCED FOR STATEMENTS WITH MORE THAN
C*          19 CONTINUATIONS
C*
C*     ASSUMPTIONS AND RESTRICTIONS :
C*          MAXIMUM NEST LEVEL - 32
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     22-JAN-87 
C*
C*     CHANGE HISTORY :
C*          22-JAN-87    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXNEST=32,MXLBL=300,NSPCHR=8,MXCRD=65,MXSTLN=1520,
     $          MXCALLS=400,MXCOMS=100,MXFIL=10,MXARG=50,MXNAME=20,
     $          MXINC=10,MXAUTH=10)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / STATMT / STMT, CARD, EOF, CONT, CLABEL, ITYPE, LENST,
     $                  LOGIF, ISTART, TCARD, NTCRD
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / LABELS / LABDEF(MXLBL), NDEF, LABREF(MXLBL), NREF,
     $                  LABDOS(MXLBL), NDOS, LABFMT(MXLBL), NFLAB,
     $                  LABCNT(MXLBL), NCLAB, FUSED(MXLBL), 
     $                  CUSED(MXLBL), EXCEED, TOLD
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      COMMON / OUT / SEQ, SPCHR, NASC1, NASC2
      COMMON / IDAT / NDO, NIF
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      CHARACTER *(MXSTLN) STMT
      CHARACTER *80 CARD, TCARD(MXINC)
      CHARACTER *66 OUTCRD                  
      CHARACTER *40 AUTHOR
      CHARACTER *5 CLABEL, CTEMP
      CHARACTER *1 CONCHR, SPCHR(NSPCHR), CC, CMTCHR, LAST
      LOGICAL ADD, ALIGN, ARG, COMM, INDENT, MOVE, PROLOG, RENUM, 
     $        STRUC, WARN, EOF, CONT, LOGIF, NEWDO, NEWIF, ELSEBL, SEQ, 
     $        NOREF, NO, FUSED, CUSED, EXCEED, FORM, CNASGN, TOMANY, 
     $        TOLD, EXEM, POINT
      DATA SPCHR / '=', ',', '/', ')', '+', '-', '*', ' ' /
      DATA NASC1, NASC2 /48,55/
C
      NBLNKS = 0
      CNASGN = .FALSE.
      IF (INDENT .AND. (ITYPE .NE. 16)) THEN
         NOREF  = .TRUE.
         NEWDO  = .FALSE.
         NEWIF  = .FALSE.
         ELSEBL = .FALSE.
C
C --- CHECK FOR END OF DO-LOOP
C
         IF ((NDO .GT. 0).AND.(CLABEL .NE. ' ').AND.(ITYPE.NE.16)) THEN
             READ(CLABEL,900) ILABEL
             DO 10 I = 1,NDOS
                IF (ILABEL .EQ. LABDOS(I)) THEN
                   NDO = NDO - 1
                ENDIF
10           CONTINUE
         ENDIF
         IF (ITYPE .EQ. 46) THEN
C
C --- NEW DO LOOP
C
            NEWDO = .TRUE.
C
C --- GET DO LABEL
C
            CALL REFNUM (4,ILAB,NO,LAST,LL,NOREF)
            NDOS = NDOS + 1
            LABDOS(NDOS) = ILAB
         ELSE IF ((ITYPE .EQ. 10).OR.(ITYPE .EQ. 11)) THEN
C
C --- ELSE OR ELSE-IF
C
           ELSEBL = .TRUE.
         ELSE IF (ITYPE .EQ. 12) THEN
C
C --- END IF
C
            NIF = NIF -1
         ELSE IF (ITYPE .EQ. 47) THEN
C
C --- NEW IF BLOCK
C
            NEWIF = .TRUE.
         ENDIF
         IDEPTH = NDO + NIF
         IF (IDEPTH .GT. MXNEST) THEN
            IDEPTH = MXNEST
            WRITE (NWARN,960) SUBNAM
         ENDIF
         IF (ELSEBL) IDEPTH = IDEPTH - 1
         NBLNKS = IDEPTH * NIND
         IF (ITYPE .EQ. 16) NBLNKS = 0
      ENDIF
C
C --- REFORMAT THE STATEMENT AND WRITE IT OUT
C --- FORMAT STATEMENTS ARE NOT INDENTED
C
      IST   = 1
      L     = LENST
      CTEMP = CLABEL
      ISEQ  = 0
      CC    = ' '
C
C --- IF THIS IS AN ASSIGNMENT STATEMENT, CHECK IF IT NEEDS TO
C --- BE CONTINUED 
C
      IF ((ITYPE .EQ. 49).AND.(L .GT. MXCRD-NBLNKS).AND.
     $    (.NOT.LOGIF)) NADD = INDEX(STMT,'=') + 2
C
C --- GET NUMBER OF SPACES TO ADD TO CONTINUED PORTION(S)
C
30    IF (L .GT. MXCRD-NBLNKS) THEN
         IF ( (ITYPE .EQ. 49) .AND. (CC .NE. ' ') 
     $         .AND. (.NOT.LOGIF) ) THEN
               IF (.NOT. CNASGN) THEN
                   CNASGN = .TRUE.
                   NBLNKS = NBLNKS + NADD
               ENDIF
          ENDIF
C
C --- BREAK STATEMENT ONLY AFTER OPERATOR OR DELIMITER
C
         NBR = MXCRD-NBLNKS + IST
40       NBR = NBR - 1
         DO 50 I = 1, NSPCHR
            IF (STMT(NBR:NBR) .EQ. SPCHR(I)) GO TO 60
50       CONTINUE
         GO TO 40
60       OUTCRD = ' '
         ICPTR = 1 + NBLNKS
         OUTCRD(ICPTR:MXCRD) = STMT(IST:NBR)
         LLL = NBR - IST + ICPTR
         IF (CC .EQ. ' ') THEN
            IF (FORM) THEN
                WRITE(NOUT,940) CMTCHR,CTEMP,CC,OUTCRD(1:LLL)
            ELSE
                WRITE(NOUT,910) CTEMP,CC,OUTCRD(1:LLL)
            ENDIF
         ELSE IF (FORM) THEN
            WRITE (NOUT,950) CMTCHR, CTEMP, CC, SPCHR(8), OUTCRD(1:LLL)
         ELSE IF ((NBLNKS .EQ. 0) .AND. (INDEX(STMT,'''') .EQ. 0)) THEN
            WRITE (NOUT,930) CTEMP, CC, SPCHR(8), OUTCRD(1:LLL)
         ELSE
            WRITE (NOUT,910) CTEMP, CC, OUTCRD(1:LLL)
         ENDIF
         ISEQ = ISEQ + 1
C
C --- CHECK FOR MORE THAN 19 CONTINUATIONS
C
         IF ((ISEQ .GT. 19) .AND. (WARN)) WRITE(NWARN,920) SUBNAM
C
C --- IF INCREASING SEQUENCE, GET NEXT CONTINUATION CHARACTER
C
         IF (SEQ) THEN
            IF (ISEQ .GT. 35) ISEQ = 1
            IF (ISEQ .GT. 9) THEN
               CC = CHAR (ISEQ + NASC2)
            ELSE
               CC = CHAR (ISEQ + NASC1)
            ENDIF
         ELSE
            IF (CC .EQ. ' ') CC = CONCHR
         ENDIF
         CTEMP = '    '
         L = L - (NBR - IST) - 1
         IST = NBR + 1
         GO TO 30
      ENDIF
      IF (L .GT. 0) THEN
         OUTCRD = ' '
         IF ((CC .NE. ' ').AND.(ITYPE .EQ. 49).AND.(.NOT.LOGIF)) THEN
            IF (.NOT. CNASGN) THEN
               CNASGN = .TRUE.
               NBLNKS = NBLNKS + NADD
               IF (L + NBLNKS .GT. MXCRD) GO TO 30
            ENDIF
         ENDIF
         ICPTR = NBLNKS + 1
         OUTCRD(ICPTR:MXCRD) = STMT(IST:LENST)
         LLL = LENST - IST + ICPTR
         IF (CC .EQ. ' ') THEN
             IF (FORM) THEN
                 WRITE(NOUT,940) CMTCHR,CTEMP,CC,OUTCRD(1:LLL)
             ELSE
                 WRITE(NOUT,910) CTEMP,CC,OUTCRD(1:LLL)
             ENDIF
         ELSE IF (FORM) THEN
             WRITE (NOUT,950) CMTCHR, CTEMP, CC, SPCHR(8), OUTCRD(1:LLL)
         ELSE IF ((NBLNKS .EQ. 0) .AND. (INDEX(STMT,'''') .EQ. 0)) THEN
             WRITE (NOUT,930) CTEMP, CC, SPCHR(8), OUTCRD(1:LLL)
         ELSE
             WRITE(NOUT,910) CTEMP,CC,OUTCRD(1:LLL)
         ENDIF
      ENDIF
C
C --- SET VARIABLES FOR NEXT STATEMENT
C
      IF (NEWDO) NDO = NDO + 1
      IF (NEWIF) NIF = NIF + 1
      RETURN  
900   FORMAT(I5)
910   FORMAT(A5,A1,A)
920   FORMAT(' ********** WARNING -- ',/,
     $ 12X,'More than 19 continuations is not standard FORTRAN',/,
     $ 12X,'in subprogram ',A)    
930   FORMAT(A5,A1,A1,A) 
940   FORMAT(A1,A5,A1,A)
950   FORMAT(A1,A5,A1,A1,A)
960   FORMAT(' ********** WARNING -- ',/,
     $ 12X,'Too many nested DO loops or IF blocks in subprogram ',A)
      END
C
C---END STOUT
C
      SUBROUTINE RESET 
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          RESET            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          RESET PARAMETERS
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS 219-1                                
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415) 604-5578                          
C*
C*     PURPOSE :
C*          RESET FLAGS, COUNTERS; REWIND FILES FOR PROCESSING OF       
C*          NEXT SUBPROGRAM                                             
C*
C*     COMMON BLOCKS :
C*          FILES, OPTIONS, STUB, LABELS, IDAT
C*
C*     FILE REFERENCES :
C*          NTEMP, NFORM
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0      8-DEC-86 
C*
C*     CHANGE HISTORY :
C*           8-DEC-86    INITIAL VERSION
C*
C***********************************************************************
C*
      PARAMETER(MXCALLS=400,MXCOMS=100,MXFIL=10,MXARG=50,MXNAME=20,
     $          MXLBL=300,MXNEST=32,MXAUTH=10)
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      COMMON / OPTIONS / ADD, ALIGN, ARG, CONCHR, INDENT, MOVE, EXEM,
     $                   PROLOG, RENUM, STRUC, WARN, MIN, INC, NIND,
     $                   COMM, CMTCHR, NCOL, POINT, LDLINES
      COMMON / STUB / SUBNAM, CALNAM(MXCALLS), NCALLS, COMNAM(MXCOMS), 
     $                NCOMS, FILREF(MXFIL), NFREF, ARGNAM(MXARG), NARGS,
     $                NLINES, AUTHOR(MXAUTH), TOMANY
      COMMON / LABELS / LABDEF(MXLBL), NDEF, LABREF(MXLBL), NREF,
     $                  LABDOS(MXLBL), NDOS, LABFMT(MXLBL), NFLAB,
     $                  LABCNT(MXLBL), NCLAB, FUSED(MXLBL), 
     $                  CUSED(MXLBL), EXCEED, TOLD
      COMMON / IDAT / NDO, NIF
      CHARACTER *(MXNAME) SUBNAM, CALNAM, COMNAM, FILREF, ARGNAM
      CHARACTER *40 AUTHOR
      CHARACTER *1 CONCHR, CMTCHR
      LOGICAL ADD, ALIGN, ARG, COMM, INDENT, MOVE, PROLOG, RENUM, 
     $        STRUC, WARN, FUSED, CUSED, TOMANY, TOLD, EXEM, POINT,
     $        EXCEED
C                                           
      DO 10 I = 1,NCLAB
         CUSED(I) = .FALSE.
10    CONTINUE
      DO 20 I = 1,NFLAB
         FUSED(I) = .FALSE.
20    CONTINUE
      EXCEED = .FALSE.
      TOMANY = .FALSE.
      TOLD   = .FALSE.
      NDOS   = 0
      NFLAB  = 0
      NCLAB  = 0
      NDEF   = 0
      NREF   = 0
      NCALLS = 0
      NCOMS  = 0
      NFREF  = 0
      NARGS  = 0
      NFMTS  = 0
      NDO    = 0
      NIF    = 0
      SUBNAM = '$MAIN'
      REWIND(NTEMP)
      IF (MOVE) REWIND(NFORM)
      RETURN
      END
C
C---END RESET 
C
      SUBROUTINE ENDUP (STAT)
C*
C*                  *******************************
C*                  *******************************
C*                  **                           **
C*                  **          ENDUP            **
C*                  **                           **
C*                  *******************************
C*                  *******************************
C*
C*     SUBPROGRAM :
C*          END UP                                  
C*
C*     AUTHOR :
C*          LAURA JURGELEIT                         
C*          MS219-1                                 
C*          NASA/Ames Research Center               
C*          Moffett Field, CA  94035                
C*          (415)604-5578                           
C*
C*     PURPOSE :
C*          DO END OF PROGRAM PROCESSING                                
C*
C*     INPUT ARGUMENTS :
C*          STAT - DID JOB END NORMALLY ?
C*
C*     COMMON BLOCKS :
C*          FILES
C*
C*     FILE REFERENCES :
C*          NWARN
C*
C*     SUBPROGRAM REFERENCES :
C*          LIB$SET_SYMBOL
C*
C*     TRANSPORTABILITY LIMITATIONS :
C*          SYSTEM SPECIFIC RTL ROUTINE LIB$SET_SYMBOL
C*
C*     LANGUAGE AND COMPILER :
C*          ANSI FORTRAN 77
C*
C*     VERSION AND DATE :
C*          VERSION I.0     13-NOV-86 
C*
C*     CHANGE HISTORY :
C*          13-NOV-86    INITIAL VERSION
C*
C***********************************************************************
C*
      COMMON / FILES / NOPT, NIN, NOUT, NTEMP, NFORM, NWARN, NFMTS, 
     $                 NAUTH
      LOGICAL STAT
C
      IF (STAT) THEN
         WRITE(NWARN,900)
      ELSE
         WRITE(NWARN,910) 
         CALL LIB$SET_SYMBOL('CODE','1')
      ENDIF
      STOP           
900   FORMAT(/20X,'--------- JOB ENDED WITH END OF FILE --------- ')
910   FORMAT(/20X,'********* JOB DID NOT FINISH NORMALLY *********')
      END
C
C --- END ENDUP
C
